import base64, json, os
from datetime import datetime
import command_v11_client as keyfactor
import command_v11_client.api.reports.put_reports_id_schedules as kf_put_reports_id_schedules
import command_v11_client.api.reports.delete_reports_custom_id as kf_delete_reports_custom_id
import command_v11_client.api.reports.post_reports_id_schedules as kf_post_reports_id_schedules
import command_v11_client.api.reports.post_reports_custom as kf_post_reports_custom
import command_v11_client.api.reports.put_reports as kf_put_reports
import command_v11_client.api.reports.get_reports_id as kf_get_reports_id
import command_v11_client.api.reports.get_reports_id_schedules as kf_get_reports_id_schedules
import command_v11_client.api.reports.get_reports_custom_id as kf_get_reports_custom_id
import command_v11_client.api.reports.put_reports_custom as kf_put_reports_custom
import command_v11_client.api.reports.put_reports_id_parameters as kf_put_reports_id_parameters
import command_v11_client.api.reports.get_reports_custom as kf_get_reports_custom
import command_v11_client.api.reports.get_reports as kf_get_reports
import command_v11_client.api.reports.get_reports_schedules_id as kf_get_reports_schedules_id
import command_v11_client.api.reports.delete_reports_schedules_id as kf_delete_reports_schedules_id
import command_v11_client.api.reports.get_reports_id_parameters as kf_get_reports_id_parameters
import command_v11_client.api.server_group.post_ssh_server_groups as kf_post_ssh_server_groups
import command_v11_client.api.server_group.put_ssh_server_groups as kf_put_ssh_server_groups
import command_v11_client.api.server_group.get_ssh_server_groups as kf_get_ssh_server_groups
import command_v11_client.api.server_group.delete_ssh_server_groups_id as kf_delete_ssh_server_groups_id
import command_v11_client.api.server_group.get_ssh_server_groups_access_id as kf_get_ssh_server_groups_access_id
import command_v11_client.api.server_group.post_ssh_server_groups_access as kf_post_ssh_server_groups_access
import command_v11_client.api.server_group.delete_ssh_server_groups_access as kf_delete_ssh_server_groups_access
import command_v11_client.api.server_group.get_ssh_server_groups_id as kf_get_ssh_server_groups_id
import command_v11_client.api.server_group.get_ssh_server_groups_name as kf_get_ssh_server_groups_name
import command_v11_client.api.enrollment.post_enrollment_renew as kf_post_enrollment_renew
import command_v11_client.api.enrollment.post_enrollment_csr_parse as kf_post_enrollment_csr_parse
import command_v11_client.api.enrollment.post_enrollment_pfx_deploy as kf_post_enrollment_pfx_deploy
import command_v11_client.api.enrollment.post_enrollment_pfx_replace as kf_post_enrollment_pfx_replace
import command_v11_client.api.enrollment.post_enrollment_csr as kf_post_enrollment_csr
import command_v11_client.api.enrollment.get_enrollment_settings_id as kf_get_enrollment_settings_id
import command_v11_client.api.enrollment.get_enrollment_csr_context_my as kf_get_enrollment_csr_context_my
import command_v11_client.api.enrollment.get_enrollment_available_renewal_thumbprint_thumbprint as kf_get_enrollment_available_renewal_thumbprint_thumbprint
import command_v11_client.api.enrollment.get_enrollment_available_renewal_id_id as kf_get_enrollment_available_renewal_id_id
import command_v11_client.api.enrollment.post_enrollment_pfx as kf_post_enrollment_pfx
import command_v11_client.api.enrollment.get_enrollment_pfx_context_my as kf_get_enrollment_pfx_context_my
import command_v11_client.api.certificate_store_container.put_certificate_store_containers as kf_put_certificate_store_containers
import command_v11_client.api.certificate_store_container.get_certificate_store_containers as kf_get_certificate_store_containers
import command_v11_client.api.certificate_store_container.get_certificate_store_containers_id as kf_get_certificate_store_containers_id
import command_v11_client.api.certificate_store_container.delete_certificate_store_containers_id as kf_delete_certificate_store_containers_id
import command_v11_client.api.certificate_store_container.post_certificate_store_containers as kf_post_certificate_store_containers
import command_v11_client.api.custom_job_type.post_job_types_custom as kf_post_job_types_custom
import command_v11_client.api.custom_job_type.get_job_types_custom as kf_get_job_types_custom
import command_v11_client.api.custom_job_type.put_job_types_custom as kf_put_job_types_custom
import command_v11_client.api.custom_job_type.get_job_types_custom_id as kf_get_job_types_custom_id
import command_v11_client.api.custom_job_type.delete_job_types_custom_id as kf_delete_job_types_custom_id
import command_v11_client.api.service_account.delete_ssh_service_accounts as kf_delete_ssh_service_accounts
import command_v11_client.api.service_account.get_ssh_service_accounts as kf_get_ssh_service_accounts
import command_v11_client.api.service_account.put_ssh_service_accounts as kf_put_ssh_service_accounts
import command_v11_client.api.service_account.post_ssh_service_accounts as kf_post_ssh_service_accounts
import command_v11_client.api.service_account.post_ssh_service_accounts_rotate_id as kf_post_ssh_service_accounts_rotate_id
import command_v11_client.api.service_account.delete_ssh_service_accounts_id as kf_delete_ssh_service_accounts_id
import command_v11_client.api.service_account.get_ssh_service_accounts_id as kf_get_ssh_service_accounts_id
import command_v11_client.api.service_account.get_ssh_service_accounts_key_id as kf_get_ssh_service_accounts_key_id
import command_v11_client.api.event_handler_registration.get_event_handler_registration_id as kf_get_event_handler_registration_id
import command_v11_client.api.event_handler_registration.put_event_handler_registration_id as kf_put_event_handler_registration_id
import command_v11_client.api.event_handler_registration.post_event_handler_registration as kf_post_event_handler_registration
import command_v11_client.api.event_handler_registration.get_event_handler_registration as kf_get_event_handler_registration
import command_v11_client.api.event_handler_registration.delete_event_handler_registration_id as kf_delete_event_handler_registration_id
import command_v11_client.api.scheduling.post_scheduling as kf_post_scheduling
import command_v11_client.api.app_setting.get_app_setting_id as kf_get_app_setting_id
import command_v11_client.api.app_setting.put_app_setting_id_set as kf_put_app_setting_id_set
import command_v11_client.api.app_setting.put_app_setting_name_set as kf_put_app_setting_name_set
import command_v11_client.api.app_setting.get_app_setting as kf_get_app_setting
import command_v11_client.api.app_setting.put_app_setting as kf_put_app_setting
import command_v11_client.api.server.delete_ssh_servers_access as kf_delete_ssh_servers_access
import command_v11_client.api.server.get_ssh_servers as kf_get_ssh_servers
import command_v11_client.api.server.delete_ssh_servers_id as kf_delete_ssh_servers_id
import command_v11_client.api.server.get_ssh_servers_id as kf_get_ssh_servers_id
import command_v11_client.api.server.post_ssh_servers_access as kf_post_ssh_servers_access
import command_v11_client.api.server.put_ssh_servers as kf_put_ssh_servers
import command_v11_client.api.server.post_ssh_servers as kf_post_ssh_servers
import command_v11_client.api.server.get_ssh_servers_access_id as kf_get_ssh_servers_access_id
import command_v11_client.api.template.post_templates_import as kf_post_templates_import
import command_v11_client.api.template.get_templates_id as kf_get_templates_id
import command_v11_client.api.template.get_templates_subject_parts as kf_get_templates_subject_parts
import command_v11_client.api.template.get_templates as kf_get_templates
import command_v11_client.api.template.get_templates_settings as kf_get_templates_settings
import command_v11_client.api.template.put_templates as kf_put_templates
import command_v11_client.api.template.put_templates_settings as kf_put_templates_settings
import command_v11_client.api.monitoring.post_monitoring_resolve_ocsp as kf_post_monitoring_resolve_ocsp
import command_v11_client.api.monitoring.post_monitoring_revocation_test as kf_post_monitoring_revocation_test
import command_v11_client.api.monitoring.get_monitoring_revocation_id as kf_get_monitoring_revocation_id
import command_v11_client.api.monitoring.delete_monitoring_revocation_id as kf_delete_monitoring_revocation_id
import command_v11_client.api.monitoring.post_monitoring_revocation as kf_post_monitoring_revocation
import command_v11_client.api.monitoring.put_monitoring_revocation as kf_put_monitoring_revocation
import command_v11_client.api.monitoring.get_monitoring_revocation as kf_get_monitoring_revocation
import command_v11_client.api.monitoring.post_monitoring_revocation_test_all as kf_post_monitoring_revocation_test_all
import command_v11_client.api.user.post_ssh_users as kf_post_ssh_users
import command_v11_client.api.user.put_ssh_users as kf_put_ssh_users
import command_v11_client.api.user.get_ssh_users_id as kf_get_ssh_users_id
import command_v11_client.api.user.get_ssh_users as kf_get_ssh_users
import command_v11_client.api.user.post_ssh_users_access as kf_post_ssh_users_access
import command_v11_client.api.user.delete_ssh_users_id as kf_delete_ssh_users_id
import command_v11_client.api.ssl.put_ssl_endpoints_monitor_status as kf_put_ssl_endpoints_monitor_status
import command_v11_client.api.ssl.delete_ssl_network_ranges_id as kf_delete_ssl_network_ranges_id
import command_v11_client.api.ssl.get_ssl_networks as kf_get_ssl_networks
import command_v11_client.api.ssl.put_ssl_endpoints_review_all as kf_put_ssl_endpoints_review_all
import command_v11_client.api.ssl.delete_ssl_networks_id as kf_delete_ssl_networks_id
import command_v11_client.api.ssl.get_ssl_parts_id as kf_get_ssl_parts_id
import command_v11_client.api.ssl.put_ssl_networks as kf_put_ssl_networks
import command_v11_client.api.ssl.get_ssl_endpoints_id as kf_get_ssl_endpoints_id
import command_v11_client.api.ssl.get_ssl_network_ranges_id as kf_get_ssl_network_ranges_id
import command_v11_client.api.ssl.post_ssl_networks as kf_post_ssl_networks
import command_v11_client.api.ssl.post_ssl_networks_id_reset as kf_post_ssl_networks_id_reset
import command_v11_client.api.ssl.get_ssl as kf_get_ssl
import command_v11_client.api.ssl.post_ssl_networks_id_scan as kf_post_ssl_networks_id_scan
import command_v11_client.api.ssl.put_ssl_endpoints_review_status as kf_put_ssl_endpoints_review_status
import command_v11_client.api.ssl.put_ssl_endpoints_monitor_all as kf_put_ssl_endpoints_monitor_all
import command_v11_client.api.ssl.get_ssl_endpoints_id_history as kf_get_ssl_endpoints_id_history
import command_v11_client.api.ssl.post_ssl_network_ranges_validate as kf_post_ssl_network_ranges_validate
import command_v11_client.api.ssl.post_ssl_network_ranges as kf_post_ssl_network_ranges
import command_v11_client.api.ssl.put_ssl_network_ranges as kf_put_ssl_network_ranges
import command_v11_client.api.ssl.get_ssl_networks_id_parts as kf_get_ssl_networks_id_parts
import command_v11_client.api.ssl.get_ssl_networks_identifier as kf_get_ssl_networks_identifier
import command_v11_client.api.certificate.get_certificates as kf_get_certificates
import command_v11_client.api.certificate.post_certificates_import as kf_post_certificates_import
import command_v11_client.api.certificate.get_certificates_id_security as kf_get_certificates_id_security
import command_v11_client.api.certificate.post_certificates_recover as kf_post_certificates_recover
import command_v11_client.api.certificate.delete_certificates as kf_delete_certificates
import command_v11_client.api.certificate.get_certificates_id as kf_get_certificates_id
import command_v11_client.api.certificate.put_certificates_metadata_all as kf_put_certificates_metadata_all
import command_v11_client.api.certificate.get_certificates_id_validate as kf_get_certificates_id_validate
import command_v11_client.api.certificate.delete_certificates_private_key_id as kf_delete_certificates_private_key_id
import command_v11_client.api.certificate.delete_certificates_id as kf_delete_certificates_id
import command_v11_client.api.certificate.get_certificates_identity_audit_id as kf_get_certificates_identity_audit_id
import command_v11_client.api.certificate.delete_certificates_query as kf_delete_certificates_query
import command_v11_client.api.certificate.post_certificates_revoke as kf_post_certificates_revoke
import command_v11_client.api.certificate.delete_certificates_private_key as kf_delete_certificates_private_key
import command_v11_client.api.certificate.post_certificates_analyze as kf_post_certificates_analyze
import command_v11_client.api.certificate.get_certificates_locations_id as kf_get_certificates_locations_id
import command_v11_client.api.certificate.post_certificates_download as kf_post_certificates_download
import command_v11_client.api.certificate.get_certificates_csv as kf_get_certificates_csv
import command_v11_client.api.certificate.put_certificates_metadata as kf_put_certificates_metadata
import command_v11_client.api.certificate.get_certificates_metadata_compare as kf_get_certificates_metadata_compare
import command_v11_client.api.certificate.get_certificates_id_history as kf_get_certificates_id_history
import command_v11_client.api.workflow.post_workflow_certificates_deny as kf_post_workflow_certificates_deny
import command_v11_client.api.workflow.get_workflow_certificates_pending as kf_get_workflow_certificates_pending
import command_v11_client.api.workflow.get_workflow_certificates_external_validation as kf_get_workflow_certificates_external_validation
import command_v11_client.api.workflow.get_workflow_certificates_denied as kf_get_workflow_certificates_denied
import command_v11_client.api.workflow.post_workflow_certificates_approve as kf_post_workflow_certificates_approve
import command_v11_client.api.workflow.get_workflow_certificates_id as kf_get_workflow_certificates_id
import command_v11_client.api.component_installation.get_component_installation as kf_get_component_installation
import command_v11_client.api.component_installation.delete_component_installation_id as kf_delete_component_installation_id
import command_v11_client.api.security_claims.get_security_claims as kf_get_security_claims
import command_v11_client.api.security_claims.post_security_claims as kf_post_security_claims
import command_v11_client.api.security_claims.delete_security_claims_id as kf_delete_security_claims_id
import command_v11_client.api.security_claims.get_security_claims_roles as kf_get_security_claims_roles
import command_v11_client.api.security_claims.put_security_claims as kf_put_security_claims
import command_v11_client.api.security_claims.get_security_claims_id as kf_get_security_claims_id
import command_v11_client.api.permission_set.delete_permission_sets_id as kf_delete_permission_sets_id
import command_v11_client.api.permission_set.put_permission_sets as kf_put_permission_sets
import command_v11_client.api.permission_set.get_permission_sets as kf_get_permission_sets
import command_v11_client.api.permission_set.get_permission_sets_id as kf_get_permission_sets_id
import command_v11_client.api.permission_set.post_permission_sets as kf_post_permission_sets
import command_v11_client.api.orchestrator_job.post_orchestrator_jobs_custom as kf_post_orchestrator_jobs_custom
import command_v11_client.api.orchestrator_job.post_orchestrator_jobs_acknowledge as kf_post_orchestrator_jobs_acknowledge
import command_v11_client.api.orchestrator_job.get_orchestrator_jobs_job_status_data as kf_get_orchestrator_jobs_job_status_data
import command_v11_client.api.orchestrator_job.get_orchestrator_jobs_scheduled_jobs as kf_get_orchestrator_jobs_scheduled_jobs
import command_v11_client.api.orchestrator_job.post_orchestrator_jobs_custom_bulk as kf_post_orchestrator_jobs_custom_bulk
import command_v11_client.api.orchestrator_job.get_orchestrator_jobs_job_history as kf_get_orchestrator_jobs_job_history
import command_v11_client.api.orchestrator_job.post_orchestrator_jobs_reschedule as kf_post_orchestrator_jobs_reschedule
import command_v11_client.api.orchestrator_job.post_orchestrator_jobs_unschedule as kf_post_orchestrator_jobs_unschedule
import command_v11_client.api.logon.post_ssh_logons_access as kf_post_ssh_logons_access
import command_v11_client.api.logon.post_ssh_logons as kf_post_ssh_logons
import command_v11_client.api.logon.get_ssh_logons_id as kf_get_ssh_logons_id
import command_v11_client.api.logon.delete_ssh_logons_id as kf_delete_ssh_logons_id
import command_v11_client.api.logon.get_ssh_logons as kf_get_ssh_logons
import command_v11_client.api.pending_alert.put_alerts_pending_schedule as kf_put_alerts_pending_schedule
import command_v11_client.api.pending_alert.post_alerts_pending_test_all as kf_post_alerts_pending_test_all
import command_v11_client.api.pending_alert.get_alerts_pending as kf_get_alerts_pending
import command_v11_client.api.pending_alert.get_alerts_pending_id as kf_get_alerts_pending_id
import command_v11_client.api.pending_alert.post_alerts_pending as kf_post_alerts_pending
import command_v11_client.api.pending_alert.put_alerts_pending as kf_put_alerts_pending
import command_v11_client.api.pending_alert.delete_alerts_pending_id as kf_delete_alerts_pending_id
import command_v11_client.api.pending_alert.get_alerts_pending_schedule as kf_get_alerts_pending_schedule
import command_v11_client.api.pending_alert.post_alerts_pending_test as kf_post_alerts_pending_test
import command_v11_client.api.agent_pool.post_agent_pools as kf_post_agent_pools
import command_v11_client.api.agent_pool.get_agent_pools as kf_get_agent_pools
import command_v11_client.api.agent_pool.get_agent_pools_id as kf_get_agent_pools_id
import command_v11_client.api.agent_pool.delete_agent_pools_id as kf_delete_agent_pools_id
import command_v11_client.api.agent_pool.get_agent_pools_agents as kf_get_agent_pools_agents
import command_v11_client.api.agent_pool.put_agent_pools as kf_put_agent_pools
import command_v11_client.api.mac_enrollment.get_mac_enrollment as kf_get_mac_enrollment
import command_v11_client.api.mac_enrollment.put_mac_enrollment as kf_put_mac_enrollment
import command_v11_client.api.issued_alert.get_alerts_issued_schedule as kf_get_alerts_issued_schedule
import command_v11_client.api.issued_alert.put_alerts_issued as kf_put_alerts_issued
import command_v11_client.api.issued_alert.delete_alerts_issued_id as kf_delete_alerts_issued_id
import command_v11_client.api.issued_alert.get_alerts_issued_id as kf_get_alerts_issued_id
import command_v11_client.api.issued_alert.put_alerts_issued_schedule as kf_put_alerts_issued_schedule
import command_v11_client.api.issued_alert.get_alerts_issued as kf_get_alerts_issued
import command_v11_client.api.issued_alert.post_alerts_issued as kf_post_alerts_issued
import command_v11_client.api.agent_blueprint.get_agent_blue_print_id_stores as kf_get_agent_blue_print_id_stores
import command_v11_client.api.agent_blueprint.get_agent_blue_print_id as kf_get_agent_blue_print_id
import command_v11_client.api.agent_blueprint.delete_agent_blue_print_id as kf_delete_agent_blue_print_id
import command_v11_client.api.agent_blueprint.post_agent_blue_print_apply_blueprint as kf_post_agent_blue_print_apply_blueprint
import command_v11_client.api.agent_blueprint.get_agent_blue_print as kf_get_agent_blue_print
import command_v11_client.api.agent_blueprint.get_agent_blue_print_id_jobs as kf_get_agent_blue_print_id_jobs
import command_v11_client.api.agent_blueprint.post_agent_blue_print_generate_blue_print as kf_post_agent_blue_print_generate_blue_print
import command_v11_client.api.certificate_collection.get_certificate_collections_nav_items as kf_get_certificate_collections_nav_items
import command_v11_client.api.certificate_collection.put_certificate_collections as kf_put_certificate_collections
import command_v11_client.api.certificate_collection.put_certificate_collections_id_favorite as kf_put_certificate_collections_id_favorite
import command_v11_client.api.certificate_collection.get_certificate_collections_collection_list as kf_get_certificate_collections_collection_list
import command_v11_client.api.certificate_collection.get_certificate_collections_name as kf_get_certificate_collections_name
import command_v11_client.api.certificate_collection.delete_certificate_collections_id as kf_delete_certificate_collections_id
import command_v11_client.api.certificate_collection.post_certificate_collections as kf_post_certificate_collections
import command_v11_client.api.certificate_collection.get_certificate_collections as kf_get_certificate_collections
import command_v11_client.api.certificate_collection.post_certificate_collections_copy as kf_post_certificate_collections_copy
import command_v11_client.api.certificate_collection.get_certificate_collections_id as kf_get_certificate_collections_id
import command_v11_client.api.certificate_store_type.get_certificate_store_types as kf_get_certificate_store_types
import command_v11_client.api.certificate_store_type.get_certificate_store_types_name_name as kf_get_certificate_store_types_name_name
import command_v11_client.api.certificate_store_type.put_certificate_store_types as kf_put_certificate_store_types
import command_v11_client.api.certificate_store_type.post_certificate_store_types as kf_post_certificate_store_types
import command_v11_client.api.certificate_store_type.delete_certificate_store_types as kf_delete_certificate_store_types
import command_v11_client.api.certificate_store_type.delete_certificate_store_types_id as kf_delete_certificate_store_types_id
import command_v11_client.api.certificate_store_type.get_certificate_store_types_id as kf_get_certificate_store_types_id
import command_v11_client.api.smtp.put_smtp as kf_put_smtp
import command_v11_client.api.smtp.get_smtp as kf_get_smtp
import command_v11_client.api.smtp.post_smtp_test as kf_post_smtp_test
import command_v11_client.api.denied_alert.get_alerts_denied_id as kf_get_alerts_denied_id
import command_v11_client.api.denied_alert.get_alerts_denied as kf_get_alerts_denied
import command_v11_client.api.denied_alert.post_alerts_denied as kf_post_alerts_denied
import command_v11_client.api.denied_alert.delete_alerts_denied_id as kf_delete_alerts_denied_id
import command_v11_client.api.denied_alert.put_alerts_denied as kf_put_alerts_denied
import command_v11_client.api.key_rotation_alert.put_alerts_key_rotation_schedule as kf_put_alerts_key_rotation_schedule
import command_v11_client.api.key_rotation_alert.delete_alerts_key_rotation_id as kf_delete_alerts_key_rotation_id
import command_v11_client.api.key_rotation_alert.get_alerts_key_rotation_schedule as kf_get_alerts_key_rotation_schedule
import command_v11_client.api.key_rotation_alert.post_alerts_key_rotation_test_all as kf_post_alerts_key_rotation_test_all
import command_v11_client.api.key_rotation_alert.get_alerts_key_rotation_id as kf_get_alerts_key_rotation_id
import command_v11_client.api.key_rotation_alert.get_alerts_key_rotation as kf_get_alerts_key_rotation
import command_v11_client.api.key_rotation_alert.post_alerts_key_rotation_test as kf_post_alerts_key_rotation_test
import command_v11_client.api.key_rotation_alert.put_alerts_key_rotation as kf_put_alerts_key_rotation
import command_v11_client.api.key_rotation_alert.post_alerts_key_rotation as kf_post_alerts_key_rotation
import command_v11_client.api.security_role_permissions.get_security_roles_id_permissions_collections as kf_get_security_roles_id_permissions_collections
import command_v11_client.api.security_role_permissions.get_security_roles_id_permissions_containers as kf_get_security_roles_id_permissions_containers
import command_v11_client.api.security_role_permissions.put_security_roles_id_permissions_pam_providers as kf_put_security_roles_id_permissions_pam_providers
import command_v11_client.api.security_role_permissions.post_security_roles_id_permissions_collections as kf_post_security_roles_id_permissions_collections
import command_v11_client.api.security_role_permissions.post_security_roles_id_permissions_global as kf_post_security_roles_id_permissions_global
import command_v11_client.api.security_role_permissions.post_security_roles_id_permissions_containers as kf_post_security_roles_id_permissions_containers
import command_v11_client.api.security_role_permissions.put_security_roles_id_permissions_global as kf_put_security_roles_id_permissions_global
import command_v11_client.api.security_role_permissions.get_security_roles_id_permissions_global as kf_get_security_roles_id_permissions_global
import command_v11_client.api.security_role_permissions.put_security_roles_id_permissions_containers as kf_put_security_roles_id_permissions_containers
import command_v11_client.api.security_role_permissions.put_security_roles_id_permissions_collections as kf_put_security_roles_id_permissions_collections
import command_v11_client.api.security_role_permissions.get_security_roles_id_permissions as kf_get_security_roles_id_permissions
import command_v11_client.api.security_role_permissions.get_security_roles_id_permissions_pam_providers as kf_get_security_roles_id_permissions_pam_providers
import command_v11_client.api.extensions.put_extensions_scripts as kf_put_extensions_scripts
import command_v11_client.api.extensions.delete_extensions_scripts_id as kf_delete_extensions_scripts_id
import command_v11_client.api.extensions.get_extensions_scripts as kf_get_extensions_scripts
import command_v11_client.api.extensions.get_extensions_scripts_id as kf_get_extensions_scripts_id
import command_v11_client.api.extensions.post_extensions_scripts as kf_post_extensions_scripts
import command_v11_client.api.key.get_ssh_keys_unmanaged_id as kf_get_ssh_keys_unmanaged_id
import command_v11_client.api.key.delete_ssh_keys_unmanaged_id as kf_delete_ssh_keys_unmanaged_id
import command_v11_client.api.key.get_ssh_keys_unmanaged as kf_get_ssh_keys_unmanaged
import command_v11_client.api.key.get_ssh_keys_my_key as kf_get_ssh_keys_my_key
import command_v11_client.api.key.put_ssh_keys_my_key as kf_put_ssh_keys_my_key
import command_v11_client.api.key.delete_ssh_keys_unmanaged as kf_delete_ssh_keys_unmanaged
import command_v11_client.api.key.post_ssh_keys_my_key as kf_post_ssh_keys_my_key
import command_v11_client.api.expiration_alert.put_alerts_expiration as kf_put_alerts_expiration
import command_v11_client.api.expiration_alert.get_alerts_expiration_schedule as kf_get_alerts_expiration_schedule
import command_v11_client.api.expiration_alert.post_alerts_expiration_test as kf_post_alerts_expiration_test
import command_v11_client.api.expiration_alert.delete_alerts_expiration_id as kf_delete_alerts_expiration_id
import command_v11_client.api.expiration_alert.post_alerts_expiration_test_all as kf_post_alerts_expiration_test_all
import command_v11_client.api.expiration_alert.put_alerts_expiration_schedule as kf_put_alerts_expiration_schedule
import command_v11_client.api.expiration_alert.post_alerts_expiration as kf_post_alerts_expiration
import command_v11_client.api.expiration_alert.get_alerts_expiration as kf_get_alerts_expiration
import command_v11_client.api.expiration_alert.get_alerts_expiration_id as kf_get_alerts_expiration_id
import command_v11_client.api.status.get_status_endpoints as kf_get_status_endpoints
import command_v11_client.api.security_roles.put_security_roles as kf_put_security_roles
import command_v11_client.api.security_roles.post_security_roles as kf_post_security_roles
import command_v11_client.api.security_roles.post_security_roles_id_copy as kf_post_security_roles_id_copy
import command_v11_client.api.security_roles.get_security_roles_id_identities as kf_get_security_roles_id_identities
import command_v11_client.api.security_roles.get_security_roles as kf_get_security_roles
import command_v11_client.api.security_roles.delete_security_roles_id as kf_delete_security_roles_id
import command_v11_client.api.security_roles.get_security_roles_id as kf_get_security_roles_id
import command_v11_client.api.security_roles.put_security_roles_id_identities as kf_put_security_roles_id_identities
import command_v11_client.api.certificate_authority.get_certificate_authority_available_forests as kf_get_certificate_authority_available_forests
import command_v11_client.api.certificate_authority.post_certificate_authority_alert_recipients_ca_threshold_recipients as kf_post_certificate_authority_alert_recipients_ca_threshold_recipients
import command_v11_client.api.certificate_authority.get_certificate_authority_alert_recipients_ca_threshold_recipients_id as kf_get_certificate_authority_alert_recipients_ca_threshold_recipients_id
import command_v11_client.api.certificate_authority.post_certificate_authority as kf_post_certificate_authority
import command_v11_client.api.certificate_authority.post_certificate_authority_test as kf_post_certificate_authority_test
import command_v11_client.api.certificate_authority.delete_certificate_authority_id as kf_delete_certificate_authority_id
import command_v11_client.api.certificate_authority.put_certificate_authority_alert_recipients_ca_health_recipients_id as kf_put_certificate_authority_alert_recipients_ca_health_recipients_id
import command_v11_client.api.certificate_authority.delete_certificate_authority_alert_recipients_ca_threshold_recipients_id as kf_delete_certificate_authority_alert_recipients_ca_threshold_recipients_id
import command_v11_client.api.certificate_authority.get_certificate_authority_id as kf_get_certificate_authority_id
import command_v11_client.api.certificate_authority.get_certificate_authority_source_count as kf_get_certificate_authority_source_count
import command_v11_client.api.certificate_authority.post_certificate_authority_alert_recipients_ca_health_recipients as kf_post_certificate_authority_alert_recipients_ca_health_recipients
import command_v11_client.api.certificate_authority.put_certificate_authority_alert_recipients_ca_threshold_recipients_id as kf_put_certificate_authority_alert_recipients_ca_threshold_recipients_id
import command_v11_client.api.certificate_authority.post_certificate_authority_publish_crl as kf_post_certificate_authority_publish_crl
import command_v11_client.api.certificate_authority.get_certificate_authority_health_monitoring_schedule as kf_get_certificate_authority_health_monitoring_schedule
import command_v11_client.api.certificate_authority.put_certificate_authority as kf_put_certificate_authority
import command_v11_client.api.certificate_authority.get_certificate_authority_alert_recipients_ca_health_recipients_id as kf_get_certificate_authority_alert_recipients_ca_health_recipients_id
import command_v11_client.api.certificate_authority.get_certificate_authority as kf_get_certificate_authority
import command_v11_client.api.certificate_authority.get_certificate_authority_alert_recipients_ca_health_recipients as kf_get_certificate_authority_alert_recipients_ca_health_recipients
import command_v11_client.api.certificate_authority.delete_certificate_authority_alert_recipients_ca_health_recipients_id as kf_delete_certificate_authority_alert_recipients_ca_health_recipients_id
import command_v11_client.api.certificate_authority.post_certificate_authority_import as kf_post_certificate_authority_import
import command_v11_client.api.certificate_authority.get_certificate_authority_alert_recipients_ca_threshold_recipients as kf_get_certificate_authority_alert_recipients_ca_threshold_recipients
import command_v11_client.api.security.get_security_identities as kf_get_security_identities
import command_v11_client.api.security.get_security_identities_id as kf_get_security_identities_id
import command_v11_client.api.security.post_security_containers_id_roles as kf_post_security_containers_id_roles
import command_v11_client.api.security.get_security_containers_id_roles as kf_get_security_containers_id_roles
import command_v11_client.api.security.delete_security_identities_id as kf_delete_security_identities_id
import command_v11_client.api.security.get_security_identities_lookup as kf_get_security_identities_lookup
import command_v11_client.api.security.get_security_my as kf_get_security_my
import command_v11_client.api.security.post_security_identities as kf_post_security_identities
import command_v11_client.api.security.get_security_audit_collections_id as kf_get_security_audit_collections_id
import command_v11_client.api.certificate_store.post_certificate_stores_schedule as kf_post_certificate_stores_schedule
import command_v11_client.api.certificate_store.put_certificate_stores as kf_put_certificate_stores
import command_v11_client.api.certificate_store.post_certificate_stores_approve as kf_post_certificate_stores_approve
import command_v11_client.api.certificate_store.post_certificate_stores_certificates_remove as kf_post_certificate_stores_certificates_remove
import command_v11_client.api.certificate_store.post_certificate_stores_reenrollment as kf_post_certificate_stores_reenrollment
import command_v11_client.api.certificate_store.post_certificate_stores_certificates_add as kf_post_certificate_stores_certificates_add
import command_v11_client.api.certificate_store.get_certificate_stores_id_inventory as kf_get_certificate_stores_id_inventory
import command_v11_client.api.certificate_store.put_certificate_stores_discovery_job as kf_put_certificate_stores_discovery_job
import command_v11_client.api.certificate_store.put_certificate_stores_password as kf_put_certificate_stores_password
import command_v11_client.api.certificate_store.put_certificate_stores_server as kf_put_certificate_stores_server
import command_v11_client.api.certificate_store.get_certificate_stores_id as kf_get_certificate_stores_id
import command_v11_client.api.certificate_store.post_certificate_stores as kf_post_certificate_stores
import command_v11_client.api.certificate_store.get_certificate_stores_server as kf_get_certificate_stores_server
import command_v11_client.api.certificate_store.delete_certificate_stores as kf_delete_certificate_stores
import command_v11_client.api.certificate_store.delete_certificate_stores_id as kf_delete_certificate_stores_id
import command_v11_client.api.certificate_store.get_certificate_stores as kf_get_certificate_stores
import command_v11_client.api.certificate_store.post_certificate_stores_server as kf_post_certificate_stores_server
import command_v11_client.api.certificate_store.put_certificate_stores_assign_container as kf_put_certificate_stores_assign_container
import command_v11_client.api.license_.get_license as kf_get_license
import command_v11_client.api.agent.post_agents_reset as kf_post_agents_reset
import command_v11_client.api.agent.get_agents as kf_get_agents
import command_v11_client.api.agent.post_agents_disapprove as kf_post_agents_disapprove
import command_v11_client.api.agent.post_agents_approve as kf_post_agents_approve
import command_v11_client.api.agent.post_agents_id_reset as kf_post_agents_id_reset
import command_v11_client.api.agent.post_agents_set_auth_certificate_reenrollment as kf_post_agents_set_auth_certificate_reenrollment
import command_v11_client.api.agent.get_agents_id as kf_get_agents_id
import command_v11_client.api.agent.post_agents_id_fetch_logs as kf_post_agents_id_fetch_logs
import command_v11_client.api.csr_generation.post_csr_generation_generate as kf_post_csr_generation_generate
import command_v11_client.api.csr_generation.get_csr_generation_pending_id as kf_get_csr_generation_pending_id
import command_v11_client.api.csr_generation.get_csr_generation_pending as kf_get_csr_generation_pending
import command_v11_client.api.csr_generation.delete_csr_generation_pending as kf_delete_csr_generation_pending
import command_v11_client.api.csr_generation.delete_csr_generation_pending_id as kf_delete_csr_generation_pending_id
import command_v11_client.api.workflow_instance.get_workflow_instances_my as kf_get_workflow_instances_my
import command_v11_client.api.workflow_instance.get_workflow_instances as kf_get_workflow_instances
import command_v11_client.api.workflow_instance.get_workflow_instances_instance_id as kf_get_workflow_instances_instance_id
import command_v11_client.api.workflow_instance.post_workflow_instances_instance_id_restart as kf_post_workflow_instances_instance_id_restart
import command_v11_client.api.workflow_instance.post_workflow_instances_instance_id_signals as kf_post_workflow_instances_instance_id_signals
import command_v11_client.api.workflow_instance.delete_workflow_instances_instance_id as kf_delete_workflow_instances_instance_id
import command_v11_client.api.workflow_instance.get_workflow_instances_assigned_to_me as kf_get_workflow_instances_assigned_to_me
import command_v11_client.api.workflow_instance.post_workflow_instances_instance_id_stop as kf_post_workflow_instances_instance_id_stop
import command_v11_client.api.pam_provider.get_pam_providers_id as kf_get_pam_providers_id
import command_v11_client.api.pam_provider.delete_pam_providers_id as kf_delete_pam_providers_id
import command_v11_client.api.pam_provider.post_pam_providers_types as kf_post_pam_providers_types
import command_v11_client.api.pam_provider.get_pam_providers as kf_get_pam_providers
import command_v11_client.api.pam_provider.put_pam_providers as kf_put_pam_providers
import command_v11_client.api.pam_provider.get_pam_providers_types as kf_get_pam_providers_types
import command_v11_client.api.pam_provider.post_pam_providers as kf_post_pam_providers
import command_v11_client.api.permissions.get_permissions as kf_get_permissions
import command_v11_client.api.audit_log.get_audit_id_validate as kf_get_audit_id_validate
import command_v11_client.api.audit_log.get_audit_download as kf_get_audit_download
import command_v11_client.api.audit_log.get_audit as kf_get_audit
import command_v11_client.api.audit_log.get_audit_related_entities as kf_get_audit_related_entities
import command_v11_client.api.audit_log.get_audit_id as kf_get_audit_id
import command_v11_client.api.workflow_definition.delete_workflow_definitions_definition_id as kf_delete_workflow_definitions_definition_id
import command_v11_client.api.workflow_definition.get_workflow_definitions_steps as kf_get_workflow_definitions_steps
import command_v11_client.api.workflow_definition.get_workflow_definitions_steps_extension_name as kf_get_workflow_definitions_steps_extension_name
import command_v11_client.api.workflow_definition.post_workflow_definitions_definition_id_publish as kf_post_workflow_definitions_definition_id_publish
import command_v11_client.api.workflow_definition.get_workflow_definitions as kf_get_workflow_definitions
import command_v11_client.api.workflow_definition.post_workflow_definitions as kf_post_workflow_definitions
import command_v11_client.api.workflow_definition.get_workflow_definitions_definition_id as kf_get_workflow_definitions_definition_id
import command_v11_client.api.workflow_definition.put_workflow_definitions_definition_id as kf_put_workflow_definitions_definition_id
import command_v11_client.api.workflow_definition.put_workflow_definitions_definition_id_steps as kf_put_workflow_definitions_definition_id_steps
import command_v11_client.api.workflow_definition.get_workflow_definitions_types as kf_get_workflow_definitions_types
import command_v11_client.api.metadata_field.put_metadata_fields as kf_put_metadata_fields
import command_v11_client.api.metadata_field.delete_metadata_fields_id as kf_delete_metadata_fields_id
import command_v11_client.api.metadata_field.get_metadata_fields_id_in_use as kf_get_metadata_fields_id_in_use
import command_v11_client.api.metadata_field.get_metadata_fields as kf_get_metadata_fields
import command_v11_client.api.metadata_field.get_metadata_fields_id as kf_get_metadata_fields_id
import command_v11_client.api.metadata_field.delete_metadata_fields as kf_delete_metadata_fields
import command_v11_client.api.metadata_field.get_metadata_fields_name as kf_get_metadata_fields_name
import command_v11_client.api.metadata_field.post_metadata_fields as kf_post_metadata_fields
import command_v11_client.api.identity_provider.get_identity_providers as kf_get_identity_providers
import command_v11_client.api.identity_provider.put_identity_providers_id as kf_put_identity_providers_id
import command_v11_client.api.identity_provider.get_identity_providers_id as kf_get_identity_providers_id
import command_v11_client.api.identity_provider.get_identity_providers_types as kf_get_identity_providers_types
import command_v11_client.models.csscms_data_model_models_invalid_keystore as kf_csscms_data_model_models_invalid_keystore
import command_v11_client.models.csscms_data_model_models_revocation_revocation_response as kf_csscms_data_model_models_revocation_revocation_response
import command_v11_client.models.keyfactor_web_keyfactor_api_models_certificate_stores_add_certificate_request as kf_keyfactor_web_keyfactor_api_models_certificate_stores_add_certificate_request
import command_v11_client.models.keyfactor_web_keyfactor_api_models_pam_provider_response_legacy as kf_keyfactor_web_keyfactor_api_models_pam_provider_response_legacy
import command_v11_client.models.keyfactor_web_keyfactor_api_models_alerts_expiration_expiration_alert_creation_request as kf_keyfactor_web_keyfactor_api_models_alerts_expiration_expiration_alert_creation_request
import command_v11_client.models.csscms_data_model_models_cert_store_locations_certificate_store_locations_detail as kf_csscms_data_model_models_cert_store_locations_certificate_store_locations_detail
import command_v11_client.models.csscms_data_model_models_certificate_import_request_model as kf_csscms_data_model_models_certificate_import_request_model
import command_v11_client.models.keyfactor_web_keyfactor_api_models_workflows_signal_request_data as kf_keyfactor_web_keyfactor_api_models_workflows_signal_request_data
import command_v11_client.models.keyfactor_orchestrators_common_enums_ssl_network_definition_item_type as kf_keyfactor_orchestrators_common_enums_ssl_network_definition_item_type
import command_v11_client.models.csscms_data_model_models_subject_alternative_name as kf_csscms_data_model_models_subject_alternative_name
import command_v11_client.models.keyfactor_orchestrators_common_enums_cert_store_custom_alias as kf_keyfactor_orchestrators_common_enums_cert_store_custom_alias
import command_v11_client.models.csscms_data_model_models_templates_algorithms_key_info as kf_csscms_data_model_models_templates_algorithms_key_info
import command_v11_client.models.keyfactor_web_keyfactor_api_models_license_license_response_licensed_product as kf_keyfactor_web_keyfactor_api_models_license_license_response_licensed_product
import command_v11_client.models.csscms_data_model_models_orchestrator_jobs_schedule_job_request_job_fields as kf_csscms_data_model_models_orchestrator_jobs_schedule_job_request_job_fields
import command_v11_client.models.csscms_data_model_models_enrollment_pfx_enrollment_response_metadata as kf_csscms_data_model_models_enrollment_pfx_enrollment_response_metadata
import command_v11_client.models.csscms_data_model_models_orchestrator_jobs_schedule_bulk_job_request_job_fields as kf_csscms_data_model_models_orchestrator_jobs_schedule_bulk_job_request_job_fields
import command_v11_client.models.csscms_data_model_models_templates_template_regex as kf_csscms_data_model_models_templates_template_regex
import command_v11_client.models.keyfactor_web_keyfactor_api_models_security_security_role_permissions_area_permission_response as kf_keyfactor_web_keyfactor_api_models_security_security_role_permissions_area_permission_response
import command_v11_client.models.keyfactor_web_keyfactor_api_models_templates_key_algorithms_response_model as kf_keyfactor_web_keyfactor_api_models_templates_key_algorithms_response_model
import command_v11_client.models.keyfactor_web_keyfactor_api_models_orchestrator_jobs_job_type_response as kf_keyfactor_web_keyfactor_api_models_orchestrator_jobs_job_type_response
import command_v11_client.models.csscms_data_model_enums_ssh_key_algorithm as kf_csscms_data_model_enums_ssh_key_algorithm
import command_v11_client.models.keyfactor_web_keyfactor_api_models_templates_enrollment_template_enrollment_policy_response as kf_keyfactor_web_keyfactor_api_models_templates_enrollment_template_enrollment_policy_response
import command_v11_client.models.keyfactor_web_keyfactor_api_models_alerts_expiration_expiration_alert_definition_response as kf_keyfactor_web_keyfactor_api_models_alerts_expiration_expiration_alert_definition_response
import command_v11_client.models.keyfactor_web_keyfactor_api_models_orchestrators_agent_blueprint_jobs_response as kf_keyfactor_web_keyfactor_api_models_orchestrators_agent_blueprint_jobs_response
import command_v11_client.models.csscms_data_model_models_certificate_store_server as kf_csscms_data_model_models_certificate_store_server
import command_v11_client.models.keyfactor_web_keyfactor_api_models_certificate_collections_certificate_collection_copy_request as kf_keyfactor_web_keyfactor_api_models_certificate_collections_certificate_collection_copy_request
import command_v11_client.models.keyfactor_web_keyfactor_api_models_monitoring_dashboard_response as kf_keyfactor_web_keyfactor_api_models_monitoring_dashboard_response
import command_v11_client.models.keyfactor_web_keyfactor_api_models_workflows_available_step_response as kf_keyfactor_web_keyfactor_api_models_workflows_available_step_response
import command_v11_client.models.csscms_data_model_models_certificate_store_update_server_request as kf_csscms_data_model_models_certificate_store_update_server_request
import command_v11_client.models.csscms_data_model_models_certificate_retrieval_response_crl_distribution_point_model as kf_csscms_data_model_models_certificate_retrieval_response_crl_distribution_point_model
import command_v11_client.models.keyfactor_web_keyfactor_api_models_certificate_stores_reenrollment_request_job_properties as kf_keyfactor_web_keyfactor_api_models_certificate_stores_reenrollment_request_job_properties
import command_v11_client.models.keyfactor_web_keyfactor_api_models_templates_valid_subject_part_response as kf_keyfactor_web_keyfactor_api_models_templates_valid_subject_part_response
import command_v11_client.models.csscms_data_model_models_ssh_server_groups_server_group_creation_request as kf_csscms_data_model_models_ssh_server_groups_server_group_creation_request
import command_v11_client.models.keyfactor_web_keyfactor_api_models_identity_provider_provider_type_parameter_response as kf_keyfactor_web_keyfactor_api_models_identity_provider_provider_type_parameter_response
import command_v11_client.models.keyfactor_web_keyfactor_api_models_orchestrators_update_orchestrator_auth_certificate_reenrollment_request as kf_keyfactor_web_keyfactor_api_models_orchestrators_update_orchestrator_auth_certificate_reenrollment_request
import command_v11_client.models.csscms_data_model_models_revocation_suspended_revocation_response as kf_csscms_data_model_models_revocation_suspended_revocation_response
import command_v11_client.models.keyfactor_web_keyfactor_api_models_orchestrator_jobs_job_type_field_response as kf_keyfactor_web_keyfactor_api_models_orchestrator_jobs_job_type_field_response
import command_v11_client.models.csscms_data_model_models_certificate_store as kf_csscms_data_model_models_certificate_store
import command_v11_client.models.keyfactor_web_keyfactor_api_models_security_role_claim_definitions_role_claim_definition_query_response as kf_keyfactor_web_keyfactor_api_models_security_role_claim_definitions_role_claim_definition_query_response
import command_v11_client.models.csscms_data_model_models_certificate_import_request_model_metadata as kf_csscms_data_model_models_certificate_import_request_model_metadata
import command_v11_client.models.csscms_data_model_models_ssh_users_ssh_user_access_response as kf_csscms_data_model_models_ssh_users_ssh_user_access_response
import command_v11_client.models.csscms_data_model_models_security_certificate_permissions as kf_csscms_data_model_models_security_certificate_permissions
import command_v11_client.models.keyfactor_web_keyfactor_api_models_workflows_definition_create_request as kf_keyfactor_web_keyfactor_api_models_workflows_definition_create_request
import command_v11_client.models.csscms_core_enums_encryption_key_type as kf_csscms_core_enums_encryption_key_type
import command_v11_client.models.csscms_data_model_models_ssl_endpoint_history_response_certificate_model as kf_csscms_data_model_models_ssl_endpoint_history_response_certificate_model
import command_v11_client.models.keyfactor_web_keyfactor_api_models_alerts_expiration_expiration_alert_test_all_request as kf_keyfactor_web_keyfactor_api_models_alerts_expiration_expiration_alert_test_all_request
import command_v11_client.models.keyfactor_web_keyfactor_api_models_reports_custom_reports_custom_report_update_request as kf_keyfactor_web_keyfactor_api_models_reports_custom_reports_custom_report_update_request
import command_v11_client.models.keyfactor_web_core_models_enrollment_enrollment_template_ca_response as kf_keyfactor_web_core_models_enrollment_enrollment_template_ca_response
import command_v11_client.models.keyfactor_web_keyfactor_api_models_templates_template_retrieval_response as kf_keyfactor_web_keyfactor_api_models_templates_template_retrieval_response
import command_v11_client.models.keyfactor_web_keyfactor_api_models_workflows_definition_query_response as kf_keyfactor_web_keyfactor_api_models_workflows_definition_query_response
import command_v11_client.models.keyfactor_web_keyfactor_api_models_certificates_cert_request_response_model as kf_keyfactor_web_keyfactor_api_models_certificates_cert_request_response_model
import command_v11_client.models.csscms_data_model_models_certificate_download_response as kf_csscms_data_model_models_certificate_download_response
import command_v11_client.models.csscms_data_model_models_orchestrator_jobs_job as kf_csscms_data_model_models_orchestrator_jobs_job
import command_v11_client.models.csscms_data_model_models_cert_store_type_password_options as kf_csscms_data_model_models_cert_store_type_password_options
import command_v11_client.models.csscms_data_model_models_certificate_store_entry as kf_csscms_data_model_models_certificate_store_entry
import command_v11_client.models.csscms_data_model_models_enrollment_csr_enrollment_request_additional_enrollment_fields as kf_csscms_data_model_models_enrollment_csr_enrollment_request_additional_enrollment_fields
import command_v11_client.models.csscms_data_model_models_certificate_collection_nav_item as kf_csscms_data_model_models_certificate_collection_nav_item
import command_v11_client.models.csscms_core_enums_ssl_scan_job_status as kf_csscms_core_enums_ssl_scan_job_status
import command_v11_client.models.csscms_data_model_models_ssh_service_accounts_service_account_response as kf_csscms_data_model_models_ssh_service_accounts_service_account_response
import command_v11_client.models.csscms_data_model_models_ssh_server_groups_server_group_response as kf_csscms_data_model_models_ssh_server_groups_server_group_response
import command_v11_client.models.csscms_data_model_models_enrollment_pfx_enrollment_request_additional_enrollment_fields as kf_csscms_data_model_models_enrollment_pfx_enrollment_request_additional_enrollment_fields
import command_v11_client.models.keyfactor_web_keyfactor_api_models_ssl_quiet_hour_response as kf_keyfactor_web_keyfactor_api_models_ssl_quiet_hour_response
import command_v11_client.models.keyfactor_web_keyfactor_api_models_alerts_denied_denied_alert_definition_response as kf_keyfactor_web_keyfactor_api_models_alerts_denied_denied_alert_definition_response
import command_v11_client.models.csscms_data_model_enums_alert_build_result as kf_csscms_data_model_enums_alert_build_result
import command_v11_client.models.keyfactor_web_keyfactor_api_models_alerts_alert_schedule_alert_schedule_response as kf_keyfactor_web_keyfactor_api_models_alerts_alert_schedule_alert_schedule_response
import command_v11_client.models.csscms_data_model_models_certificate_store_inventory_parameters as kf_csscms_data_model_models_certificate_store_inventory_parameters
import command_v11_client.models.keyfactor_web_keyfactor_api_models_alerts_expiration_expiration_alert_test_response as kf_keyfactor_web_keyfactor_api_models_alerts_expiration_expiration_alert_test_response
import command_v11_client.models.keyfactor_web_keyfactor_api_models_global_permissions_global_permission_response as kf_keyfactor_web_keyfactor_api_models_global_permissions_global_permission_response
import command_v11_client.models.keyfactor_auditing_enums_audit_log_level as kf_keyfactor_auditing_enums_audit_log_level
import command_v11_client.models.keyfactor_web_keyfactor_api_models_alerts_expiration_expiration_alert_response as kf_keyfactor_web_keyfactor_api_models_alerts_expiration_expiration_alert_response
import command_v11_client.models.keyfactor_web_keyfactor_api_models_security_role_claim_definitions_role_claim_definition_update_request as kf_keyfactor_web_keyfactor_api_models_security_role_claim_definitions_role_claim_definition_update_request
import command_v11_client.models.keyfactor_web_keyfactor_api_models_reports_report_schedules_report_schedule_update_request as kf_keyfactor_web_keyfactor_api_models_reports_report_schedules_report_schedule_update_request
import command_v11_client.models.csscms_data_model_models_certificate_retrieval_response_detailed_key_usage_model as kf_csscms_data_model_models_certificate_retrieval_response_detailed_key_usage_model
import command_v11_client.models.keyfactor_web_keyfactor_api_models_certificate_authorities_ca_alert_recipient_response as kf_keyfactor_web_keyfactor_api_models_certificate_authorities_ca_alert_recipient_response
import command_v11_client.models.keyfactor_web_keyfactor_api_models_mac_enrollment_mac_enrollment_api_model as kf_keyfactor_web_keyfactor_api_models_mac_enrollment_mac_enrollment_api_model
import command_v11_client.models.csscms_data_model_models_certificate_store_type_property as kf_csscms_data_model_models_certificate_store_type_property
import command_v11_client.models.csscms_data_model_models_certificate_retrieval_response_extended_key_usage_model as kf_csscms_data_model_models_certificate_retrieval_response_extended_key_usage_model
import command_v11_client.models.keyfactor_web_keyfactor_api_models_metadata_field_metadata_field_update_request as kf_keyfactor_web_keyfactor_api_models_metadata_field_metadata_field_update_request
import command_v11_client.models.csscms_data_model_models_enrollment_csr_generation_request_sa_ns as kf_csscms_data_model_models_enrollment_csr_generation_request_sa_ns
import command_v11_client.models.keyfactor_web_keyfactor_api_models_security_legacy_security_roles_security_identity_response as kf_keyfactor_web_keyfactor_api_models_security_legacy_security_roles_security_identity_response
import command_v11_client.models.keyfactor_web_keyfactor_api_models_workflows_signal_definition_response_input_parameters as kf_keyfactor_web_keyfactor_api_models_workflows_signal_definition_response_input_parameters
import command_v11_client.models.keyfactor_web_keyfactor_api_models_monitoring_dashboard_request as kf_keyfactor_web_keyfactor_api_models_monitoring_dashboard_request
import command_v11_client.models.csscms_data_model_models_pkcs_12_certificate_response as kf_csscms_data_model_models_pkcs_12_certificate_response
import command_v11_client.models.keyfactor_web_keyfactor_api_models_certificate_stores_types_certificate_store_type_response as kf_keyfactor_web_keyfactor_api_models_certificate_stores_types_certificate_store_type_response
import command_v11_client.models.csscms_data_model_models_csr_contents as kf_csscms_data_model_models_csr_contents
import command_v11_client.models.csscms_data_model_models_ssl_scan_job_part as kf_csscms_data_model_models_ssl_scan_job_part
import command_v11_client.models.keyfactor_web_keyfactor_api_models_alerts_issued_issued_alert_definition_response as kf_keyfactor_web_keyfactor_api_models_alerts_issued_issued_alert_definition_response
import command_v11_client.models.csscms_data_model_models_keyfactor_secret as kf_csscms_data_model_models_keyfactor_secret
import command_v11_client.models.keyfactor_web_keyfactor_api_models_certificate_collections_certificate_collection_update_request as kf_keyfactor_web_keyfactor_api_models_certificate_collections_certificate_collection_update_request
import command_v11_client.models.csscms_data_model_models_workflow_certificate_request_model as kf_csscms_data_model_models_workflow_certificate_request_model
import command_v11_client.models.keyfactor_web_keyfactor_api_models_certificate_stores_types_certificate_store_type_creation_request as kf_keyfactor_web_keyfactor_api_models_certificate_stores_types_certificate_store_type_creation_request
import command_v11_client.models.keyfactor_web_keyfactor_api_models_reports_report_schedules_report_schedule_update_request_runtime_parameters as kf_keyfactor_web_keyfactor_api_models_reports_report_schedules_report_schedule_update_request_runtime_parameters
import command_v11_client.models.keyfactor_web_keyfactor_api_models_scripts_script_query_response as kf_keyfactor_web_keyfactor_api_models_scripts_script_query_response
import command_v11_client.models.csscms_core_enums_agent_platform_type as kf_csscms_core_enums_agent_platform_type
import command_v11_client.models.csscms_data_model_models_ssl_display_scan_job_part as kf_csscms_data_model_models_ssl_display_scan_job_part
import command_v11_client.models.keyfactor_web_keyfactor_api_models_orchestrators_agent_blueprint_stores_response as kf_keyfactor_web_keyfactor_api_models_orchestrators_agent_blueprint_stores_response
import command_v11_client.models.keyfactor_web_keyfactor_api_models_security_legacy_security_roles_security_role_creation_request as kf_keyfactor_web_keyfactor_api_models_security_legacy_security_roles_security_role_creation_request
import command_v11_client.models.csscms_data_model_models_pkcs_10_certificate_response as kf_csscms_data_model_models_pkcs_10_certificate_response
import command_v11_client.models.keyfactor_web_keyfactor_api_models_permission_sets_permission_set_create_request as kf_keyfactor_web_keyfactor_api_models_permission_sets_permission_set_create_request
import command_v11_client.models.csscms_core_enums_metadata_type_enrollment as kf_csscms_core_enums_metadata_type_enrollment
import command_v11_client.models.keyfactor_web_keyfactor_api_models_alerts_pending_pending_alert_definition_response as kf_keyfactor_web_keyfactor_api_models_alerts_pending_pending_alert_definition_response
import command_v11_client.models.keyfactor_web_keyfactor_api_models_orchestrator_pools_agent_pool_creation_request as kf_keyfactor_web_keyfactor_api_models_orchestrator_pools_agent_pool_creation_request
import command_v11_client.models.csscms_data_model_models_provider_type_param as kf_csscms_data_model_models_provider_type_param
import command_v11_client.models.csscms_data_model_models_container_assignment as kf_csscms_data_model_models_container_assignment
import command_v11_client.models.keyfactor_web_keyfactor_api_models_certificate_authorities_certificate_authority_request as kf_keyfactor_web_keyfactor_api_models_certificate_authorities_certificate_authority_request
import command_v11_client.models.keyfactor_common_scheduling_models_time_model as kf_keyfactor_common_scheduling_models_time_model
import command_v11_client.models.keyfactor_web_keyfactor_api_models_workflows_available_signal_response as kf_keyfactor_web_keyfactor_api_models_workflows_available_signal_response
import command_v11_client.models.keyfactor_web_keyfactor_api_models_event_handler_registered_event_handler_response as kf_keyfactor_web_keyfactor_api_models_event_handler_registered_event_handler_response
import command_v11_client.models.keyfactor_web_keyfactor_api_models_orchestrator_jobs_reschedule_job_request as kf_keyfactor_web_keyfactor_api_models_orchestrator_jobs_reschedule_job_request
import command_v11_client.models.csscms_data_model_models_report_parameters_request as kf_csscms_data_model_models_report_parameters_request
import command_v11_client.models.csscms_data_model_models_orchestrator_jobs_schedule_job_request as kf_csscms_data_model_models_orchestrator_jobs_schedule_job_request
import command_v11_client.models.csscms_data_model_models_cert_store_locations_certificate_locations_group as kf_csscms_data_model_models_cert_store_locations_certificate_locations_group
import command_v11_client.models.keyfactor_web_keyfactor_api_models_workflows_available_step_response_configuration_parameters_definition as kf_keyfactor_web_keyfactor_api_models_workflows_available_step_response_configuration_parameters_definition
import command_v11_client.models.keyfactor_web_keyfactor_api_models_pam_provider_create_request as kf_keyfactor_web_keyfactor_api_models_pam_provider_create_request
import command_v11_client.models.csscms_data_model_models_keyfactor_api_secret as kf_csscms_data_model_models_keyfactor_api_secret
import command_v11_client.models.keyfactor_workflows_input_control_type as kf_keyfactor_workflows_input_control_type
import command_v11_client.models.keyfactor_web_keyfactor_api_models_component_installation_component_installation_response as kf_keyfactor_web_keyfactor_api_models_component_installation_component_installation_response
import command_v11_client.models.csscms_data_model_models_revoke_certificate_request as kf_csscms_data_model_models_revoke_certificate_request
import command_v11_client.models.keyfactor_web_keyfactor_api_models_templates_template_policy_request_response_model as kf_keyfactor_web_keyfactor_api_models_templates_template_policy_request_response_model
import command_v11_client.models.keyfactor_web_keyfactor_api_models_templates_extended_key_usage_response_model as kf_keyfactor_web_keyfactor_api_models_templates_extended_key_usage_response_model
import command_v11_client.models.csscms_data_model_models_enrollment_csr_generation_request as kf_csscms_data_model_models_enrollment_csr_generation_request
import command_v11_client.models.keyfactor_web_keyfactor_api_models_pam_provider_type_parameter_create_request as kf_keyfactor_web_keyfactor_api_models_pam_provider_type_parameter_create_request
import command_v11_client.models.csscms_data_model_enums_failure_type as kf_csscms_data_model_enums_failure_type
import command_v11_client.models.keyfactor_web_keyfactor_api_models_ssl_quiet_hour_request as kf_keyfactor_web_keyfactor_api_models_ssl_quiet_hour_request
import command_v11_client.models.csscms_data_model_models_workflow_certificate_request_model_metadata as kf_csscms_data_model_models_workflow_certificate_request_model_metadata
import command_v11_client.models.csscms_data_model_models_cert_store_container_request as kf_csscms_data_model_models_cert_store_container_request
import command_v11_client.models.keyfactor_web_keyfactor_api_models_event_handler_registration_event_handler_registration_update_request as kf_keyfactor_web_keyfactor_api_models_event_handler_registration_event_handler_registration_update_request
import command_v11_client.models.keyfactor_web_keyfactor_api_models_security_security_role_permissions_pam_provider_permission_request as kf_keyfactor_web_keyfactor_api_models_security_security_role_permissions_pam_provider_permission_request
import command_v11_client.models.csscms_data_model_models_certificate_location_specifier as kf_csscms_data_model_models_certificate_location_specifier
import command_v11_client.models.keyfactor_web_keyfactor_api_models_workflows_condition_configuration_response as kf_keyfactor_web_keyfactor_api_models_workflows_condition_configuration_response
import command_v11_client.models.csscms_core_enums_ssl_network_job_status as kf_csscms_core_enums_ssl_network_job_status
import command_v11_client.models.keyfactor_web_keyfactor_api_models_certificates_subject_alternative_name as kf_keyfactor_web_keyfactor_api_models_certificates_subject_alternative_name
import command_v11_client.models.csscms_data_model_models_report_parameters as kf_csscms_data_model_models_report_parameters
import command_v11_client.models.csscms_data_model_models_ssh_logons_logon_query_response as kf_csscms_data_model_models_ssh_logons_logon_query_response
import command_v11_client.models.keyfactor_web_keyfactor_api_models_alerts_issued_issued_alert_update_request as kf_keyfactor_web_keyfactor_api_models_alerts_issued_issued_alert_update_request
import command_v11_client.models.csscms_data_model_models_report_schedule_runtime_parameters as kf_csscms_data_model_models_report_schedule_runtime_parameters
import command_v11_client.models.keyfactor_web_keyfactor_api_models_certificate_authorities_certificate_authority_response as kf_keyfactor_web_keyfactor_api_models_certificate_authorities_certificate_authority_response
import command_v11_client.models.csscms_data_model_models_keyfactor_api_secret_parameters as kf_csscms_data_model_models_keyfactor_api_secret_parameters
import command_v11_client.models.keyfactor_web_keyfactor_api_models_security_legacy_security_roles_security_role_copy_request as kf_keyfactor_web_keyfactor_api_models_security_legacy_security_roles_security_role_copy_request
import command_v11_client.models.keyfactor_web_keyfactor_api_models_certificates_certificate_locations_response as kf_keyfactor_web_keyfactor_api_models_certificates_certificate_locations_response
import command_v11_client.models.keyfactor_web_keyfactor_api_models_monitoring_ocsp_parameters_response as kf_keyfactor_web_keyfactor_api_models_monitoring_ocsp_parameters_response
import command_v11_client.models.keyfactor_web_keyfactor_api_models_alerts_key_rotation_key_rotation_alert_update_request as kf_keyfactor_web_keyfactor_api_models_alerts_key_rotation_key_rotation_alert_update_request
import command_v11_client.models.keyfactor_web_keyfactor_api_models_security_legacy_security_roles_security_role_update_request as kf_keyfactor_web_keyfactor_api_models_security_legacy_security_roles_security_role_update_request
import command_v11_client.models.csscms_data_model_models_ssh_service_accounts_service_account_creation_request as kf_csscms_data_model_models_ssh_service_accounts_service_account_creation_request
import command_v11_client.models.keyfactor_web_keyfactor_api_models_orchestrator_jobs_acknowledge_job_request as kf_keyfactor_web_keyfactor_api_models_orchestrator_jobs_acknowledge_job_request
import command_v11_client.models.csscms_data_model_models_ssh_logons_logon_response as kf_csscms_data_model_models_ssh_logons_logon_response
import command_v11_client.models.csscms_data_model_models_certificate_validation_response as kf_csscms_data_model_models_certificate_validation_response
import command_v11_client.models.keyfactor_web_keyfactor_api_models_workflows_definition_step_response_configuration_parameters as kf_keyfactor_web_keyfactor_api_models_workflows_definition_step_response_configuration_parameters
import command_v11_client.models.keyfactor_web_keyfactor_api_models_license_license_response as kf_keyfactor_web_keyfactor_api_models_license_license_response
import command_v11_client.models.csscms_data_model_models_security_identities_security_identity_identifier as kf_csscms_data_model_models_security_identities_security_identity_identifier
import command_v11_client.models.csscms_data_model_models_certificate_store_container_permissions as kf_csscms_data_model_models_certificate_store_container_permissions
import command_v11_client.models.csscms_core_enums_report_parameter_type as kf_csscms_core_enums_report_parameter_type
import command_v11_client.models.keyfactor_web_keyfactor_api_models_security_legacy_security_roles_role_identities_request as kf_keyfactor_web_keyfactor_api_models_security_legacy_security_roles_role_identities_request
import command_v11_client.models.csscms_data_model_models_orchestrator_jobs_bulk_orchestrator_job_pair as kf_csscms_data_model_models_orchestrator_jobs_bulk_orchestrator_job_pair
import command_v11_client.models.csscms_data_model_models_ssl_endpoint as kf_csscms_data_model_models_ssl_endpoint
import command_v11_client.models.keyfactor_web_keyfactor_api_models_permission_sets_permission_set_update_request as kf_keyfactor_web_keyfactor_api_models_permission_sets_permission_set_update_request
import command_v11_client.models.keyfactor_web_keyfactor_api_models_monitoring_revocation_monitoring_alert_test_response as kf_keyfactor_web_keyfactor_api_models_monitoring_revocation_monitoring_alert_test_response
import command_v11_client.models.csscms_data_model_models_ssh_access_server_group_access_request as kf_csscms_data_model_models_ssh_access_server_group_access_request
import command_v11_client.models.csscms_data_model_models_enrollment_renewal_request as kf_csscms_data_model_models_enrollment_renewal_request
import command_v11_client.models.csscms_data_model_models_ssh_service_accounts_service_account_user_creation_request as kf_csscms_data_model_models_ssh_service_accounts_service_account_user_creation_request
import command_v11_client.models.keyfactor_web_keyfactor_api_models_security_security_identities_security_identity_response as kf_keyfactor_web_keyfactor_api_models_security_security_identities_security_identity_response
import command_v11_client.models.keyfactor_common_scheduling_models_weekly_model as kf_keyfactor_common_scheduling_models_weekly_model
import command_v11_client.models.csscms_core_enums_claim_type as kf_csscms_core_enums_claim_type
import command_v11_client.models.keyfactor_web_keyfactor_api_models_alerts_pending_pending_alert_test_request as kf_keyfactor_web_keyfactor_api_models_alerts_pending_pending_alert_test_request
import command_v11_client.models.keyfactor_web_keyfactor_api_models_templates_template_metadata_field_request_response_model as kf_keyfactor_web_keyfactor_api_models_templates_template_metadata_field_request_response_model
import command_v11_client.models.keyfactor_web_keyfactor_api_models_monitoring_revocation_monitoring_creation_request as kf_keyfactor_web_keyfactor_api_models_monitoring_revocation_monitoring_creation_request
import command_v11_client.models.csscms_data_model_models_certificate_query as kf_csscms_data_model_models_certificate_query
import command_v11_client.models.csscms_core_enums_entry_parameter_usage_flags as kf_csscms_core_enums_entry_parameter_usage_flags
import command_v11_client.models.keyfactor_common_scheduling_keyfactor_schedule as kf_keyfactor_common_scheduling_keyfactor_schedule
import command_v11_client.models.keyfactor_web_core_models_enrollment_enrollment_template as kf_keyfactor_web_core_models_enrollment_enrollment_template
import command_v11_client.models.keyfactor_common_scheduling_models_monthly_model as kf_keyfactor_common_scheduling_models_monthly_model
import command_v11_client.models.keyfactor_web_keyfactor_api_models_event_handler_event_handler_parameter_response as kf_keyfactor_web_keyfactor_api_models_event_handler_event_handler_parameter_response
import command_v11_client.models.keyfactor_web_keyfactor_api_models_alerts_key_rotation_key_rotation_alert_response as kf_keyfactor_web_keyfactor_api_models_alerts_key_rotation_key_rotation_alert_response
import command_v11_client.models.csscms_core_enums_duplicate_subject_type as kf_csscms_core_enums_duplicate_subject_type
import command_v11_client.models.keyfactor_web_keyfactor_api_models_monitoring_email_request as kf_keyfactor_web_keyfactor_api_models_monitoring_email_request
import command_v11_client.models.csscms_data_model_models_ssl_scan_job_part_definition as kf_csscms_data_model_models_ssl_scan_job_part_definition
import command_v11_client.models.keyfactor_web_keyfactor_api_models_templates_enrollment_template_enrollment_settings_response as kf_keyfactor_web_keyfactor_api_models_templates_enrollment_template_enrollment_settings_response
import command_v11_client.models.csscms_data_model_models_pending_csr_response as kf_csscms_data_model_models_pending_csr_response
import command_v11_client.models.keyfactor_web_keyfactor_api_models_event_handler_registration_event_handler_registration_response as kf_keyfactor_web_keyfactor_api_models_event_handler_registration_event_handler_registration_response
import command_v11_client.models.csscms_data_model_models_cert_store_type_supported_operations as kf_csscms_data_model_models_cert_store_type_supported_operations
import command_v11_client.models.keyfactor_web_keyfactor_api_models_templates_global_global_template_regex_response as kf_keyfactor_web_keyfactor_api_models_templates_global_global_template_regex_response
import command_v11_client.models.keyfactor_web_keyfactor_api_models_ssl_network_response as kf_keyfactor_web_keyfactor_api_models_ssl_network_response
import command_v11_client.models.keyfactor_web_keyfactor_api_models_workflows_definition_step_signal_response as kf_keyfactor_web_keyfactor_api_models_workflows_definition_step_signal_response
import command_v11_client.models.csscms_data_model_models_certificate_stores_certificate_store_update_request as kf_csscms_data_model_models_certificate_stores_certificate_store_update_request
import command_v11_client.models.csscms_data_model_enums_script_categories as kf_csscms_data_model_enums_script_categories
import command_v11_client.models.keyfactor_web_keyfactor_api_models_certificates_certificate_identity_audit_response as kf_keyfactor_web_keyfactor_api_models_certificates_certificate_identity_audit_response
import command_v11_client.models.keyfactor_web_keyfactor_api_models_alerts_pending_pending_alert_creation_request as kf_keyfactor_web_keyfactor_api_models_alerts_pending_pending_alert_creation_request
import command_v11_client.models.keyfactor_web_keyfactor_api_models_templates_global_global_template_regex_request as kf_keyfactor_web_keyfactor_api_models_templates_global_global_template_regex_request
import command_v11_client.models.csscms_data_model_models_certificate_store_types_certificate_store_type_entry_parameter as kf_csscms_data_model_models_certificate_store_types_certificate_store_type_entry_parameter
import command_v11_client.models.csscms_data_model_models_extended_key_usage as kf_csscms_data_model_models_extended_key_usage
import command_v11_client.models.csscms_data_model_models_ssl_endpoint_history_response as kf_csscms_data_model_models_ssl_endpoint_history_response
import command_v11_client.models.keyfactor_web_keyfactor_api_models_workflows_definition_step_request_outputs as kf_keyfactor_web_keyfactor_api_models_workflows_definition_step_request_outputs
import command_v11_client.models.keyfactor_web_keyfactor_api_models_templates_global_global_template_policy_response as kf_keyfactor_web_keyfactor_api_models_templates_global_global_template_policy_response
import command_v11_client.models.csscms_data_model_models_ssh_servers_server_response as kf_csscms_data_model_models_ssh_servers_server_response
import command_v11_client.models.keyfactor_web_keyfactor_api_models_pam_provider_create_request_provider_type as kf_keyfactor_web_keyfactor_api_models_pam_provider_create_request_provider_type
import command_v11_client.models.csscms_data_model_models_enrollment_csr_enrollment_request_sa_ns as kf_csscms_data_model_models_enrollment_csr_enrollment_request_sa_ns
import command_v11_client.models.keyfactor_web_keyfactor_api_models_workflows_definition_step_request_configuration_parameters as kf_keyfactor_web_keyfactor_api_models_workflows_definition_step_request_configuration_parameters
import command_v11_client.models.keyfactor_web_keyfactor_api_models_orchestrators_agent_response as kf_keyfactor_web_keyfactor_api_models_orchestrators_agent_response
import command_v11_client.models.keyfactor_web_keyfactor_api_models_workflows_parameter_definition_response_depends_on as kf_keyfactor_web_keyfactor_api_models_workflows_parameter_definition_response_depends_on
import command_v11_client.models.csscms_data_model_enums_renewal_type as kf_csscms_data_model_enums_renewal_type
import command_v11_client.models.csscms_data_model_models_monitoring_revocation_monitoring_alert_response as kf_csscms_data_model_models_monitoring_revocation_monitoring_alert_response
import command_v11_client.models.keyfactor_web_keyfactor_api_models_app_settings_app_setting_response as kf_keyfactor_web_keyfactor_api_models_app_settings_app_setting_response
import command_v11_client.models.keyfactor_web_keyfactor_api_models_workflows_parameter_definition_response as kf_keyfactor_web_keyfactor_api_models_workflows_parameter_definition_response
import command_v11_client.models.keyfactor_web_keyfactor_api_models_templates_global_global_template_default_response as kf_keyfactor_web_keyfactor_api_models_templates_global_global_template_default_response
import command_v11_client.models.csscms_core_enums_agent_status_type as kf_csscms_core_enums_agent_status_type
import command_v11_client.models.keyfactor_web_keyfactor_api_models_templates_global_global_template_settings_request as kf_keyfactor_web_keyfactor_api_models_templates_global_global_template_settings_request
import command_v11_client.models.keyfactor_web_keyfactor_api_models_templates_template_enrollment_field_request_response_model as kf_keyfactor_web_keyfactor_api_models_templates_template_enrollment_field_request_response_model
import command_v11_client.models.keyfactor_web_keyfactor_api_models_alerts_key_rotation_key_rotation_alert_test_request as kf_keyfactor_web_keyfactor_api_models_alerts_key_rotation_key_rotation_alert_test_request
import command_v11_client.models.keyfactor_pki_enums_certificate_state as kf_keyfactor_pki_enums_certificate_state
import command_v11_client.models.keyfactor_web_keyfactor_api_models_templates_global_global_template_settings_response as kf_keyfactor_web_keyfactor_api_models_templates_global_global_template_settings_response
import command_v11_client.models.csscms_core_enums_scheduled_task_type as kf_csscms_core_enums_scheduled_task_type
import command_v11_client.models.keyfactor_web_keyfactor_api_models_reports_report_schedules_report_schedule_creation_request_runtime_parameters as kf_keyfactor_web_keyfactor_api_models_reports_report_schedules_report_schedule_creation_request_runtime_parameters
import command_v11_client.models.csscms_data_model_models_certificate_store_inventory as kf_csscms_data_model_models_certificate_store_inventory
import command_v11_client.models.keyfactor_web_keyfactor_api_models_license_license_response_licensed_customer as kf_keyfactor_web_keyfactor_api_models_license_license_response_licensed_customer
import command_v11_client.models.csscms_data_model_models_csr_generation_response_model as kf_csscms_data_model_models_csr_generation_response_model
import command_v11_client.models.csscms_data_model_models_pkcs_12_certificate_response_enrollment_context as kf_csscms_data_model_models_pkcs_12_certificate_response_enrollment_context
import command_v11_client.models.keyfactor_web_keyfactor_api_models_certificate_collections_certificate_query_access_control as kf_keyfactor_web_keyfactor_api_models_certificate_collections_certificate_query_access_control
import command_v11_client.models.keyfactor_orchestrators_common_enums_ssl_endpoint_status as kf_keyfactor_orchestrators_common_enums_ssl_endpoint_status
import command_v11_client.models.keyfactor_common_queryable_extensions_sort_order as kf_keyfactor_common_queryable_extensions_sort_order
import command_v11_client.models.keyfactor_web_keyfactor_api_models_alerts_pending_pending_alert_response as kf_keyfactor_web_keyfactor_api_models_alerts_pending_pending_alert_response
import command_v11_client.models.keyfactor_web_keyfactor_api_models_alerts_key_rotation_key_rotation_alert_test_all_request as kf_keyfactor_web_keyfactor_api_models_alerts_key_rotation_key_rotation_alert_test_all_request
import command_v11_client.models.keyfactor_web_keyfactor_api_models_alerts_pending_pending_alert_update_request as kf_keyfactor_web_keyfactor_api_models_alerts_pending_pending_alert_update_request
import command_v11_client.models.csscms_data_model_models_enrollment_management_store_type as kf_csscms_data_model_models_enrollment_management_store_type
import command_v11_client.models.keyfactor_web_keyfactor_api_models_certificates_analyze_certificate_request as kf_keyfactor_web_keyfactor_api_models_certificates_analyze_certificate_request
import command_v11_client.models.csscms_data_model_models_ssh_logons_logon_access_request as kf_csscms_data_model_models_ssh_logons_logon_access_request
import command_v11_client.models.csscms_data_model_models_enrollment_csr_enrollment_request_metadata_input as kf_csscms_data_model_models_enrollment_csr_enrollment_request_metadata_input
import command_v11_client.models.keyfactor_web_keyfactor_api_models_pam_provider_type_parameter_response as kf_keyfactor_web_keyfactor_api_models_pam_provider_type_parameter_response
import command_v11_client.models.csscms_data_model_enums_data_type as kf_csscms_data_model_enums_data_type
import command_v11_client.models.keyfactor_web_keyfactor_api_models_monitoring_revocation_monitoring_definition_response as kf_keyfactor_web_keyfactor_api_models_monitoring_revocation_monitoring_definition_response
import command_v11_client.models.keyfactor_web_keyfactor_api_models_security_security_identities_security_identity_lookup_response as kf_keyfactor_web_keyfactor_api_models_security_security_identities_security_identity_lookup_response
import command_v11_client.models.keyfactor_web_keyfactor_api_models_monitoring_revocation_monitoring_alert_test_all_request as kf_keyfactor_web_keyfactor_api_models_monitoring_revocation_monitoring_alert_test_all_request
import command_v11_client.models.csscms_data_model_enums_pam_parameter_data_type as kf_csscms_data_model_enums_pam_parameter_data_type
import command_v11_client.models.keyfactor_web_keyfactor_api_models_scheduling_scheduled_task_request as kf_keyfactor_web_keyfactor_api_models_scheduling_scheduled_task_request
import command_v11_client.models.keyfactor_web_keyfactor_api_models_workflows_available_step_query_response_signals_definition as kf_keyfactor_web_keyfactor_api_models_workflows_available_step_query_response_signals_definition
import command_v11_client.models.keyfactor_web_keyfactor_api_models_orchestrator_pools_agent_pool_agent_get_response as kf_keyfactor_web_keyfactor_api_models_orchestrator_pools_agent_pool_agent_get_response
import command_v11_client.models.keyfactor_web_keyfactor_api_models_orchestrator_jobs_unschedule_job_request as kf_keyfactor_web_keyfactor_api_models_orchestrator_jobs_unschedule_job_request
import command_v11_client.models.csscms_core_enums_cert_store_entry_parameter_type as kf_csscms_core_enums_cert_store_entry_parameter_type
import command_v11_client.models.csscms_data_model_models_pam_provider_type_param_value as kf_csscms_data_model_models_pam_provider_type_param_value
import command_v11_client.models.csscms_data_model_models_enrollment_pfx_enrollment_request as kf_csscms_data_model_models_enrollment_pfx_enrollment_request
import command_v11_client.models.keyfactor_web_keyfactor_api_models_alerts_denied_denied_alert_update_request as kf_keyfactor_web_keyfactor_api_models_alerts_denied_denied_alert_update_request
import command_v11_client.models.csscms_data_model_models_certificate_retrieval_response_metadata as kf_csscms_data_model_models_certificate_retrieval_response_metadata
import command_v11_client.models.keyfactor_web_keyfactor_api_models_reports_custom_reports_custom_report_response as kf_keyfactor_web_keyfactor_api_models_reports_custom_reports_custom_report_response
import command_v11_client.models.csscms_data_model_models_metadata_all_update_request as kf_csscms_data_model_models_metadata_all_update_request
import command_v11_client.models.keyfactor_web_keyfactor_api_models_certificate_stores_job_history_response as kf_keyfactor_web_keyfactor_api_models_certificate_stores_job_history_response
import command_v11_client.models.csscms_data_model_models_certificate_retrieval_response as kf_csscms_data_model_models_certificate_retrieval_response
import command_v11_client.models.csscms_data_model_models_cert_store_new_password_request as kf_csscms_data_model_models_cert_store_new_password_request
import command_v11_client.models.csscms_data_model_models_enrollment_available_renewal as kf_csscms_data_model_models_enrollment_available_renewal
import command_v11_client.models.csscms_data_model_models_ssl_ssl_scan_result as kf_csscms_data_model_models_ssl_ssl_scan_result
import command_v11_client.models.system_day_of_week as kf_system_day_of_week
import command_v11_client.models.keyfactor_orchestrators_common_enums_orchestrator_job_status_job_result as kf_keyfactor_orchestrators_common_enums_orchestrator_job_status_job_result
import command_v11_client.models.csscms_data_model_models_ssh_users_ssh_user_update_request as kf_csscms_data_model_models_ssh_users_ssh_user_update_request
import command_v11_client.models.keyfactor_web_keyfactor_api_models_certificate_authorities_certificate_authority_test_response as kf_keyfactor_web_keyfactor_api_models_certificate_authorities_certificate_authority_test_response
import command_v11_client.models.keyfactor_web_keyfactor_api_models_app_settings_app_setting_update_request as kf_keyfactor_web_keyfactor_api_models_app_settings_app_setting_update_request
import command_v11_client.models.csscms_data_model_models_certificate_store_server_response as kf_csscms_data_model_models_certificate_store_server_response
import command_v11_client.models.keyfactor_web_keyfactor_api_models_ssl_update_network_request as kf_keyfactor_web_keyfactor_api_models_ssl_update_network_request
import command_v11_client.models.csscms_data_model_models_ssh_logons_logon_creation_request as kf_csscms_data_model_models_ssh_logons_logon_creation_request
import command_v11_client.models.csscms_data_model_models_ssh_users_ssh_user_creation_request as kf_csscms_data_model_models_ssh_users_ssh_user_creation_request
import command_v11_client.models.keyfactor_web_keyfactor_api_models_security_legacy_security_roles_security_my_response as kf_keyfactor_web_keyfactor_api_models_security_legacy_security_roles_security_my_response
import command_v11_client.models.keyfactor_web_keyfactor_api_models_pam_provider_create_request_provider_type_param as kf_keyfactor_web_keyfactor_api_models_pam_provider_create_request_provider_type_param
import command_v11_client.models.keyfactor_web_keyfactor_api_models_certificate_store_containers_certificate_store_container_response as kf_keyfactor_web_keyfactor_api_models_certificate_store_containers_certificate_store_container_response
import command_v11_client.models.csscms_data_model_enums_certificate_saved_state as kf_csscms_data_model_enums_certificate_saved_state
import command_v11_client.models.keyfactor_web_keyfactor_api_models_pam_provider_type_create_request as kf_keyfactor_web_keyfactor_api_models_pam_provider_type_create_request
import command_v11_client.models.keyfactor_web_keyfactor_api_models_workflows_definition_step_response as kf_keyfactor_web_keyfactor_api_models_workflows_definition_step_response
import command_v11_client.models.keyfactor_web_keyfactor_api_models_security_security_role_permissions_container_permission_response as kf_keyfactor_web_keyfactor_api_models_security_security_role_permissions_container_permission_response
import command_v11_client.models.csscms_data_model_models_cert_stores_schedule as kf_csscms_data_model_models_cert_stores_schedule
import command_v11_client.models.keyfactor_web_keyfactor_api_models_certificate_collections_certificate_collection_create_request as kf_keyfactor_web_keyfactor_api_models_certificate_collections_certificate_collection_create_request
import command_v11_client.models.keyfactor_web_keyfactor_api_models_reports_custom_reports_custom_report_creation_request as kf_keyfactor_web_keyfactor_api_models_reports_custom_reports_custom_report_creation_request
import command_v11_client.models.csscms_data_model_models_ssh_users_ssh_user_response as kf_csscms_data_model_models_ssh_users_ssh_user_response
import command_v11_client.models.keyfactor_web_keyfactor_api_models_workflows_instance_response_initial_data as kf_keyfactor_web_keyfactor_api_models_workflows_instance_response_initial_data
import command_v11_client.models.csscms_data_model_models_ssh_keys_key_generation_request as kf_csscms_data_model_models_ssh_keys_key_generation_request
import command_v11_client.models.keyfactor_web_keyfactor_api_models_reports_report_schedules_report_schedule_creation_request as kf_keyfactor_web_keyfactor_api_models_reports_report_schedules_report_schedule_creation_request
import command_v11_client.models.csscms_data_model_models_templates_algorithms_algorithm_data as kf_csscms_data_model_models_templates_algorithms_algorithm_data
import command_v11_client.models.keyfactor_web_keyfactor_api_models_reports_report_schedules_report_schedule_response_runtime_parameters as kf_keyfactor_web_keyfactor_api_models_reports_report_schedules_report_schedule_response_runtime_parameters
import command_v11_client.models.keyfactor_web_keyfactor_api_models_scripts_scripts_update_request as kf_keyfactor_web_keyfactor_api_models_scripts_scripts_update_request
import command_v11_client.models.keyfactor_web_keyfactor_api_models_smtpsmtp_test_response as kf_keyfactor_web_keyfactor_api_models_smtpsmtp_test_response
import command_v11_client.models.keyfactor_web_keyfactor_api_models_scheduling_scheduled_task_response as kf_keyfactor_web_keyfactor_api_models_scheduling_scheduled_task_response
import command_v11_client.models.csscms_data_model_models_enrollment_existing_enrollment_management_request as kf_csscms_data_model_models_enrollment_existing_enrollment_management_request
import command_v11_client.models.csscms_data_model_models_ssh_keys_key_response as kf_csscms_data_model_models_ssh_keys_key_response
import command_v11_client.models.csscms_data_model_models_orchestrator_jobs_job_type_field_request as kf_csscms_data_model_models_orchestrator_jobs_job_type_field_request
import command_v11_client.models.csscms_data_model_models_ssh_keys_key_update_request as kf_csscms_data_model_models_ssh_keys_key_update_request
import command_v11_client.models.keyfactor_web_keyfactor_api_models_security_security_role_permissions_collection_permission_request as kf_keyfactor_web_keyfactor_api_models_security_security_role_permissions_collection_permission_request
import command_v11_client.models.csscms_data_model_models_discovery_job_request as kf_csscms_data_model_models_discovery_job_request
import command_v11_client.models.keyfactor_web_keyfactor_api_models_certificate_authorities_ca_alert_recipient_create_request as kf_keyfactor_web_keyfactor_api_models_certificate_authorities_ca_alert_recipient_create_request
import command_v11_client.models.keyfactor_web_keyfactor_api_models_certificate_stores_remove_certificate_request as kf_keyfactor_web_keyfactor_api_models_certificate_stores_remove_certificate_request
import command_v11_client.models.csscms_data_model_models_ssh_access_logon_user_access_request as kf_csscms_data_model_models_ssh_access_logon_user_access_request
import command_v11_client.models.csscms_data_model_models_ssh_keys_unmanaged_key_response as kf_csscms_data_model_models_ssh_keys_unmanaged_key_response
import command_v11_client.models.keyfactor_web_keyfactor_api_models_certificate_authorities_ca_alert_recipient_update_request as kf_keyfactor_web_keyfactor_api_models_certificate_authorities_ca_alert_recipient_update_request
import command_v11_client.models.keyfactor_web_keyfactor_api_models_identity_provider_identity_provider_response as kf_keyfactor_web_keyfactor_api_models_identity_provider_identity_provider_response
import command_v11_client.models.csscms_core_enums_template_enrollment_field_type as kf_csscms_core_enums_template_enrollment_field_type
import command_v11_client.models.csscms_data_model_models_ssh_access_logon_user_access_response as kf_csscms_data_model_models_ssh_access_logon_user_access_response
import command_v11_client.models.csscms_data_model_models_enrollment_pfx_enrollment_request_sa_ns as kf_csscms_data_model_models_enrollment_pfx_enrollment_request_sa_ns
import command_v11_client.models.csscms_data_model_models_certificate_authorities_certificate_authority_auth_certificate as kf_csscms_data_model_models_certificate_authorities_certificate_authority_auth_certificate
import command_v11_client.models.keyfactor_web_keyfactor_api_models_workflows_parameter_definition_response_potential_values as kf_keyfactor_web_keyfactor_api_models_workflows_parameter_definition_response_potential_values
import command_v11_client.models.keyfactor_web_keyfactor_api_models_alerts_expiration_expiration_alert_update_request as kf_keyfactor_web_keyfactor_api_models_alerts_expiration_expiration_alert_update_request
import command_v11_client.models.csscms_data_model_enums_cert_store_types_password_styles as kf_csscms_data_model_enums_cert_store_types_password_styles
import command_v11_client.models.keyfactor_platform_extensions_ca_sync_type as kf_keyfactor_platform_extensions_ca_sync_type
import command_v11_client.models.keyfactor_web_keyfactor_api_models_monitoring_revocation_monitoring_update_request as kf_keyfactor_web_keyfactor_api_models_monitoring_revocation_monitoring_update_request
import command_v11_client.models.keyfactor_web_keyfactor_api_models_security_security_role_permissions_pam_provider_permission_response as kf_keyfactor_web_keyfactor_api_models_security_security_role_permissions_pam_provider_permission_response
import command_v11_client.models.keyfactor_web_keyfactor_api_models_workflows_workflow_type_query_response as kf_keyfactor_web_keyfactor_api_models_workflows_workflow_type_query_response
import command_v11_client.models.keyfactor_web_keyfactor_api_models_security_role_claim_definitions_role_claim_definition_provider_response as kf_keyfactor_web_keyfactor_api_models_security_role_claim_definitions_role_claim_definition_provider_response
import command_v11_client.models.keyfactor_web_keyfactor_api_models_enrollment_management_store_request_properties as kf_keyfactor_web_keyfactor_api_models_enrollment_management_store_request_properties
import command_v11_client.models.keyfactor_web_keyfactor_api_models_certificate_stores_types_certificate_store_type_update_request as kf_keyfactor_web_keyfactor_api_models_certificate_stores_types_certificate_store_type_update_request
import command_v11_client.models.keyfactor_web_keyfactor_api_models_alerts_alert_schedule_alert_schedule_request as kf_keyfactor_web_keyfactor_api_models_alerts_alert_schedule_alert_schedule_request
import command_v11_client.models.csscms_data_model_models_certificate_stores_certificate_store_create_request as kf_csscms_data_model_models_certificate_stores_certificate_store_create_request
import command_v11_client.models.csscms_data_model_models_enrollment_csr_enrollment_response as kf_csscms_data_model_models_enrollment_csr_enrollment_response
import command_v11_client.models.keyfactor_web_core_models_enrollment_enrollment_template_policy as kf_keyfactor_web_core_models_enrollment_enrollment_template_policy
import command_v11_client.models.keyfactor_web_keyfactor_api_models_orchestrator_pools_agent_pool_update_request as kf_keyfactor_web_keyfactor_api_models_orchestrator_pools_agent_pool_update_request
import command_v11_client.models.keyfactor_web_keyfactor_api_models_alerts_key_rotation_key_rotation_alert_definition_response as kf_keyfactor_web_keyfactor_api_models_alerts_key_rotation_key_rotation_alert_definition_response
import command_v11_client.models.csscms_data_model_models_ssl_network_definition as kf_csscms_data_model_models_ssl_network_definition
import command_v11_client.models.keyfactor_web_keyfactor_api_models_metadata_field_metadata_field_response as kf_keyfactor_web_keyfactor_api_models_metadata_field_metadata_field_response
import command_v11_client.models.keyfactor_web_keyfactor_api_models_workflows_definition_update_request as kf_keyfactor_web_keyfactor_api_models_workflows_definition_update_request
import command_v11_client.models.keyfactor_web_keyfactor_api_models_certificates_cert_request_response_model_metadata as kf_keyfactor_web_keyfactor_api_models_certificates_cert_request_response_model_metadata
import command_v11_client.models.keyfactor_web_keyfactor_api_models_security_security_role_permissions_global_permission_response as kf_keyfactor_web_keyfactor_api_models_security_security_role_permissions_global_permission_response
import command_v11_client.models.keyfactor_orchestrators_common_enums_ssl_job_type as kf_keyfactor_orchestrators_common_enums_ssl_job_type
import command_v11_client.models.csscms_data_model_models_certificate_authorities_certificate_authority_scheduled_task as kf_csscms_data_model_models_certificate_authorities_certificate_authority_scheduled_task
import command_v11_client.models.keyfactor_web_keyfactor_api_models_identity_provider_identity_provider_update_request as kf_keyfactor_web_keyfactor_api_models_identity_provider_identity_provider_update_request
import command_v11_client.models.keyfactor_web_keyfactor_api_models_certificate_collections_assignable_query_role as kf_keyfactor_web_keyfactor_api_models_certificate_collections_assignable_query_role
import command_v11_client.models.keyfactor_web_keyfactor_api_models_orchestrator_pools_agent_pool_get_response as kf_keyfactor_web_keyfactor_api_models_orchestrator_pools_agent_pool_get_response
import command_v11_client.models.keyfactor_orchestrators_common_enums_ssl_probe_type as kf_keyfactor_orchestrators_common_enums_ssl_probe_type
import command_v11_client.models.keyfactor_web_keyfactor_api_models_workflows_instance_query_response as kf_keyfactor_web_keyfactor_api_models_workflows_instance_query_response
import command_v11_client.models.keyfactor_web_keyfactor_api_models_orchestrators_agent_blueprint_response as kf_keyfactor_web_keyfactor_api_models_orchestrators_agent_blueprint_response
import command_v11_client.models.csscms_data_model_models_templates_template_enrollment_field as kf_csscms_data_model_models_templates_template_enrollment_field
import command_v11_client.models.keyfactor_web_keyfactor_api_models_templates_global_global_template_policy_request as kf_keyfactor_web_keyfactor_api_models_templates_global_global_template_policy_request
import command_v11_client.models.keyfactor_web_keyfactor_api_models_monitoring_email_response as kf_keyfactor_web_keyfactor_api_models_monitoring_email_response
import command_v11_client.models.csscms_data_model_models_certificate_details_metadata as kf_csscms_data_model_models_certificate_details_metadata
import command_v11_client.models.keyfactor_auditing_querying_audit_log_entry as kf_keyfactor_auditing_querying_audit_log_entry
import command_v11_client.models.keyfactor_web_keyfactor_api_models_identity_provider_identity_provider_parameter_update_request as kf_keyfactor_web_keyfactor_api_models_identity_provider_identity_provider_parameter_update_request
import command_v11_client.models.csscms_core_enums_orchestrator_auth_certificate_reenrollment as kf_csscms_core_enums_orchestrator_auth_certificate_reenrollment
import command_v11_client.models.keyfactor_web_keyfactor_api_models_security_role_claim_definitions_security_role_for_claim_response as kf_keyfactor_web_keyfactor_api_models_security_role_claim_definitions_security_role_for_claim_response
import command_v11_client.models.keyfactor_web_keyfactor_api_models_enrollment_management_store_type_request as kf_keyfactor_web_keyfactor_api_models_enrollment_management_store_type_request
import command_v11_client.models.keyfactor_web_keyfactor_api_models_ssl_create_network_request as kf_keyfactor_web_keyfactor_api_models_ssl_create_network_request
import command_v11_client.models.csscms_data_model_models_ssh_access_server_access_response as kf_csscms_data_model_models_ssh_access_server_access_response
import command_v11_client.models.csscms_data_model_models_ssh_access_server_access_request as kf_csscms_data_model_models_ssh_access_server_access_request
import command_v11_client.models.csscms_data_model_models_orchestrator_jobs_job_type_create_request as kf_csscms_data_model_models_orchestrator_jobs_job_type_create_request
import command_v11_client.models.keyfactor_web_keyfactor_api_models_alerts_denied_denied_alert_creation_request as kf_keyfactor_web_keyfactor_api_models_alerts_denied_denied_alert_creation_request
import command_v11_client.models.csscms_data_model_models_ssl_endpoint_status_request as kf_csscms_data_model_models_ssl_endpoint_status_request
import command_v11_client.models.csscms_data_model_models_certificate_import_response_model as kf_csscms_data_model_models_certificate_import_response_model
import command_v11_client.models.keyfactor_web_keyfactor_api_models_templates_template_update_request as kf_keyfactor_web_keyfactor_api_models_templates_template_update_request
import command_v11_client.models.keyfactor_web_keyfactor_api_models_workflows_available_step_response_signals_definition as kf_keyfactor_web_keyfactor_api_models_workflows_available_step_response_signals_definition
import command_v11_client.models.keyfactor_web_keyfactor_api_models_security_security_identity_permissions_permission_roles_pair_response as kf_keyfactor_web_keyfactor_api_models_security_security_identity_permissions_permission_roles_pair_response
import command_v11_client.models.keyfactor_web_keyfactor_api_models_app_settings_app_setting_update_bulk_request as kf_keyfactor_web_keyfactor_api_models_app_settings_app_setting_update_bulk_request
import command_v11_client.models.keyfactor_workflows_data_type as kf_keyfactor_workflows_data_type
import command_v11_client.models.keyfactor_web_keyfactor_api_models_alerts_pending_pending_alert_test_all_request as kf_keyfactor_web_keyfactor_api_models_alerts_pending_pending_alert_test_all_request
import command_v11_client.models.csscms_data_model_models_enrollment_csr_enrollment_response_metadata as kf_csscms_data_model_models_enrollment_csr_enrollment_response_metadata
import command_v11_client.models.keyfactor_web_keyfactor_api_models_orchestrators_update_orchestrator_auth_certificate_reenrollment_response as kf_keyfactor_web_keyfactor_api_models_orchestrators_update_orchestrator_auth_certificate_reenrollment_response
import command_v11_client.models.keyfactor_web_keyfactor_api_models_security_role_claim_definitions_role_claim_definition_creation_request as kf_keyfactor_web_keyfactor_api_models_security_role_claim_definitions_role_claim_definition_creation_request
import command_v11_client.models.keyfactor_web_keyfactor_api_models_event_handler_event_handler_parameter_request as kf_keyfactor_web_keyfactor_api_models_event_handler_event_handler_parameter_request
import command_v11_client.models.keyfactor_web_keyfactor_api_models_templates_template_default_request_response_model as kf_keyfactor_web_keyfactor_api_models_templates_template_default_request_response_model
import command_v11_client.models.csscms_data_model_models_pkcs_10_certificate_response_enrollment_context as kf_csscms_data_model_models_pkcs_10_certificate_response_enrollment_context
import command_v11_client.models.csscms_core_enums_certificate_store_type_property_type as kf_csscms_core_enums_certificate_store_type_property_type
import command_v11_client.models.keyfactor_web_keyfactor_api_models_security_security_identity_permissions_security_identity_permissions_response as kf_keyfactor_web_keyfactor_api_models_security_security_identity_permissions_security_identity_permissions_response
import command_v11_client.models.keyfactor_web_keyfactor_api_models_workflows_available_step_query_response as kf_keyfactor_web_keyfactor_api_models_workflows_available_step_query_response
import command_v11_client.models.keyfactor_web_keyfactor_api_models_workflows_definition_step_response_outputs as kf_keyfactor_web_keyfactor_api_models_workflows_definition_step_response_outputs
import command_v11_client.models.csscms_data_model_models_certificate_store_entry_job_fields as kf_csscms_data_model_models_certificate_store_entry_job_fields
import command_v11_client.models.csscms_data_model_models_templates_template_metadata_field as kf_csscms_data_model_models_templates_template_metadata_field
import command_v11_client.models.csscms_data_model_models_ssh_access_server_group_access_response as kf_csscms_data_model_models_ssh_access_server_group_access_response
import command_v11_client.models.csscms_data_model_models_certificate_retrieval_response_location_count_model as kf_csscms_data_model_models_certificate_retrieval_response_location_count_model
import command_v11_client.models.keyfactor_web_keyfactor_api_models_certificates_certificate_identity_audit_response_certificate_permission as kf_keyfactor_web_keyfactor_api_models_certificates_certificate_identity_audit_response_certificate_permission
import command_v11_client.models.keyfactor_web_keyfactor_api_models_metadata_field_metadata_field_create_request as kf_keyfactor_web_keyfactor_api_models_metadata_field_metadata_field_create_request
import command_v11_client.models.csscms_data_model_models_ssh_servers_server_update_request as kf_csscms_data_model_models_ssh_servers_server_update_request
import command_v11_client.models.keyfactor_web_keyfactor_api_models_security_role_claim_definitions_role_claim_definition_response as kf_keyfactor_web_keyfactor_api_models_security_role_claim_definitions_role_claim_definition_response
import command_v11_client.models.csscms_data_model_models_enrollment_pfx_enrollment_request_additional_enrollment_fields_input as kf_csscms_data_model_models_enrollment_pfx_enrollment_request_additional_enrollment_fields_input
import command_v11_client.models.keyfactor_web_keyfactor_api_models_smtpsmtp_response as kf_keyfactor_web_keyfactor_api_models_smtpsmtp_response
import command_v11_client.models.keyfactor_web_keyfactor_api_models_orchestrator_jobs_job_field_response as kf_keyfactor_web_keyfactor_api_models_orchestrator_jobs_job_field_response
import command_v11_client.models.csscms_data_model_models_certificate_location_specifier_job_fields as kf_csscms_data_model_models_certificate_location_specifier_job_fields
import command_v11_client.models.keyfactor_web_keyfactor_api_models_orchestrator_jobs_job_response as kf_keyfactor_web_keyfactor_api_models_orchestrator_jobs_job_response
import command_v11_client.models.csscms_data_model_models_report_schedule as kf_csscms_data_model_models_report_schedule
import command_v11_client.models.keyfactor_web_keyfactor_api_models_license_license_response_license as kf_keyfactor_web_keyfactor_api_models_license_license_response_license
import command_v11_client.models.keyfactor_web_keyfactor_api_models_reports_report_schedules_report_schedule_response as kf_keyfactor_web_keyfactor_api_models_reports_report_schedules_report_schedule_response
import command_v11_client.models.keyfactor_web_keyfactor_api_models_workflows_instance_response_current_state_data as kf_keyfactor_web_keyfactor_api_models_workflows_instance_response_current_state_data
import command_v11_client.models.keyfactor_web_keyfactor_api_models_orchestrator_jobs_custom_job_result_data_response as kf_keyfactor_web_keyfactor_api_models_orchestrator_jobs_custom_job_result_data_response
import command_v11_client.models.keyfactor_web_keyfactor_api_models_certificate_stores_certificate_store_response as kf_keyfactor_web_keyfactor_api_models_certificate_stores_certificate_store_response
import command_v11_client.models.csscms_data_model_models_metadata_single_update_request as kf_csscms_data_model_models_metadata_single_update_request
import command_v11_client.models.csscms_data_model_models_ssl_network_ranges_request as kf_csscms_data_model_models_ssl_network_ranges_request
import command_v11_client.models.keyfactor_web_keyfactor_api_models_certificate_collections_certificate_collection_permissions_response as kf_keyfactor_web_keyfactor_api_models_certificate_collections_certificate_collection_permissions_response
import command_v11_client.models.keyfactor_web_keyfactor_api_models_alerts_key_rotation_key_rotation_alert_test_response as kf_keyfactor_web_keyfactor_api_models_alerts_key_rotation_key_rotation_alert_test_response
import command_v11_client.models.csscms_data_model_models_provider_type as kf_csscms_data_model_models_provider_type
import command_v11_client.models.keyfactor_web_keyfactor_api_models_workflows_signal_request as kf_keyfactor_web_keyfactor_api_models_workflows_signal_request
import command_v11_client.models.csscms_data_model_models_crl_request_model as kf_csscms_data_model_models_crl_request_model
import command_v11_client.models.keyfactor_web_keyfactor_api_models_security_security_role_permissions_container_permission_request as kf_keyfactor_web_keyfactor_api_models_security_security_role_permissions_container_permission_request
import command_v11_client.models.csscms_data_model_models_workflow_denial_request as kf_csscms_data_model_models_workflow_denial_request
import command_v11_client.models.csscms_data_model_models_certificate_retrieval_response_subject_alternative_name_model as kf_csscms_data_model_models_certificate_retrieval_response_subject_alternative_name_model
import command_v11_client.models.keyfactor_web_keyfactor_api_models_alerts_expiration_expiration_alert_test_request as kf_keyfactor_web_keyfactor_api_models_alerts_expiration_expiration_alert_test_request
import command_v11_client.models.keyfactor_web_keyfactor_api_models_alerts_alert_certificate_query_alert_certificate_query_response as kf_keyfactor_web_keyfactor_api_models_alerts_alert_certificate_query_alert_certificate_query_response
import command_v11_client.models.keyfactor_web_keyfactor_api_models_security_security_identities_security_identity_request as kf_keyfactor_web_keyfactor_api_models_security_security_identities_security_identity_request
import command_v11_client.models.csscms_data_model_models_certificate_retrieval_response_certificate_store_location_detail_model as kf_csscms_data_model_models_certificate_retrieval_response_certificate_store_location_detail_model
import command_v11_client.models.csscms_data_model_models_enrollment_pfx_enrollment_response as kf_csscms_data_model_models_enrollment_pfx_enrollment_response
import command_v11_client.models.csscms_data_model_models_certificate_store_create_server_request as kf_csscms_data_model_models_certificate_store_create_server_request
import command_v11_client.models.keyfactor_web_keyfactor_api_models_pam_provider_update_request_legacy as kf_keyfactor_web_keyfactor_api_models_pam_provider_update_request_legacy
import command_v11_client.models.csscms_data_model_models_ssl_immediate_ssl_scan_request as kf_csscms_data_model_models_ssl_immediate_ssl_scan_request
import command_v11_client.models.csscms_core_enums_enrollment_type as kf_csscms_core_enums_enrollment_type
import command_v11_client.models.csscms_data_model_models_recovery_response as kf_csscms_data_model_models_recovery_response
import command_v11_client.models.keyfactor_pki_enums_certificate_collection_order as kf_keyfactor_pki_enums_certificate_collection_order
import command_v11_client.models.keyfactor_web_keyfactor_api_models_smtpsmtp_request as kf_keyfactor_web_keyfactor_api_models_smtpsmtp_request
import command_v11_client.models.keyfactor_web_keyfactor_api_models_certificate_collections_certificate_collection_favorite_request as kf_keyfactor_web_keyfactor_api_models_certificate_collections_certificate_collection_favorite_request
import command_v11_client.models.csscms_data_model_enums_identity_provider_data_type as kf_csscms_data_model_enums_identity_provider_data_type
import command_v11_client.models.keyfactor_web_keyfactor_api_models_enrollment_enrollment_management_request as kf_keyfactor_web_keyfactor_api_models_enrollment_enrollment_management_request
import command_v11_client.models.csscms_data_model_models_metadata_update_request as kf_csscms_data_model_models_metadata_update_request
import command_v11_client.models.keyfactor_web_keyfactor_api_models_workflows_instance_definition_response as kf_keyfactor_web_keyfactor_api_models_workflows_instance_definition_response
import command_v11_client.models.keyfactor_workflows_workflow_instance_status as kf_keyfactor_workflows_workflow_instance_status
import command_v11_client.models.keyfactor_web_keyfactor_api_models_workflows_definition_response as kf_keyfactor_web_keyfactor_api_models_workflows_definition_response
import command_v11_client.models.keyfactor_web_keyfactor_api_models_monitoring_ocsp_parameters_request as kf_keyfactor_web_keyfactor_api_models_monitoring_ocsp_parameters_request
import command_v11_client.models.keyfactor_web_keyfactor_api_models_workflows_instance_response as kf_keyfactor_web_keyfactor_api_models_workflows_instance_response
import command_v11_client.models.keyfactor_web_keyfactor_api_models_smtpsmtp_test_request as kf_keyfactor_web_keyfactor_api_models_smtpsmtp_test_request
import command_v11_client.models.keyfactor_web_keyfactor_api_models_configuration_tenant_configuration_tenant_request as kf_keyfactor_web_keyfactor_api_models_configuration_tenant_configuration_tenant_request
import command_v11_client.models.keyfactor_web_keyfactor_api_models_event_handler_registered_event_handler_request as kf_keyfactor_web_keyfactor_api_models_event_handler_registered_event_handler_request
import command_v11_client.models.keyfactor_pkipki_constants_x509_subject_alt_name_element_type as kf_keyfactor_pkipki_constants_x509_subject_alt_name_element_type
import command_v11_client.models.csscms_data_model_models_certificate_store_inventory_certificates_metadata as kf_csscms_data_model_models_certificate_store_inventory_certificates_metadata
import command_v11_client.models.csscms_core_enums_report_parameter_visibility as kf_csscms_core_enums_report_parameter_visibility
import command_v11_client.models.keyfactor_web_keyfactor_api_models_enrollment_enrollment_management_response as kf_keyfactor_web_keyfactor_api_models_enrollment_enrollment_management_response
import command_v11_client.models.csscms_data_model_models_enrollment_csr_enrollment_request_additional_enrollment_fields_input as kf_csscms_data_model_models_enrollment_csr_enrollment_request_additional_enrollment_fields_input
import command_v11_client.models.csscms_core_enums_cert_store_private_key as kf_csscms_core_enums_cert_store_private_key
import command_v11_client.models.csscms_data_model_models_metadata_field_type_model as kf_csscms_data_model_models_metadata_field_type_model
import command_v11_client.models.csscms_data_model_models_reenrollment_status as kf_csscms_data_model_models_reenrollment_status
import command_v11_client.models.csscms_core_enums_certificate_authority_type as kf_csscms_core_enums_certificate_authority_type
import command_v11_client.models.csscms_data_model_models_enrollment_pfx_enrollment_request_metadata as kf_csscms_data_model_models_enrollment_pfx_enrollment_request_metadata
import command_v11_client.models.keyfactor_web_keyfactor_api_models_workflows_signal_definition_response as kf_keyfactor_web_keyfactor_api_models_workflows_signal_definition_response
import command_v11_client.models.keyfactor_web_keyfactor_api_models_license_license_response_licensed_feature as kf_keyfactor_web_keyfactor_api_models_license_license_response_licensed_feature
import command_v11_client.models.keyfactor_web_keyfactor_api_models_orchestrator_jobs_bulk_job_response as kf_keyfactor_web_keyfactor_api_models_orchestrator_jobs_bulk_job_response
import command_v11_client.models.csscms_data_model_enums_private_key_status as kf_csscms_data_model_enums_private_key_status
import command_v11_client.models.keyfactor_web_keyfactor_api_models_certificates_certificate_recovery_request as kf_keyfactor_web_keyfactor_api_models_certificates_certificate_recovery_request
import command_v11_client.models.csscms_data_model_enums_certificate_import_job_status as kf_csscms_data_model_enums_certificate_import_job_status
import command_v11_client.models.csscms_data_model_models_metadata_update_request_metadata as kf_csscms_data_model_models_metadata_update_request_metadata
import command_v11_client.models.csscms_core_enums_key_retention_policy as kf_csscms_core_enums_key_retention_policy
import command_v11_client.models.keyfactor_web_core_models_enrollment_enrollment_ca as kf_keyfactor_web_core_models_enrollment_enrollment_ca
import command_v11_client.models.csscms_data_model_models_certificate_store_inventory_certificates as kf_csscms_data_model_models_certificate_store_inventory_certificates
import command_v11_client.models.csscms_data_model_models_certificate_authorities_certificate_authority_test_request as kf_csscms_data_model_models_certificate_authorities_certificate_authority_test_request
import command_v11_client.models.keyfactor_web_keyfactor_api_models_ssl_network_query_response as kf_keyfactor_web_keyfactor_api_models_ssl_network_query_response
import command_v11_client.models.keyfactor_web_keyfactor_api_models_orchestrator_pools_agent_pool_agent_creation_request as kf_keyfactor_web_keyfactor_api_models_orchestrator_pools_agent_pool_agent_creation_request
import command_v11_client.models.csscms_data_model_models_certificate_store_container_list_response as kf_csscms_data_model_models_certificate_store_container_list_response
import command_v11_client.models.keyfactor_web_keyfactor_api_models_certificate_stores_reenrollment_request as kf_keyfactor_web_keyfactor_api_models_certificate_stores_reenrollment_request
import command_v11_client.models.keyfactor_orchestrators_common_enums_orchestrator_job_status_job_status as kf_keyfactor_orchestrators_common_enums_orchestrator_job_status_job_status
import command_v11_client.models.csscms_data_model_models_orchestrator_jobs_job_type_update_request as kf_csscms_data_model_models_orchestrator_jobs_job_type_update_request
import command_v11_client.models.keyfactor_web_keyfactor_api_models_security_security_role_permissions_collection_permission_response as kf_keyfactor_web_keyfactor_api_models_security_security_role_permissions_collection_permission_response
import command_v11_client.models.csscms_data_model_models_provider as kf_csscms_data_model_models_provider
import command_v11_client.models.keyfactor_web_keyfactor_api_models_workflows_condition_configuration_request as kf_keyfactor_web_keyfactor_api_models_workflows_condition_configuration_request
import command_v11_client.models.keyfactor_common_scheduling_models_interval_model as kf_keyfactor_common_scheduling_models_interval_model
import command_v11_client.models.csscms_data_model_models_enrollment_csr_enrollment_request_metadata as kf_csscms_data_model_models_enrollment_csr_enrollment_request_metadata
import command_v11_client.models.csscms_data_model_models_orchestrator_jobs_schedule_bulk_job_request as kf_csscms_data_model_models_orchestrator_jobs_schedule_bulk_job_request
import command_v11_client.models.keyfactor_web_keyfactor_api_models_alerts_issued_issued_alert_creation_request as kf_keyfactor_web_keyfactor_api_models_alerts_issued_issued_alert_creation_request
import command_v11_client.models.keyfactor_web_keyfactor_api_models_certificates_certificate_download_request as kf_keyfactor_web_keyfactor_api_models_certificates_certificate_download_request
import command_v11_client.models.keyfactor_pki_enums_revoke_code as kf_keyfactor_pki_enums_revoke_code
import command_v11_client.models.csscms_data_model_models_workflow_processed_certificate_request as kf_csscms_data_model_models_workflow_processed_certificate_request
import command_v11_client.models.keyfactor_web_keyfactor_api_models_scripts_script_response as kf_keyfactor_web_keyfactor_api_models_scripts_script_response
import command_v11_client.models.csscms_data_model_models_security_security_roles_security_role_response_base as kf_csscms_data_model_models_security_security_roles_security_role_response_base
import command_v11_client.models.csscms_data_model_models_ssh_servers_server_creation_request as kf_csscms_data_model_models_ssh_servers_server_creation_request
import command_v11_client.models.csscms_data_model_models_certificate_validation_response_results as kf_csscms_data_model_models_certificate_validation_response_results
import command_v11_client.models.keyfactor_web_keyfactor_api_models_pam_pam_provider_type_param_value_response as kf_keyfactor_web_keyfactor_api_models_pam_pam_provider_type_param_value_response
import command_v11_client.models.keyfactor_web_keyfactor_api_models_templates_template_collection_retrieval_response as kf_keyfactor_web_keyfactor_api_models_templates_template_collection_retrieval_response
import command_v11_client.models.keyfactor_web_keyfactor_api_models_templates_template_regex_request_response_model as kf_keyfactor_web_keyfactor_api_models_templates_template_regex_request_response_model
import command_v11_client.models.keyfactor_web_keyfactor_api_models_workflows_signal_configuration_request as kf_keyfactor_web_keyfactor_api_models_workflows_signal_configuration_request
import command_v11_client.models.csscms_data_model_models_enrollment_csr_enrollment_request as kf_csscms_data_model_models_enrollment_csr_enrollment_request
import command_v11_client.models.keyfactor_web_keyfactor_api_models_enrollment_management_store_request as kf_keyfactor_web_keyfactor_api_models_enrollment_management_store_request
import command_v11_client.models.keyfactor_web_keyfactor_api_models_workflows_available_step_query_response_configuration_parameters_definition as kf_keyfactor_web_keyfactor_api_models_workflows_available_step_query_response_configuration_parameters_definition
import command_v11_client.models.csscms_data_model_models_certificate_details as kf_csscms_data_model_models_certificate_details
import command_v11_client.models.csscms_data_model_models_enrollment_pfx_enrollment_request_metadata_input as kf_csscms_data_model_models_enrollment_pfx_enrollment_request_metadata_input
import command_v11_client.models.csscms_data_model_models_report_request_model as kf_csscms_data_model_models_report_request_model
import command_v11_client.models.csscms_data_model_enums_ssh_private_key_format as kf_csscms_data_model_enums_ssh_private_key_format
import command_v11_client.models.keyfactor_web_keyfactor_api_models_scripts_script_create_request as kf_keyfactor_web_keyfactor_api_models_scripts_script_create_request
import command_v11_client.models.keyfactor_web_keyfactor_api_models_templates_enrollment_template_enrollment_regex_response as kf_keyfactor_web_keyfactor_api_models_templates_enrollment_template_enrollment_regex_response
import command_v11_client.models.keyfactor_web_keyfactor_api_models_alerts_pending_pending_alert_test_response as kf_keyfactor_web_keyfactor_api_models_alerts_pending_pending_alert_test_response
import command_v11_client.models.csscms_data_model_models_workflow_certificate_request_cert_store_model as kf_csscms_data_model_models_workflow_certificate_request_cert_store_model
import command_v11_client.models.keyfactor_web_keyfactor_api_models_identity_provider_provider_type_response as kf_keyfactor_web_keyfactor_api_models_identity_provider_provider_type_response
import command_v11_client.models.keyfactor_web_keyfactor_api_models_alerts_key_rotation_key_rotation_alert_creation_request as kf_keyfactor_web_keyfactor_api_models_alerts_key_rotation_key_rotation_alert_creation_request
import command_v11_client.models.keyfactor_web_keyfactor_api_models_event_handler_registration_event_handler_registration_create_request as kf_keyfactor_web_keyfactor_api_models_event_handler_registration_event_handler_registration_create_request
import command_v11_client.models.keyfactor_web_keyfactor_api_models_monitoring_revocation_monitoring_alert_test_request as kf_keyfactor_web_keyfactor_api_models_monitoring_revocation_monitoring_alert_test_request
import command_v11_client.models.keyfactor_web_keyfactor_api_models_security_security_role_permissions_global_permission_request as kf_keyfactor_web_keyfactor_api_models_security_security_role_permissions_global_permission_request
import command_v11_client.models.csscms_data_model_models_certificate_retrieval_response_certificate_store_inventory_item_model as kf_csscms_data_model_models_certificate_retrieval_response_certificate_store_inventory_item_model
import command_v11_client.models.keyfactor_web_keyfactor_api_models_security_legacy_security_roles_security_role_response as kf_keyfactor_web_keyfactor_api_models_security_legacy_security_roles_security_role_response
import command_v11_client.models.keyfactor_web_keyfactor_api_models_pam_provider_type_response as kf_keyfactor_web_keyfactor_api_models_pam_provider_type_response
import command_v11_client.models.keyfactor_web_keyfactor_api_models_security_legacy_security_roles_role_identities_response as kf_keyfactor_web_keyfactor_api_models_security_legacy_security_roles_role_identities_response
import command_v11_client.models.keyfactor_web_keyfactor_api_models_alerts_alert_template_alert_template_response as kf_keyfactor_web_keyfactor_api_models_alerts_alert_template_alert_template_response
import command_v11_client.models.keyfactor_web_keyfactor_api_models_pam_provider_create_request_type_param_value as kf_keyfactor_web_keyfactor_api_models_pam_provider_create_request_type_param_value
import command_v11_client.models.keyfactor_web_keyfactor_api_models_templates_global_global_template_default_request as kf_keyfactor_web_keyfactor_api_models_templates_global_global_template_default_request
import command_v11_client.models.csscms_data_model_models_enrollment_renewal_response as kf_csscms_data_model_models_enrollment_renewal_response
import command_v11_client.models.keyfactor_web_keyfactor_api_models_certificate_collections_certificate_collection_response as kf_keyfactor_web_keyfactor_api_models_certificate_collections_certificate_collection_response
import command_v11_client.models.keyfactor_web_keyfactor_api_models_identity_provider_provider_type_parameter_value_response as kf_keyfactor_web_keyfactor_api_models_identity_provider_provider_type_parameter_value_response
import command_v11_client.models.keyfactor_web_keyfactor_api_models_workflows_definition_step_request as kf_keyfactor_web_keyfactor_api_models_workflows_definition_step_request
import command_v11_client.models.keyfactor_web_keyfactor_api_models_certificate_collections_certificate_collection_list_response as kf_keyfactor_web_keyfactor_api_models_certificate_collections_certificate_collection_list_response
import command_v11_client.models.csscms_data_model_models_report as kf_csscms_data_model_models_report
import command_v11_client.models.csscms_data_model_models_ssh_server_groups_server_group_update_request as kf_csscms_data_model_models_ssh_server_groups_server_group_update_request
import command_v11_client.models.keyfactor_web_keyfactor_api_models_certificate_stores_certificate_store_approve_request as kf_keyfactor_web_keyfactor_api_models_certificate_stores_certificate_store_approve_request
import command_v11_client.models.csscms_data_model_models_workflow_approve_deny_result as kf_csscms_data_model_models_workflow_approve_deny_result
import command_v11_client.models.keyfactor_web_keyfactor_api_models_permission_sets_permission_set_response as kf_keyfactor_web_keyfactor_api_models_permission_sets_permission_set_response
import command_v11_client.models.csscms_core_permissions_web_console_area_permission as kf_csscms_core_permissions_web_console_area_permission
import command_v11_client.models.keyfactor_web_keyfactor_api_models_templates_enrollment_template_enrollment_default_response as kf_keyfactor_web_keyfactor_api_models_templates_enrollment_template_enrollment_default_response
import command_v11_client.models.csscms_data_model_models_pki_certificate_operation as kf_csscms_data_model_models_pki_certificate_operation
import command_v11_client.models.csscms_data_model_models_ssh_service_accounts_service_account_update_request as kf_csscms_data_model_models_ssh_service_accounts_service_account_update_request
import command_v11_client.models.csscms_core_enums_metadata_data_type as kf_csscms_core_enums_metadata_data_type

def normalize(arg):
  return None if arg is None else arg.to_dict()

def getJson(filename):
  f = open(filename,"r")
  contents = f.read()
  f.close()
  data = json.loads(contents)
  return data

try:
    config = getJson(os.environ.get('KEYFACTOR_CONFIG', "environment.json"))
except FileNotFoundError:
    config = {
        "host": os.environ.get('KEYFACTOR_HOSTNAME', ""),
        "username": os.environ.get('KEYFACTOR_USERNAME', ""),
        "password": os.environ.get('KEYFACTOR_PASSWORD', ""),
        "domain": os.environ.get('KEYFACTOR_DOMAIN', ""),
        "scheme": os.environ.get('KEYFACTOR_SCHEME', "https"),
        "URLbase": os.environ.get('KEYFACTOR_URLBASE', "KeyfactorAPI"),
        "token": os.environ.get('KEYFACTOR_TOKEN', ""),
        "tokenURL":os.environ.get('COMMAND_IDP_TOKENURL',""),
        "clientId":os.environ.get("COMMAND_IDP_CLIENTID",""),
        "clientSecret":os.environ.get("COMMAND_IDP_CLIENTSECRET","")

    }
scheme = config.get("scheme", "https")
host = config["host"]
URLBase = config.get("URLbase", "KeyfactorAPI")
token = config.get("token")
if not token:
    username = config.get("username")
    password = config.get("password")
    domain = config.get("domain")
    token = base64.b64encode(f"{username}:{password}".encode('utf-8')).decode('utf-8')

kfclient = keyfactor.client.AuthenticatedClient(base_url=f"{scheme}://{host}/{URLBase}",
                                                   prefix="Basic", token=token, verify_ssl=True)
if len(config["tokenURL"]) > 0:
    kfclient._idp_args["tokenURL"] = config["tokenURL"]
    kfclient._idp_args["clientId"] = config["clientId"]
    kfclient._idp_args["clientSecret"] = config["clientSecret"]


def put_reports_id_schedules_(sync=True, **kwargs):
  if sync:
    return kf_put_reports_id_schedules.sync(client=kfclient,**kwargs)

def delete_reports_custom_id_(sync=True, **kwargs):
  if sync:
    return kf_delete_reports_custom_id.sync(client=kfclient,**kwargs)

def post_reports_id_schedules_(sync=True, **kwargs):
  if sync:
    return kf_post_reports_id_schedules.sync(client=kfclient,**kwargs)

def post_reports_custom_(sync=True, **kwargs):
  if sync:
    return kf_post_reports_custom.sync(client=kfclient,**kwargs)

def put_reports_(sync=True, **kwargs):
  if sync:
    return kf_put_reports.sync(client=kfclient,**kwargs)

def get_reports_id_(sync=True, **kwargs):
  if sync:
    return kf_get_reports_id.sync(client=kfclient,**kwargs)

def get_reports_id_schedules_(sync=True, **kwargs):
  if sync:
    return kf_get_reports_id_schedules.sync(client=kfclient,**kwargs)

def get_reports_custom_id_(sync=True, **kwargs):
  if sync:
    return kf_get_reports_custom_id.sync(client=kfclient,**kwargs)

def put_reports_custom_(sync=True, **kwargs):
  if sync:
    return kf_put_reports_custom.sync(client=kfclient,**kwargs)

def put_reports_id_parameters_(sync=True, **kwargs):
  if sync:
    return kf_put_reports_id_parameters.sync(client=kfclient,**kwargs)

def get_reports_custom_(sync=True, **kwargs):
  if sync:
    return kf_get_reports_custom.sync(client=kfclient,**kwargs)

def get_reports_(sync=True, **kwargs):
  if sync:
    return kf_get_reports.sync(client=kfclient,**kwargs)

def get_reports_schedules_id_(sync=True, **kwargs):
  if sync:
    return kf_get_reports_schedules_id.sync(client=kfclient,**kwargs)

def delete_reports_schedules_id_(sync=True, **kwargs):
  if sync:
    return kf_delete_reports_schedules_id.sync(client=kfclient,**kwargs)

def get_reports_id_parameters_(sync=True, **kwargs):
  if sync:
    return kf_get_reports_id_parameters.sync(client=kfclient,**kwargs)

def post_ssh_server_groups_(sync=True, **kwargs):
  if sync:
    return kf_post_ssh_server_groups.sync(client=kfclient,**kwargs)

def put_ssh_server_groups_(sync=True, **kwargs):
  if sync:
    return kf_put_ssh_server_groups.sync(client=kfclient,**kwargs)

def get_ssh_server_groups_(sync=True, **kwargs):
  if sync:
    return kf_get_ssh_server_groups.sync(client=kfclient,**kwargs)

def delete_ssh_server_groups_id_(sync=True, **kwargs):
  if sync:
    return kf_delete_ssh_server_groups_id.sync(client=kfclient,**kwargs)

def get_ssh_server_groups_access_id_(sync=True, **kwargs):
  if sync:
    return kf_get_ssh_server_groups_access_id.sync(client=kfclient,**kwargs)

def post_ssh_server_groups_access_(sync=True, **kwargs):
  if sync:
    return kf_post_ssh_server_groups_access.sync(client=kfclient,**kwargs)

def delete_ssh_server_groups_access_(sync=True, **kwargs):
  if sync:
    return kf_delete_ssh_server_groups_access.sync(client=kfclient,**kwargs)

def get_ssh_server_groups_id_(sync=True, **kwargs):
  if sync:
    return kf_get_ssh_server_groups_id.sync(client=kfclient,**kwargs)

def get_ssh_server_groups_name_(sync=True, **kwargs):
  if sync:
    return kf_get_ssh_server_groups_name.sync(client=kfclient,**kwargs)

def post_enrollment_renew_(sync=True, **kwargs):
  if sync:
    return kf_post_enrollment_renew.sync(client=kfclient,**kwargs)

def post_enrollment_csr_parse_(sync=True, **kwargs):
  if sync:
    return kf_post_enrollment_csr_parse.sync(client=kfclient,**kwargs)

def post_enrollment_pfx_deploy_(sync=True, **kwargs):
  if sync:
    return kf_post_enrollment_pfx_deploy.sync(client=kfclient,**kwargs)

def post_enrollment_pfx_replace_(sync=True, **kwargs):
  if sync:
    return kf_post_enrollment_pfx_replace.sync(client=kfclient,**kwargs)

def post_enrollment_csr_(sync=True, **kwargs):
  if sync:
    return kf_post_enrollment_csr.sync(client=kfclient,**kwargs)

def get_enrollment_settings_id_(sync=True, **kwargs):
  if sync:
    return kf_get_enrollment_settings_id.sync(client=kfclient,**kwargs)

def get_enrollment_csr_context_my_(sync=True, **kwargs):
  if sync:
    return kf_get_enrollment_csr_context_my.sync(client=kfclient,**kwargs)

def get_enrollment_available_renewal_thumbprint_thumbprint_(sync=True, **kwargs):
  if sync:
    return kf_get_enrollment_available_renewal_thumbprint_thumbprint.sync(client=kfclient,**kwargs)

def get_enrollment_available_renewal_id_id_(sync=True, **kwargs):
  if sync:
    return kf_get_enrollment_available_renewal_id_id.sync(client=kfclient,**kwargs)

def post_enrollment_pfx_(sync=True, **kwargs):
  if sync:
    return kf_post_enrollment_pfx.sync(client=kfclient,**kwargs)

def get_enrollment_pfx_context_my_(sync=True, **kwargs):
  if sync:
    return kf_get_enrollment_pfx_context_my.sync(client=kfclient,**kwargs)

def put_certificate_store_containers_(sync=True, **kwargs):
  if sync:
    return kf_put_certificate_store_containers.sync(client=kfclient,**kwargs)

def get_certificate_store_containers_(sync=True, **kwargs):
  if sync:
    return kf_get_certificate_store_containers.sync(client=kfclient,**kwargs)

def get_certificate_store_containers_id_(sync=True, **kwargs):
  if sync:
    return kf_get_certificate_store_containers_id.sync(client=kfclient,**kwargs)

def delete_certificate_store_containers_id_(sync=True, **kwargs):
  if sync:
    return kf_delete_certificate_store_containers_id.sync(client=kfclient,**kwargs)

def post_certificate_store_containers_(sync=True, **kwargs):
  if sync:
    return kf_post_certificate_store_containers.sync(client=kfclient,**kwargs)

def post_job_types_custom_(sync=True, **kwargs):
  if sync:
    return kf_post_job_types_custom.sync(client=kfclient,**kwargs)

def get_job_types_custom_(sync=True, **kwargs):
  if sync:
    return kf_get_job_types_custom.sync(client=kfclient,**kwargs)

def put_job_types_custom_(sync=True, **kwargs):
  if sync:
    return kf_put_job_types_custom.sync(client=kfclient,**kwargs)

def get_job_types_custom_id_(sync=True, **kwargs):
  if sync:
    return kf_get_job_types_custom_id.sync(client=kfclient,**kwargs)

def delete_job_types_custom_id_(sync=True, **kwargs):
  if sync:
    return kf_delete_job_types_custom_id.sync(client=kfclient,**kwargs)

def delete_ssh_service_accounts_(sync=True, **kwargs):
  if sync:
    return kf_delete_ssh_service_accounts.sync(client=kfclient,**kwargs)

def get_ssh_service_accounts_(sync=True, **kwargs):
  if sync:
    return kf_get_ssh_service_accounts.sync(client=kfclient,**kwargs)

def put_ssh_service_accounts_(sync=True, **kwargs):
  if sync:
    return kf_put_ssh_service_accounts.sync(client=kfclient,**kwargs)

def post_ssh_service_accounts_(sync=True, **kwargs):
  if sync:
    return kf_post_ssh_service_accounts.sync(client=kfclient,**kwargs)

def post_ssh_service_accounts_rotate_id_(sync=True, **kwargs):
  if sync:
    return kf_post_ssh_service_accounts_rotate_id.sync(client=kfclient,**kwargs)

def delete_ssh_service_accounts_id_(sync=True, **kwargs):
  if sync:
    return kf_delete_ssh_service_accounts_id.sync(client=kfclient,**kwargs)

def get_ssh_service_accounts_id_(sync=True, **kwargs):
  if sync:
    return kf_get_ssh_service_accounts_id.sync(client=kfclient,**kwargs)

def get_ssh_service_accounts_key_id_(sync=True, **kwargs):
  if sync:
    return kf_get_ssh_service_accounts_key_id.sync(client=kfclient,**kwargs)

def get_event_handler_registration_id_(sync=True, **kwargs):
  if sync:
    return kf_get_event_handler_registration_id.sync(client=kfclient,**kwargs)

def put_event_handler_registration_id_(sync=True, **kwargs):
  if sync:
    return kf_put_event_handler_registration_id.sync(client=kfclient,**kwargs)

def post_event_handler_registration_(sync=True, **kwargs):
  if sync:
    return kf_post_event_handler_registration.sync(client=kfclient,**kwargs)

def get_event_handler_registration_(sync=True, **kwargs):
  if sync:
    return kf_get_event_handler_registration.sync(client=kfclient,**kwargs)

def delete_event_handler_registration_id_(sync=True, **kwargs):
  if sync:
    return kf_delete_event_handler_registration_id.sync(client=kfclient,**kwargs)

def post_scheduling_(sync=True, **kwargs):
  if sync:
    return kf_post_scheduling.sync(client=kfclient,**kwargs)

def get_app_setting_id_(sync=True, **kwargs):
  if sync:
    return kf_get_app_setting_id.sync(client=kfclient,**kwargs)

def put_app_setting_id_set_(sync=True, **kwargs):
  if sync:
    return kf_put_app_setting_id_set.sync(client=kfclient,**kwargs)

def put_app_setting_name_set_(sync=True, **kwargs):
  if sync:
    return kf_put_app_setting_name_set.sync(client=kfclient,**kwargs)

def get_app_setting_(sync=True, **kwargs):
  if sync:
    return kf_get_app_setting.sync(client=kfclient,**kwargs)

def put_app_setting_(sync=True, **kwargs):
  if sync:
    return kf_put_app_setting.sync(client=kfclient,**kwargs)

def delete_ssh_servers_access_(sync=True, **kwargs):
  if sync:
    return kf_delete_ssh_servers_access.sync(client=kfclient,**kwargs)

def get_ssh_servers_(sync=True, **kwargs):
  if sync:
    return kf_get_ssh_servers.sync(client=kfclient,**kwargs)

def delete_ssh_servers_id_(sync=True, **kwargs):
  if sync:
    return kf_delete_ssh_servers_id.sync(client=kfclient,**kwargs)

def get_ssh_servers_id_(sync=True, **kwargs):
  if sync:
    return kf_get_ssh_servers_id.sync(client=kfclient,**kwargs)

def post_ssh_servers_access_(sync=True, **kwargs):
  if sync:
    return kf_post_ssh_servers_access.sync(client=kfclient,**kwargs)

def put_ssh_servers_(sync=True, **kwargs):
  if sync:
    return kf_put_ssh_servers.sync(client=kfclient,**kwargs)

def post_ssh_servers_(sync=True, **kwargs):
  if sync:
    return kf_post_ssh_servers.sync(client=kfclient,**kwargs)

def get_ssh_servers_access_id_(sync=True, **kwargs):
  if sync:
    return kf_get_ssh_servers_access_id.sync(client=kfclient,**kwargs)

def post_templates_import_(sync=True, **kwargs):
  if sync:
    return kf_post_templates_import.sync(client=kfclient,**kwargs)

def get_templates_id_(sync=True, **kwargs):
  if sync:
    return kf_get_templates_id.sync(client=kfclient,**kwargs)

def get_templates_subject_parts_(sync=True, **kwargs):
  if sync:
    return kf_get_templates_subject_parts.sync(client=kfclient,**kwargs)

def get_templates_(sync=True, **kwargs):
  if sync:
    return kf_get_templates.sync(client=kfclient,**kwargs)

def get_templates_settings_(sync=True, **kwargs):
  if sync:
    return kf_get_templates_settings.sync(client=kfclient,**kwargs)

def put_templates_(sync=True, **kwargs):
  if sync:
    return kf_put_templates.sync(client=kfclient,**kwargs)

def put_templates_settings_(sync=True, **kwargs):
  if sync:
    return kf_put_templates_settings.sync(client=kfclient,**kwargs)

def post_monitoring_resolve_ocsp_(sync=True, **kwargs):
  if sync:
    return kf_post_monitoring_resolve_ocsp.sync(client=kfclient,**kwargs)

def post_monitoring_revocation_test_(sync=True, **kwargs):
  if sync:
    return kf_post_monitoring_revocation_test.sync(client=kfclient,**kwargs)

def get_monitoring_revocation_id_(sync=True, **kwargs):
  if sync:
    return kf_get_monitoring_revocation_id.sync(client=kfclient,**kwargs)

def delete_monitoring_revocation_id_(sync=True, **kwargs):
  if sync:
    return kf_delete_monitoring_revocation_id.sync(client=kfclient,**kwargs)

def post_monitoring_revocation_(sync=True, **kwargs):
  if sync:
    return kf_post_monitoring_revocation.sync(client=kfclient,**kwargs)

def put_monitoring_revocation_(sync=True, **kwargs):
  if sync:
    return kf_put_monitoring_revocation.sync(client=kfclient,**kwargs)

def get_monitoring_revocation_(sync=True, **kwargs):
  if sync:
    return kf_get_monitoring_revocation.sync(client=kfclient,**kwargs)

def post_monitoring_revocation_test_all_(sync=True, **kwargs):
  if sync:
    return kf_post_monitoring_revocation_test_all.sync(client=kfclient,**kwargs)

def post_ssh_users_(sync=True, **kwargs):
  if sync:
    return kf_post_ssh_users.sync(client=kfclient,**kwargs)

def put_ssh_users_(sync=True, **kwargs):
  if sync:
    return kf_put_ssh_users.sync(client=kfclient,**kwargs)

def get_ssh_users_id_(sync=True, **kwargs):
  if sync:
    return kf_get_ssh_users_id.sync(client=kfclient,**kwargs)

def get_ssh_users_(sync=True, **kwargs):
  if sync:
    return kf_get_ssh_users.sync(client=kfclient,**kwargs)

def post_ssh_users_access_(sync=True, **kwargs):
  if sync:
    return kf_post_ssh_users_access.sync(client=kfclient,**kwargs)

def delete_ssh_users_id_(sync=True, **kwargs):
  if sync:
    return kf_delete_ssh_users_id.sync(client=kfclient,**kwargs)

def put_ssl_endpoints_monitor_status_(sync=True, **kwargs):
  if sync:
    return kf_put_ssl_endpoints_monitor_status.sync(client=kfclient,**kwargs)

def delete_ssl_network_ranges_id_(sync=True, **kwargs):
  if sync:
    return kf_delete_ssl_network_ranges_id.sync(client=kfclient,**kwargs)

def get_ssl_networks_(sync=True, **kwargs):
  if sync:
    return kf_get_ssl_networks.sync(client=kfclient,**kwargs)

def put_ssl_endpoints_review_all_(sync=True, **kwargs):
  if sync:
    return kf_put_ssl_endpoints_review_all.sync(client=kfclient,**kwargs)

def delete_ssl_networks_id_(sync=True, **kwargs):
  if sync:
    return kf_delete_ssl_networks_id.sync(client=kfclient,**kwargs)

def get_ssl_parts_id_(sync=True, **kwargs):
  if sync:
    return kf_get_ssl_parts_id.sync(client=kfclient,**kwargs)

def put_ssl_networks_(sync=True, **kwargs):
  if sync:
    return kf_put_ssl_networks.sync(client=kfclient,**kwargs)

def get_ssl_endpoints_id_(sync=True, **kwargs):
  if sync:
    return kf_get_ssl_endpoints_id.sync(client=kfclient,**kwargs)

def get_ssl_network_ranges_id_(sync=True, **kwargs):
  if sync:
    return kf_get_ssl_network_ranges_id.sync(client=kfclient,**kwargs)

def post_ssl_networks_(sync=True, **kwargs):
  if sync:
    return kf_post_ssl_networks.sync(client=kfclient,**kwargs)

def post_ssl_networks_id_reset_(sync=True, **kwargs):
  if sync:
    return kf_post_ssl_networks_id_reset.sync(client=kfclient,**kwargs)

def get_ssl_(sync=True, **kwargs):
  if sync:
    return kf_get_ssl.sync(client=kfclient,**kwargs)

def post_ssl_networks_id_scan_(sync=True, **kwargs):
  if sync:
    return kf_post_ssl_networks_id_scan.sync(client=kfclient,**kwargs)

def put_ssl_endpoints_review_status_(sync=True, **kwargs):
  if sync:
    return kf_put_ssl_endpoints_review_status.sync(client=kfclient,**kwargs)

def put_ssl_endpoints_monitor_all_(sync=True, **kwargs):
  if sync:
    return kf_put_ssl_endpoints_monitor_all.sync(client=kfclient,**kwargs)

def get_ssl_endpoints_id_history_(sync=True, **kwargs):
  if sync:
    return kf_get_ssl_endpoints_id_history.sync(client=kfclient,**kwargs)

def post_ssl_network_ranges_validate_(sync=True, **kwargs):
  if sync:
    return kf_post_ssl_network_ranges_validate.sync(client=kfclient,**kwargs)

def post_ssl_network_ranges_(sync=True, **kwargs):
  if sync:
    return kf_post_ssl_network_ranges.sync(client=kfclient,**kwargs)

def put_ssl_network_ranges_(sync=True, **kwargs):
  if sync:
    return kf_put_ssl_network_ranges.sync(client=kfclient,**kwargs)

def get_ssl_networks_id_parts_(sync=True, **kwargs):
  if sync:
    return kf_get_ssl_networks_id_parts.sync(client=kfclient,**kwargs)

def get_ssl_networks_identifier_(sync=True, **kwargs):
  if sync:
    return kf_get_ssl_networks_identifier.sync(client=kfclient,**kwargs)

def get_certificates_(sync=True, **kwargs):
  if sync:
    return kf_get_certificates.sync(client=kfclient,**kwargs)

def post_certificates_import_(sync=True, **kwargs):
  if sync:
    return kf_post_certificates_import.sync(client=kfclient,**kwargs)

def get_certificates_id_security_(sync=True, **kwargs):
  if sync:
    return kf_get_certificates_id_security.sync(client=kfclient,**kwargs)

def post_certificates_recover_(sync=True, **kwargs):
  if sync:
    return kf_post_certificates_recover.sync(client=kfclient,**kwargs)

def delete_certificates_(sync=True, **kwargs):
  if sync:
    return kf_delete_certificates.sync(client=kfclient,**kwargs)

def get_certificates_id_(sync=True, **kwargs):
  if sync:
    return kf_get_certificates_id.sync(client=kfclient,**kwargs)

def put_certificates_metadata_all_(sync=True, **kwargs):
  if sync:
    return kf_put_certificates_metadata_all.sync(client=kfclient,**kwargs)

def get_certificates_id_validate_(sync=True, **kwargs):
  if sync:
    return kf_get_certificates_id_validate.sync(client=kfclient,**kwargs)

def delete_certificates_private_key_id_(sync=True, **kwargs):
  if sync:
    return kf_delete_certificates_private_key_id.sync(client=kfclient,**kwargs)

def delete_certificates_id_(sync=True, **kwargs):
  if sync:
    return kf_delete_certificates_id.sync(client=kfclient,**kwargs)

def get_certificates_identity_audit_id_(sync=True, **kwargs):
  if sync:
    return kf_get_certificates_identity_audit_id.sync(client=kfclient,**kwargs)

def delete_certificates_query_(sync=True, **kwargs):
  if sync:
    return kf_delete_certificates_query.sync(client=kfclient,**kwargs)

def post_certificates_revoke_(sync=True, **kwargs):
  if sync:
    return kf_post_certificates_revoke.sync(client=kfclient,**kwargs)

def delete_certificates_private_key_(sync=True, **kwargs):
  if sync:
    return kf_delete_certificates_private_key.sync(client=kfclient,**kwargs)

def post_certificates_analyze_(sync=True, **kwargs):
  if sync:
    return kf_post_certificates_analyze.sync(client=kfclient,**kwargs)

def get_certificates_locations_id_(sync=True, **kwargs):
  if sync:
    return kf_get_certificates_locations_id.sync(client=kfclient,**kwargs)

def post_certificates_download_(sync=True, **kwargs):
  if sync:
    return kf_post_certificates_download.sync(client=kfclient,**kwargs)

def get_certificates_csv_(sync=True, **kwargs):
  if sync:
    return kf_get_certificates_csv.sync(client=kfclient,**kwargs)

def put_certificates_metadata_(sync=True, **kwargs):
  if sync:
    return kf_put_certificates_metadata.sync(client=kfclient,**kwargs)

def get_certificates_metadata_compare_(sync=True, **kwargs):
  if sync:
    return kf_get_certificates_metadata_compare.sync(client=kfclient,**kwargs)

def get_certificates_id_history_(sync=True, **kwargs):
  if sync:
    return kf_get_certificates_id_history.sync(client=kfclient,**kwargs)

def post_workflow_certificates_deny_(sync=True, **kwargs):
  if sync:
    return kf_post_workflow_certificates_deny.sync(client=kfclient,**kwargs)

def get_workflow_certificates_pending_(sync=True, **kwargs):
  if sync:
    return kf_get_workflow_certificates_pending.sync(client=kfclient,**kwargs)

def get_workflow_certificates_external_validation_(sync=True, **kwargs):
  if sync:
    return kf_get_workflow_certificates_external_validation.sync(client=kfclient,**kwargs)

def get_workflow_certificates_denied_(sync=True, **kwargs):
  if sync:
    return kf_get_workflow_certificates_denied.sync(client=kfclient,**kwargs)

def post_workflow_certificates_approve_(sync=True, **kwargs):
  if sync:
    return kf_post_workflow_certificates_approve.sync(client=kfclient,**kwargs)

def get_workflow_certificates_id_(sync=True, **kwargs):
  if sync:
    return kf_get_workflow_certificates_id.sync(client=kfclient,**kwargs)

def get_component_installation_(sync=True, **kwargs):
  if sync:
    return kf_get_component_installation.sync(client=kfclient,**kwargs)

def delete_component_installation_id_(sync=True, **kwargs):
  if sync:
    return kf_delete_component_installation_id.sync(client=kfclient,**kwargs)

def get_security_claims_(sync=True, **kwargs):
  if sync:
    return kf_get_security_claims.sync(client=kfclient,**kwargs)

def post_security_claims_(sync=True, **kwargs):
  if sync:
    return kf_post_security_claims.sync(client=kfclient,**kwargs)

def delete_security_claims_id_(sync=True, **kwargs):
  if sync:
    return kf_delete_security_claims_id.sync(client=kfclient,**kwargs)

def get_security_claims_roles_(sync=True, **kwargs):
  if sync:
    return kf_get_security_claims_roles.sync(client=kfclient,**kwargs)

def put_security_claims_(sync=True, **kwargs):
  if sync:
    return kf_put_security_claims.sync(client=kfclient,**kwargs)

def get_security_claims_id_(sync=True, **kwargs):
  if sync:
    return kf_get_security_claims_id.sync(client=kfclient,**kwargs)

def delete_permission_sets_id_(sync=True, **kwargs):
  if sync:
    return kf_delete_permission_sets_id.sync(client=kfclient,**kwargs)

def put_permission_sets_(sync=True, **kwargs):
  if sync:
    return kf_put_permission_sets.sync(client=kfclient,**kwargs)

def get_permission_sets_(sync=True, **kwargs):
  if sync:
    return kf_get_permission_sets.sync(client=kfclient,**kwargs)

def get_permission_sets_id_(sync=True, **kwargs):
  if sync:
    return kf_get_permission_sets_id.sync(client=kfclient,**kwargs)

def post_permission_sets_(sync=True, **kwargs):
  if sync:
    return kf_post_permission_sets.sync(client=kfclient,**kwargs)

def post_orchestrator_jobs_custom_(sync=True, **kwargs):
  if sync:
    return kf_post_orchestrator_jobs_custom.sync(client=kfclient,**kwargs)

def post_orchestrator_jobs_acknowledge_(sync=True, **kwargs):
  if sync:
    return kf_post_orchestrator_jobs_acknowledge.sync(client=kfclient,**kwargs)

def get_orchestrator_jobs_job_status_data_(sync=True, **kwargs):
  if sync:
    return kf_get_orchestrator_jobs_job_status_data.sync(client=kfclient,**kwargs)

def get_orchestrator_jobs_scheduled_jobs_(sync=True, **kwargs):
  if sync:
    return kf_get_orchestrator_jobs_scheduled_jobs.sync(client=kfclient,**kwargs)

def post_orchestrator_jobs_custom_bulk_(sync=True, **kwargs):
  if sync:
    return kf_post_orchestrator_jobs_custom_bulk.sync(client=kfclient,**kwargs)

def get_orchestrator_jobs_job_history_(sync=True, **kwargs):
  if sync:
    return kf_get_orchestrator_jobs_job_history.sync(client=kfclient,**kwargs)

def post_orchestrator_jobs_reschedule_(sync=True, **kwargs):
  if sync:
    return kf_post_orchestrator_jobs_reschedule.sync(client=kfclient,**kwargs)

def post_orchestrator_jobs_unschedule_(sync=True, **kwargs):
  if sync:
    return kf_post_orchestrator_jobs_unschedule.sync(client=kfclient,**kwargs)

def post_ssh_logons_access_(sync=True, **kwargs):
  if sync:
    return kf_post_ssh_logons_access.sync(client=kfclient,**kwargs)

def post_ssh_logons_(sync=True, **kwargs):
  if sync:
    return kf_post_ssh_logons.sync(client=kfclient,**kwargs)

def get_ssh_logons_id_(sync=True, **kwargs):
  if sync:
    return kf_get_ssh_logons_id.sync(client=kfclient,**kwargs)

def delete_ssh_logons_id_(sync=True, **kwargs):
  if sync:
    return kf_delete_ssh_logons_id.sync(client=kfclient,**kwargs)

def get_ssh_logons_(sync=True, **kwargs):
  if sync:
    return kf_get_ssh_logons.sync(client=kfclient,**kwargs)

def put_alerts_pending_schedule_(sync=True, **kwargs):
  if sync:
    return kf_put_alerts_pending_schedule.sync(client=kfclient,**kwargs)

def post_alerts_pending_test_all_(sync=True, **kwargs):
  if sync:
    return kf_post_alerts_pending_test_all.sync(client=kfclient,**kwargs)

def get_alerts_pending_(sync=True, **kwargs):
  if sync:
    return kf_get_alerts_pending.sync(client=kfclient,**kwargs)

def get_alerts_pending_id_(sync=True, **kwargs):
  if sync:
    return kf_get_alerts_pending_id.sync(client=kfclient,**kwargs)

def post_alerts_pending_(sync=True, **kwargs):
  if sync:
    return kf_post_alerts_pending.sync(client=kfclient,**kwargs)

def put_alerts_pending_(sync=True, **kwargs):
  if sync:
    return kf_put_alerts_pending.sync(client=kfclient,**kwargs)

def delete_alerts_pending_id_(sync=True, **kwargs):
  if sync:
    return kf_delete_alerts_pending_id.sync(client=kfclient,**kwargs)

def get_alerts_pending_schedule_(sync=True, **kwargs):
  if sync:
    return kf_get_alerts_pending_schedule.sync(client=kfclient,**kwargs)

def post_alerts_pending_test_(sync=True, **kwargs):
  if sync:
    return kf_post_alerts_pending_test.sync(client=kfclient,**kwargs)

def post_agent_pools_(sync=True, **kwargs):
  if sync:
    return kf_post_agent_pools.sync(client=kfclient,**kwargs)

def get_agent_pools_(sync=True, **kwargs):
  if sync:
    return kf_get_agent_pools.sync(client=kfclient,**kwargs)

def get_agent_pools_id_(sync=True, **kwargs):
  if sync:
    return kf_get_agent_pools_id.sync(client=kfclient,**kwargs)

def delete_agent_pools_id_(sync=True, **kwargs):
  if sync:
    return kf_delete_agent_pools_id.sync(client=kfclient,**kwargs)

def get_agent_pools_agents_(sync=True, **kwargs):
  if sync:
    return kf_get_agent_pools_agents.sync(client=kfclient,**kwargs)

def put_agent_pools_(sync=True, **kwargs):
  if sync:
    return kf_put_agent_pools.sync(client=kfclient,**kwargs)

def get_mac_enrollment_(sync=True, **kwargs):
  if sync:
    return kf_get_mac_enrollment.sync(client=kfclient,**kwargs)

def put_mac_enrollment_(sync=True, **kwargs):
  if sync:
    return kf_put_mac_enrollment.sync(client=kfclient,**kwargs)

def get_alerts_issued_schedule_(sync=True, **kwargs):
  if sync:
    return kf_get_alerts_issued_schedule.sync(client=kfclient,**kwargs)

def put_alerts_issued_(sync=True, **kwargs):
  if sync:
    return kf_put_alerts_issued.sync(client=kfclient,**kwargs)

def delete_alerts_issued_id_(sync=True, **kwargs):
  if sync:
    return kf_delete_alerts_issued_id.sync(client=kfclient,**kwargs)

def get_alerts_issued_id_(sync=True, **kwargs):
  if sync:
    return kf_get_alerts_issued_id.sync(client=kfclient,**kwargs)

def put_alerts_issued_schedule_(sync=True, **kwargs):
  if sync:
    return kf_put_alerts_issued_schedule.sync(client=kfclient,**kwargs)

def get_alerts_issued_(sync=True, **kwargs):
  if sync:
    return kf_get_alerts_issued.sync(client=kfclient,**kwargs)

def post_alerts_issued_(sync=True, **kwargs):
  if sync:
    return kf_post_alerts_issued.sync(client=kfclient,**kwargs)

def get_agent_blue_print_id_stores_(sync=True, **kwargs):
  if sync:
    return kf_get_agent_blue_print_id_stores.sync(client=kfclient,**kwargs)

def get_agent_blue_print_id_(sync=True, **kwargs):
  if sync:
    return kf_get_agent_blue_print_id.sync(client=kfclient,**kwargs)

def delete_agent_blue_print_id_(sync=True, **kwargs):
  if sync:
    return kf_delete_agent_blue_print_id.sync(client=kfclient,**kwargs)

def post_agent_blue_print_apply_blueprint_(sync=True, **kwargs):
  if sync:
    return kf_post_agent_blue_print_apply_blueprint.sync(client=kfclient,**kwargs)

def get_agent_blue_print_(sync=True, **kwargs):
  if sync:
    return kf_get_agent_blue_print.sync(client=kfclient,**kwargs)

def get_agent_blue_print_id_jobs_(sync=True, **kwargs):
  if sync:
    return kf_get_agent_blue_print_id_jobs.sync(client=kfclient,**kwargs)

def post_agent_blue_print_generate_blue_print_(sync=True, **kwargs):
  if sync:
    return kf_post_agent_blue_print_generate_blue_print.sync(client=kfclient,**kwargs)

def get_certificate_collections_nav_items_(sync=True, **kwargs):
  if sync:
    return kf_get_certificate_collections_nav_items.sync(client=kfclient,**kwargs)

def put_certificate_collections_(sync=True, **kwargs):
  if sync:
    return kf_put_certificate_collections.sync(client=kfclient,**kwargs)

def put_certificate_collections_id_favorite_(sync=True, **kwargs):
  if sync:
    return kf_put_certificate_collections_id_favorite.sync(client=kfclient,**kwargs)

def get_certificate_collections_collection_list_(sync=True, **kwargs):
  if sync:
    return kf_get_certificate_collections_collection_list.sync(client=kfclient,**kwargs)

def get_certificate_collections_name_(sync=True, **kwargs):
  if sync:
    return kf_get_certificate_collections_name.sync(client=kfclient,**kwargs)

def delete_certificate_collections_id_(sync=True, **kwargs):
  if sync:
    return kf_delete_certificate_collections_id.sync(client=kfclient,**kwargs)

def post_certificate_collections_(sync=True, **kwargs):
  if sync:
    return kf_post_certificate_collections.sync(client=kfclient,**kwargs)

def get_certificate_collections_(sync=True, **kwargs):
  if sync:
    return kf_get_certificate_collections.sync(client=kfclient,**kwargs)

def post_certificate_collections_copy_(sync=True, **kwargs):
  if sync:
    return kf_post_certificate_collections_copy.sync(client=kfclient,**kwargs)

def get_certificate_collections_id_(sync=True, **kwargs):
  if sync:
    return kf_get_certificate_collections_id.sync(client=kfclient,**kwargs)

def get_certificate_store_types_(sync=True, **kwargs):
  if sync:
    return kf_get_certificate_store_types.sync(client=kfclient,**kwargs)

def get_certificate_store_types_name_name_(sync=True, **kwargs):
  if sync:
    return kf_get_certificate_store_types_name_name.sync(client=kfclient,**kwargs)

def put_certificate_store_types_(sync=True, **kwargs):
  if sync:
    return kf_put_certificate_store_types.sync(client=kfclient,**kwargs)

def post_certificate_store_types_(sync=True, **kwargs):
  if sync:
    return kf_post_certificate_store_types.sync(client=kfclient,**kwargs)

def delete_certificate_store_types_(sync=True, **kwargs):
  if sync:
    return kf_delete_certificate_store_types.sync(client=kfclient,**kwargs)

def delete_certificate_store_types_id_(sync=True, **kwargs):
  if sync:
    return kf_delete_certificate_store_types_id.sync(client=kfclient,**kwargs)

def get_certificate_store_types_id_(sync=True, **kwargs):
  if sync:
    return kf_get_certificate_store_types_id.sync(client=kfclient,**kwargs)

def put_smtp_(sync=True, **kwargs):
  if sync:
    return kf_put_smtp.sync(client=kfclient,**kwargs)

def get_smtp_(sync=True, **kwargs):
  if sync:
    return kf_get_smtp.sync(client=kfclient,**kwargs)

def post_smtp_test_(sync=True, **kwargs):
  if sync:
    return kf_post_smtp_test.sync(client=kfclient,**kwargs)

def get_alerts_denied_id_(sync=True, **kwargs):
  if sync:
    return kf_get_alerts_denied_id.sync(client=kfclient,**kwargs)

def get_alerts_denied_(sync=True, **kwargs):
  if sync:
    return kf_get_alerts_denied.sync(client=kfclient,**kwargs)

def post_alerts_denied_(sync=True, **kwargs):
  if sync:
    return kf_post_alerts_denied.sync(client=kfclient,**kwargs)

def delete_alerts_denied_id_(sync=True, **kwargs):
  if sync:
    return kf_delete_alerts_denied_id.sync(client=kfclient,**kwargs)

def put_alerts_denied_(sync=True, **kwargs):
  if sync:
    return kf_put_alerts_denied.sync(client=kfclient,**kwargs)

def put_alerts_key_rotation_schedule_(sync=True, **kwargs):
  if sync:
    return kf_put_alerts_key_rotation_schedule.sync(client=kfclient,**kwargs)

def delete_alerts_key_rotation_id_(sync=True, **kwargs):
  if sync:
    return kf_delete_alerts_key_rotation_id.sync(client=kfclient,**kwargs)

def get_alerts_key_rotation_schedule_(sync=True, **kwargs):
  if sync:
    return kf_get_alerts_key_rotation_schedule.sync(client=kfclient,**kwargs)

def post_alerts_key_rotation_test_all_(sync=True, **kwargs):
  if sync:
    return kf_post_alerts_key_rotation_test_all.sync(client=kfclient,**kwargs)

def get_alerts_key_rotation_id_(sync=True, **kwargs):
  if sync:
    return kf_get_alerts_key_rotation_id.sync(client=kfclient,**kwargs)

def get_alerts_key_rotation_(sync=True, **kwargs):
  if sync:
    return kf_get_alerts_key_rotation.sync(client=kfclient,**kwargs)

def post_alerts_key_rotation_test_(sync=True, **kwargs):
  if sync:
    return kf_post_alerts_key_rotation_test.sync(client=kfclient,**kwargs)

def put_alerts_key_rotation_(sync=True, **kwargs):
  if sync:
    return kf_put_alerts_key_rotation.sync(client=kfclient,**kwargs)

def post_alerts_key_rotation_(sync=True, **kwargs):
  if sync:
    return kf_post_alerts_key_rotation.sync(client=kfclient,**kwargs)

def get_security_roles_id_permissions_collections_(sync=True, **kwargs):
  if sync:
    return kf_get_security_roles_id_permissions_collections.sync(client=kfclient,**kwargs)

def get_security_roles_id_permissions_containers_(sync=True, **kwargs):
  if sync:
    return kf_get_security_roles_id_permissions_containers.sync(client=kfclient,**kwargs)

def put_security_roles_id_permissions_pam_providers_(sync=True, **kwargs):
  if sync:
    return kf_put_security_roles_id_permissions_pam_providers.sync(client=kfclient,**kwargs)

def post_security_roles_id_permissions_collections_(sync=True, **kwargs):
  if sync:
    return kf_post_security_roles_id_permissions_collections.sync(client=kfclient,**kwargs)

def post_security_roles_id_permissions_global_(sync=True, **kwargs):
  if sync:
    return kf_post_security_roles_id_permissions_global.sync(client=kfclient,**kwargs)

def post_security_roles_id_permissions_containers_(sync=True, **kwargs):
  if sync:
    return kf_post_security_roles_id_permissions_containers.sync(client=kfclient,**kwargs)

def put_security_roles_id_permissions_global_(sync=True, **kwargs):
  if sync:
    return kf_put_security_roles_id_permissions_global.sync(client=kfclient,**kwargs)

def get_security_roles_id_permissions_global_(sync=True, **kwargs):
  if sync:
    return kf_get_security_roles_id_permissions_global.sync(client=kfclient,**kwargs)

def put_security_roles_id_permissions_containers_(sync=True, **kwargs):
  if sync:
    return kf_put_security_roles_id_permissions_containers.sync(client=kfclient,**kwargs)

def put_security_roles_id_permissions_collections_(sync=True, **kwargs):
  if sync:
    return kf_put_security_roles_id_permissions_collections.sync(client=kfclient,**kwargs)

def get_security_roles_id_permissions_(sync=True, **kwargs):
  if sync:
    return kf_get_security_roles_id_permissions.sync(client=kfclient,**kwargs)

def get_security_roles_id_permissions_pam_providers_(sync=True, **kwargs):
  if sync:
    return kf_get_security_roles_id_permissions_pam_providers.sync(client=kfclient,**kwargs)

def put_extensions_scripts_(sync=True, **kwargs):
  if sync:
    return kf_put_extensions_scripts.sync(client=kfclient,**kwargs)

def delete_extensions_scripts_id_(sync=True, **kwargs):
  if sync:
    return kf_delete_extensions_scripts_id.sync(client=kfclient,**kwargs)

def get_extensions_scripts_(sync=True, **kwargs):
  if sync:
    return kf_get_extensions_scripts.sync(client=kfclient,**kwargs)

def get_extensions_scripts_id_(sync=True, **kwargs):
  if sync:
    return kf_get_extensions_scripts_id.sync(client=kfclient,**kwargs)

def post_extensions_scripts_(sync=True, **kwargs):
  if sync:
    return kf_post_extensions_scripts.sync(client=kfclient,**kwargs)

def get_ssh_keys_unmanaged_id_(sync=True, **kwargs):
  if sync:
    return kf_get_ssh_keys_unmanaged_id.sync(client=kfclient,**kwargs)

def delete_ssh_keys_unmanaged_id_(sync=True, **kwargs):
  if sync:
    return kf_delete_ssh_keys_unmanaged_id.sync(client=kfclient,**kwargs)

def get_ssh_keys_unmanaged_(sync=True, **kwargs):
  if sync:
    return kf_get_ssh_keys_unmanaged.sync(client=kfclient,**kwargs)

def get_ssh_keys_my_key_(sync=True, **kwargs):
  if sync:
    return kf_get_ssh_keys_my_key.sync(client=kfclient,**kwargs)

def put_ssh_keys_my_key_(sync=True, **kwargs):
  if sync:
    return kf_put_ssh_keys_my_key.sync(client=kfclient,**kwargs)

def delete_ssh_keys_unmanaged_(sync=True, **kwargs):
  if sync:
    return kf_delete_ssh_keys_unmanaged.sync(client=kfclient,**kwargs)

def post_ssh_keys_my_key_(sync=True, **kwargs):
  if sync:
    return kf_post_ssh_keys_my_key.sync(client=kfclient,**kwargs)

def put_alerts_expiration_(sync=True, **kwargs):
  if sync:
    return kf_put_alerts_expiration.sync(client=kfclient,**kwargs)

def get_alerts_expiration_schedule_(sync=True, **kwargs):
  if sync:
    return kf_get_alerts_expiration_schedule.sync(client=kfclient,**kwargs)

def post_alerts_expiration_test_(sync=True, **kwargs):
  if sync:
    return kf_post_alerts_expiration_test.sync(client=kfclient,**kwargs)

def delete_alerts_expiration_id_(sync=True, **kwargs):
  if sync:
    return kf_delete_alerts_expiration_id.sync(client=kfclient,**kwargs)

def post_alerts_expiration_test_all_(sync=True, **kwargs):
  if sync:
    return kf_post_alerts_expiration_test_all.sync(client=kfclient,**kwargs)

def put_alerts_expiration_schedule_(sync=True, **kwargs):
  if sync:
    return kf_put_alerts_expiration_schedule.sync(client=kfclient,**kwargs)

def post_alerts_expiration_(sync=True, **kwargs):
  if sync:
    return kf_post_alerts_expiration.sync(client=kfclient,**kwargs)

def get_alerts_expiration_(sync=True, **kwargs):
  if sync:
    return kf_get_alerts_expiration.sync(client=kfclient,**kwargs)

def get_alerts_expiration_id_(sync=True, **kwargs):
  if sync:
    return kf_get_alerts_expiration_id.sync(client=kfclient,**kwargs)

def get_status_endpoints_(sync=True, **kwargs):
  if sync:
    return kf_get_status_endpoints.sync(client=kfclient,**kwargs)

def put_security_roles_(sync=True, **kwargs):
  if sync:
    return kf_put_security_roles.sync(client=kfclient,**kwargs)

def post_security_roles_(sync=True, **kwargs):
  if sync:
    return kf_post_security_roles.sync(client=kfclient,**kwargs)

def post_security_roles_id_copy_(sync=True, **kwargs):
  if sync:
    return kf_post_security_roles_id_copy.sync(client=kfclient,**kwargs)

def get_security_roles_id_identities_(sync=True, **kwargs):
  if sync:
    return kf_get_security_roles_id_identities.sync(client=kfclient,**kwargs)

def get_security_roles_(sync=True, **kwargs):
  if sync:
    return kf_get_security_roles.sync(client=kfclient,**kwargs)

def delete_security_roles_id_(sync=True, **kwargs):
  if sync:
    return kf_delete_security_roles_id.sync(client=kfclient,**kwargs)

def get_security_roles_id_(sync=True, **kwargs):
  if sync:
    return kf_get_security_roles_id.sync(client=kfclient,**kwargs)

def put_security_roles_id_identities_(sync=True, **kwargs):
  if sync:
    return kf_put_security_roles_id_identities.sync(client=kfclient,**kwargs)

def get_certificate_authority_available_forests_(sync=True, **kwargs):
  if sync:
    return kf_get_certificate_authority_available_forests.sync(client=kfclient,**kwargs)

def post_certificate_authority_alert_recipients_ca_threshold_recipients_(sync=True, **kwargs):
  if sync:
    return kf_post_certificate_authority_alert_recipients_ca_threshold_recipients.sync(client=kfclient,**kwargs)

def get_certificate_authority_alert_recipients_ca_threshold_recipients_id_(sync=True, **kwargs):
  if sync:
    return kf_get_certificate_authority_alert_recipients_ca_threshold_recipients_id.sync(client=kfclient,**kwargs)

def post_certificate_authority_(sync=True, **kwargs):
  if sync:
    return kf_post_certificate_authority.sync(client=kfclient,**kwargs)

def post_certificate_authority_test_(sync=True, **kwargs):
  if sync:
    return kf_post_certificate_authority_test.sync(client=kfclient,**kwargs)

def delete_certificate_authority_id_(sync=True, **kwargs):
  if sync:
    return kf_delete_certificate_authority_id.sync(client=kfclient,**kwargs)

def put_certificate_authority_alert_recipients_ca_health_recipients_id_(sync=True, **kwargs):
  if sync:
    return kf_put_certificate_authority_alert_recipients_ca_health_recipients_id.sync(client=kfclient,**kwargs)

def delete_certificate_authority_alert_recipients_ca_threshold_recipients_id_(sync=True, **kwargs):
  if sync:
    return kf_delete_certificate_authority_alert_recipients_ca_threshold_recipients_id.sync(client=kfclient,**kwargs)

def get_certificate_authority_id_(sync=True, **kwargs):
  if sync:
    return kf_get_certificate_authority_id.sync(client=kfclient,**kwargs)

def get_certificate_authority_source_count_(sync=True, **kwargs):
  if sync:
    return kf_get_certificate_authority_source_count.sync(client=kfclient,**kwargs)

def post_certificate_authority_alert_recipients_ca_health_recipients_(sync=True, **kwargs):
  if sync:
    return kf_post_certificate_authority_alert_recipients_ca_health_recipients.sync(client=kfclient,**kwargs)

def put_certificate_authority_alert_recipients_ca_threshold_recipients_id_(sync=True, **kwargs):
  if sync:
    return kf_put_certificate_authority_alert_recipients_ca_threshold_recipients_id.sync(client=kfclient,**kwargs)

def post_certificate_authority_publish_crl_(sync=True, **kwargs):
  if sync:
    return kf_post_certificate_authority_publish_crl.sync(client=kfclient,**kwargs)

def get_certificate_authority_health_monitoring_schedule_(sync=True, **kwargs):
  if sync:
    return kf_get_certificate_authority_health_monitoring_schedule.sync(client=kfclient,**kwargs)

def put_certificate_authority_(sync=True, **kwargs):
  if sync:
    return kf_put_certificate_authority.sync(client=kfclient,**kwargs)

def get_certificate_authority_alert_recipients_ca_health_recipients_id_(sync=True, **kwargs):
  if sync:
    return kf_get_certificate_authority_alert_recipients_ca_health_recipients_id.sync(client=kfclient,**kwargs)

def get_certificate_authority_(sync=True, **kwargs):
  if sync:
    return kf_get_certificate_authority.sync(client=kfclient,**kwargs)

def get_certificate_authority_alert_recipients_ca_health_recipients_(sync=True, **kwargs):
  if sync:
    return kf_get_certificate_authority_alert_recipients_ca_health_recipients.sync(client=kfclient,**kwargs)

def delete_certificate_authority_alert_recipients_ca_health_recipients_id_(sync=True, **kwargs):
  if sync:
    return kf_delete_certificate_authority_alert_recipients_ca_health_recipients_id.sync(client=kfclient,**kwargs)

def post_certificate_authority_import_(sync=True, **kwargs):
  if sync:
    return kf_post_certificate_authority_import.sync(client=kfclient,**kwargs)

def get_certificate_authority_alert_recipients_ca_threshold_recipients_(sync=True, **kwargs):
  if sync:
    return kf_get_certificate_authority_alert_recipients_ca_threshold_recipients.sync(client=kfclient,**kwargs)

def get_security_identities_(sync=True, **kwargs):
  if sync:
    return kf_get_security_identities.sync(client=kfclient,**kwargs)

def get_security_identities_id_(sync=True, **kwargs):
  if sync:
    return kf_get_security_identities_id.sync(client=kfclient,**kwargs)

def post_security_containers_id_roles_(sync=True, **kwargs):
  if sync:
    return kf_post_security_containers_id_roles.sync(client=kfclient,**kwargs)

def get_security_containers_id_roles_(sync=True, **kwargs):
  if sync:
    return kf_get_security_containers_id_roles.sync(client=kfclient,**kwargs)

def delete_security_identities_id_(sync=True, **kwargs):
  if sync:
    return kf_delete_security_identities_id.sync(client=kfclient,**kwargs)

def get_security_identities_lookup_(sync=True, **kwargs):
  if sync:
    return kf_get_security_identities_lookup.sync(client=kfclient,**kwargs)

def get_security_my_(sync=True, **kwargs):
  if sync:
    return kf_get_security_my.sync(client=kfclient,**kwargs)

def post_security_identities_(sync=True, **kwargs):
  if sync:
    return kf_post_security_identities.sync(client=kfclient,**kwargs)

def get_security_audit_collections_id_(sync=True, **kwargs):
  if sync:
    return kf_get_security_audit_collections_id.sync(client=kfclient,**kwargs)

def post_certificate_stores_schedule_(sync=True, **kwargs):
  if sync:
    return kf_post_certificate_stores_schedule.sync(client=kfclient,**kwargs)

def put_certificate_stores_(sync=True, **kwargs):
  if sync:
    return kf_put_certificate_stores.sync(client=kfclient,**kwargs)

def post_certificate_stores_approve_(sync=True, **kwargs):
  if sync:
    return kf_post_certificate_stores_approve.sync(client=kfclient,**kwargs)

def post_certificate_stores_certificates_remove_(sync=True, **kwargs):
  if sync:
    return kf_post_certificate_stores_certificates_remove.sync(client=kfclient,**kwargs)

def post_certificate_stores_reenrollment_(sync=True, **kwargs):
  if sync:
    return kf_post_certificate_stores_reenrollment.sync(client=kfclient,**kwargs)

def post_certificate_stores_certificates_add_(sync=True, **kwargs):
  if sync:
    return kf_post_certificate_stores_certificates_add.sync(client=kfclient,**kwargs)

def get_certificate_stores_id_inventory_(sync=True, **kwargs):
  if sync:
    return kf_get_certificate_stores_id_inventory.sync(client=kfclient,**kwargs)

def put_certificate_stores_discovery_job_(sync=True, **kwargs):
  if sync:
    return kf_put_certificate_stores_discovery_job.sync(client=kfclient,**kwargs)

def put_certificate_stores_password_(sync=True, **kwargs):
  if sync:
    return kf_put_certificate_stores_password.sync(client=kfclient,**kwargs)

def put_certificate_stores_server_(sync=True, **kwargs):
  if sync:
    return kf_put_certificate_stores_server.sync(client=kfclient,**kwargs)

def get_certificate_stores_id_(sync=True, **kwargs):
  if sync:
    return kf_get_certificate_stores_id.sync(client=kfclient,**kwargs)

def post_certificate_stores_(sync=True, **kwargs):
  if sync:
    return kf_post_certificate_stores.sync(client=kfclient,**kwargs)

def get_certificate_stores_server_(sync=True, **kwargs):
  if sync:
    return kf_get_certificate_stores_server.sync(client=kfclient,**kwargs)

def delete_certificate_stores_(sync=True, **kwargs):
  if sync:
    return kf_delete_certificate_stores.sync(client=kfclient,**kwargs)

def delete_certificate_stores_id_(sync=True, **kwargs):
  if sync:
    return kf_delete_certificate_stores_id.sync(client=kfclient,**kwargs)

def get_certificate_stores_(sync=True, **kwargs):
  if sync:
    return kf_get_certificate_stores.sync(client=kfclient,**kwargs)

def post_certificate_stores_server_(sync=True, **kwargs):
  if sync:
    return kf_post_certificate_stores_server.sync(client=kfclient,**kwargs)

def put_certificate_stores_assign_container_(sync=True, **kwargs):
  if sync:
    return kf_put_certificate_stores_assign_container.sync(client=kfclient,**kwargs)

def get_license_(sync=True, **kwargs):
  if sync:
    return kf_get_license.sync(client=kfclient,**kwargs)

def post_agents_reset_(sync=True, **kwargs):
  if sync:
    return kf_post_agents_reset.sync(client=kfclient,**kwargs)

def get_agents_(sync=True, **kwargs):
  if sync:
    return kf_get_agents.sync(client=kfclient,**kwargs)

def post_agents_disapprove_(sync=True, **kwargs):
  if sync:
    return kf_post_agents_disapprove.sync(client=kfclient,**kwargs)

def post_agents_approve_(sync=True, **kwargs):
  if sync:
    return kf_post_agents_approve.sync(client=kfclient,**kwargs)

def post_agents_id_reset_(sync=True, **kwargs):
  if sync:
    return kf_post_agents_id_reset.sync(client=kfclient,**kwargs)

def post_agents_set_auth_certificate_reenrollment_(sync=True, **kwargs):
  if sync:
    return kf_post_agents_set_auth_certificate_reenrollment.sync(client=kfclient,**kwargs)

def get_agents_id_(sync=True, **kwargs):
  if sync:
    return kf_get_agents_id.sync(client=kfclient,**kwargs)

def post_agents_id_fetch_logs_(sync=True, **kwargs):
  if sync:
    return kf_post_agents_id_fetch_logs.sync(client=kfclient,**kwargs)

def post_csr_generation_generate_(sync=True, **kwargs):
  if sync:
    return kf_post_csr_generation_generate.sync(client=kfclient,**kwargs)

def get_csr_generation_pending_id_(sync=True, **kwargs):
  if sync:
    return kf_get_csr_generation_pending_id.sync(client=kfclient,**kwargs)

def get_csr_generation_pending_(sync=True, **kwargs):
  if sync:
    return kf_get_csr_generation_pending.sync(client=kfclient,**kwargs)

def delete_csr_generation_pending_(sync=True, **kwargs):
  if sync:
    return kf_delete_csr_generation_pending.sync(client=kfclient,**kwargs)

def delete_csr_generation_pending_id_(sync=True, **kwargs):
  if sync:
    return kf_delete_csr_generation_pending_id.sync(client=kfclient,**kwargs)

def get_workflow_instances_my_(sync=True, **kwargs):
  if sync:
    return kf_get_workflow_instances_my.sync(client=kfclient,**kwargs)

def get_workflow_instances_(sync=True, **kwargs):
  if sync:
    return kf_get_workflow_instances.sync(client=kfclient,**kwargs)

def get_workflow_instances_instance_id_(sync=True, **kwargs):
  if sync:
    return kf_get_workflow_instances_instance_id.sync(client=kfclient,**kwargs)

def post_workflow_instances_instance_id_restart_(sync=True, **kwargs):
  if sync:
    return kf_post_workflow_instances_instance_id_restart.sync(client=kfclient,**kwargs)

def post_workflow_instances_instance_id_signals_(sync=True, **kwargs):
  if sync:
    return kf_post_workflow_instances_instance_id_signals.sync(client=kfclient,**kwargs)

def delete_workflow_instances_instance_id_(sync=True, **kwargs):
  if sync:
    return kf_delete_workflow_instances_instance_id.sync(client=kfclient,**kwargs)

def get_workflow_instances_assigned_to_me_(sync=True, **kwargs):
  if sync:
    return kf_get_workflow_instances_assigned_to_me.sync(client=kfclient,**kwargs)

def post_workflow_instances_instance_id_stop_(sync=True, **kwargs):
  if sync:
    return kf_post_workflow_instances_instance_id_stop.sync(client=kfclient,**kwargs)

def get_pam_providers_id_(sync=True, **kwargs):
  if sync:
    return kf_get_pam_providers_id.sync(client=kfclient,**kwargs)

def delete_pam_providers_id_(sync=True, **kwargs):
  if sync:
    return kf_delete_pam_providers_id.sync(client=kfclient,**kwargs)

def post_pam_providers_types_(sync=True, **kwargs):
  if sync:
    return kf_post_pam_providers_types.sync(client=kfclient,**kwargs)

def get_pam_providers_(sync=True, **kwargs):
  if sync:
    return kf_get_pam_providers.sync(client=kfclient,**kwargs)

def put_pam_providers_(sync=True, **kwargs):
  if sync:
    return kf_put_pam_providers.sync(client=kfclient,**kwargs)

def get_pam_providers_types_(sync=True, **kwargs):
  if sync:
    return kf_get_pam_providers_types.sync(client=kfclient,**kwargs)

def post_pam_providers_(sync=True, **kwargs):
  if sync:
    return kf_post_pam_providers.sync(client=kfclient,**kwargs)

def get_permissions_(sync=True, **kwargs):
  if sync:
    return kf_get_permissions.sync(client=kfclient,**kwargs)

def get_audit_id_validate_(sync=True, **kwargs):
  if sync:
    return kf_get_audit_id_validate.sync(client=kfclient,**kwargs)

def get_audit_download_(sync=True, **kwargs):
  if sync:
    return kf_get_audit_download.sync(client=kfclient,**kwargs)

def get_audit_(sync=True, **kwargs):
  if sync:
    return kf_get_audit.sync(client=kfclient,**kwargs)

def get_audit_related_entities_(sync=True, **kwargs):
  if sync:
    return kf_get_audit_related_entities.sync(client=kfclient,**kwargs)

def get_audit_id_(sync=True, **kwargs):
  if sync:
    return kf_get_audit_id.sync(client=kfclient,**kwargs)

def delete_workflow_definitions_definition_id_(sync=True, **kwargs):
  if sync:
    return kf_delete_workflow_definitions_definition_id.sync(client=kfclient,**kwargs)

def get_workflow_definitions_steps_(sync=True, **kwargs):
  if sync:
    return kf_get_workflow_definitions_steps.sync(client=kfclient,**kwargs)

def get_workflow_definitions_steps_extension_name_(sync=True, **kwargs):
  if sync:
    return kf_get_workflow_definitions_steps_extension_name.sync(client=kfclient,**kwargs)

def post_workflow_definitions_definition_id_publish_(sync=True, **kwargs):
  if sync:
    return kf_post_workflow_definitions_definition_id_publish.sync(client=kfclient,**kwargs)

def get_workflow_definitions_(sync=True, **kwargs):
  if sync:
    return kf_get_workflow_definitions.sync(client=kfclient,**kwargs)

def post_workflow_definitions_(sync=True, **kwargs):
  if sync:
    return kf_post_workflow_definitions.sync(client=kfclient,**kwargs)

def get_workflow_definitions_definition_id_(sync=True, **kwargs):
  if sync:
    return kf_get_workflow_definitions_definition_id.sync(client=kfclient,**kwargs)

def put_workflow_definitions_definition_id_(sync=True, **kwargs):
  if sync:
    return kf_put_workflow_definitions_definition_id.sync(client=kfclient,**kwargs)

def put_workflow_definitions_definition_id_steps_(sync=True, **kwargs):
  if sync:
    return kf_put_workflow_definitions_definition_id_steps.sync(client=kfclient,**kwargs)

def get_workflow_definitions_types_(sync=True, **kwargs):
  if sync:
    return kf_get_workflow_definitions_types.sync(client=kfclient,**kwargs)

def put_metadata_fields_(sync=True, **kwargs):
  if sync:
    return kf_put_metadata_fields.sync(client=kfclient,**kwargs)

def delete_metadata_fields_id_(sync=True, **kwargs):
  if sync:
    return kf_delete_metadata_fields_id.sync(client=kfclient,**kwargs)

def get_metadata_fields_id_in_use_(sync=True, **kwargs):
  if sync:
    return kf_get_metadata_fields_id_in_use.sync(client=kfclient,**kwargs)

def get_metadata_fields_(sync=True, **kwargs):
  if sync:
    return kf_get_metadata_fields.sync(client=kfclient,**kwargs)

def get_metadata_fields_id_(sync=True, **kwargs):
  if sync:
    return kf_get_metadata_fields_id.sync(client=kfclient,**kwargs)

def delete_metadata_fields_(sync=True, **kwargs):
  if sync:
    return kf_delete_metadata_fields.sync(client=kfclient,**kwargs)

def get_metadata_fields_name_(sync=True, **kwargs):
  if sync:
    return kf_get_metadata_fields_name.sync(client=kfclient,**kwargs)

def post_metadata_fields_(sync=True, **kwargs):
  if sync:
    return kf_post_metadata_fields.sync(client=kfclient,**kwargs)

def get_identity_providers_(sync=True, **kwargs):
  if sync:
    return kf_get_identity_providers.sync(client=kfclient,**kwargs)

def put_identity_providers_id_(sync=True, **kwargs):
  if sync:
    return kf_put_identity_providers_id.sync(client=kfclient,**kwargs)

def get_identity_providers_id_(sync=True, **kwargs):
  if sync:
    return kf_get_identity_providers_id.sync(client=kfclient,**kwargs)

def get_identity_providers_types_(sync=True, **kwargs):
  if sync:
    return kf_get_identity_providers_types.sync(client=kfclient,**kwargs)

def put_reports_id_schedules(args):
  return normalize(put_reports_id_schedules_(json_body=kf_keyfactor_web_keyfactor_api_models_reports_report_schedules_report_schedule_update_request.KeyfactorWebKeyfactorApiModelsReportsReportSchedulesReportScheduleUpdateRequest.from_dict(args)))

def reports_id_schedules(args):
  return normalize(post_reports_id_schedules_(json_body=kf_keyfactor_web_keyfactor_api_models_reports_report_schedules_report_schedule_creation_request.KeyfactorWebKeyfactorApiModelsReportsReportSchedulesReportScheduleCreationRequest.from_dict(args)))

def reports_custom(args):
  return normalize(post_reports_custom_(json_body=kf_keyfactor_web_keyfactor_api_models_reports_custom_reports_custom_report_creation_request.KeyfactorWebKeyfactorApiModelsReportsCustomReportsCustomReportCreationRequest.from_dict(args)))

def put_reports(args):
  return normalize(put_reports_(json_body=kf_csscms_data_model_models_report_request_model.CSSCMSDataModelModelsReportRequestModel.from_dict(args)))

def put_reports_custom(args):
  return normalize(put_reports_custom_(json_body=kf_keyfactor_web_keyfactor_api_models_reports_custom_reports_custom_report_update_request.KeyfactorWebKeyfactorApiModelsReportsCustomReportsCustomReportUpdateRequest.from_dict(args)))

def ssh_server_groups(args):
  return normalize(post_ssh_server_groups_(json_body=kf_csscms_data_model_models_ssh_server_groups_server_group_creation_request.CSSCMSDataModelModelsSSHServerGroupsServerGroupCreationRequest.from_dict(args)))

def put_ssh_server_groups(args):
  return normalize(put_ssh_server_groups_(json_body=kf_csscms_data_model_models_ssh_server_groups_server_group_update_request.CSSCMSDataModelModelsSSHServerGroupsServerGroupUpdateRequest.from_dict(args)))

def ssh_server_groups_access(args):
  return normalize(post_ssh_server_groups_access_(json_body=kf_csscms_data_model_models_ssh_access_server_group_access_request.CSSCMSDataModelModelsSSHAccessServerGroupAccessRequest.from_dict(args)))

def delete_ssh_server_groups_access(args):
  return normalize(delete_ssh_server_groups_access_(json_body=kf_csscms_data_model_models_ssh_access_server_group_access_request.CSSCMSDataModelModelsSSHAccessServerGroupAccessRequest.from_dict(args)))

def enrollment_renew(args):
  return normalize(post_enrollment_renew_(json_body=kf_csscms_data_model_models_enrollment_renewal_request.CSSCMSDataModelModelsEnrollmentRenewalRequest.from_dict(args)))

def enrollment_csr_parse(args):
  return normalize(post_enrollment_csr_parse_(json_body=kf_csscms_data_model_models_csr_contents.CSSCMSDataModelModelsCSRContents.from_dict(args)))

def enrollment_pfx_deploy(args):
  return normalize(post_enrollment_pfx_deploy_(json_body=kf_keyfactor_web_keyfactor_api_models_enrollment_enrollment_management_request.KeyfactorWebKeyfactorApiModelsEnrollmentEnrollmentManagementRequest.from_dict(args)))

def enrollment_pfx_replace(args):
  return normalize(post_enrollment_pfx_replace_(json_body=kf_csscms_data_model_models_enrollment_existing_enrollment_management_request.CSSCMSDataModelModelsEnrollmentExistingEnrollmentManagementRequest.from_dict(args)))

def enrollment_csr(args):
  return normalize(post_enrollment_csr_(json_body=kf_csscms_data_model_models_enrollment_csr_enrollment_request.CSSCMSDataModelModelsEnrollmentCSREnrollmentRequest.from_dict(args)))

def enrollment_pfx(args):
  return normalize(post_enrollment_pfx_(json_body=kf_csscms_data_model_models_enrollment_pfx_enrollment_request.CSSCMSDataModelModelsEnrollmentPFXEnrollmentRequest.from_dict(args)))

def put_certificate_store_containers(args):
  return normalize(put_certificate_store_containers_(json_body=kf_csscms_data_model_models_cert_store_container_request.CSSCMSDataModelModelsCertStoreContainerRequest.from_dict(args)))

def certificate_store_containers(args):
  return normalize(post_certificate_store_containers_(json_body=kf_csscms_data_model_models_cert_store_container_request.CSSCMSDataModelModelsCertStoreContainerRequest.from_dict(args)))

def job_types_custom(args):
  return normalize(post_job_types_custom_(json_body=kf_csscms_data_model_models_orchestrator_jobs_job_type_create_request.CSSCMSDataModelModelsOrchestratorJobsJobTypeCreateRequest.from_dict(args)))

def put_job_types_custom(args):
  return normalize(put_job_types_custom_(json_body=kf_csscms_data_model_models_orchestrator_jobs_job_type_update_request.CSSCMSDataModelModelsOrchestratorJobsJobTypeUpdateRequest.from_dict(args)))

def put_ssh_service_accounts(args):
  return normalize(put_ssh_service_accounts_(json_body=kf_csscms_data_model_models_ssh_service_accounts_service_account_update_request.CSSCMSDataModelModelsSSHServiceAccountsServiceAccountUpdateRequest.from_dict(args)))

def ssh_service_accounts(args):
  return normalize(post_ssh_service_accounts_(json_body=kf_csscms_data_model_models_ssh_service_accounts_service_account_creation_request.CSSCMSDataModelModelsSSHServiceAccountsServiceAccountCreationRequest.from_dict(args)))

def ssh_service_accounts_rotate_id(args):
  return normalize(post_ssh_service_accounts_rotate_id_(json_body=kf_csscms_data_model_models_ssh_keys_key_generation_request.CSSCMSDataModelModelsSSHKeysKeyGenerationRequest.from_dict(args)))

def put_event_handler_registration_id(args):
  return normalize(put_event_handler_registration_id_(json_body=kf_keyfactor_web_keyfactor_api_models_event_handler_registration_event_handler_registration_update_request.KeyfactorWebKeyfactorApiModelsEventHandlerRegistrationEventHandlerRegistrationUpdateRequest.from_dict(args)))

def event_handler_registration(args):
  return normalize(post_event_handler_registration_(json_body=kf_keyfactor_web_keyfactor_api_models_event_handler_registration_event_handler_registration_create_request.KeyfactorWebKeyfactorApiModelsEventHandlerRegistrationEventHandlerRegistrationCreateRequest.from_dict(args)))

def scheduling(args):
  return normalize(post_scheduling_(json_body=kf_keyfactor_web_keyfactor_api_models_scheduling_scheduled_task_request.KeyfactorWebKeyfactorApiModelsSchedulingScheduledTaskRequest.from_dict(args)))

def put_app_setting_id_set(args):
  return normalize(put_app_setting_id_set_(json_body=kf_keyfactor_web_keyfactor_api_models_app_settings_app_setting_update_request.KeyfactorWebKeyfactorApiModelsAppSettingsAppSettingUpdateRequest.from_dict(args)))

def put_app_setting_name_set(args):
  return normalize(put_app_setting_name_set_(json_body=kf_keyfactor_web_keyfactor_api_models_app_settings_app_setting_update_request.KeyfactorWebKeyfactorApiModelsAppSettingsAppSettingUpdateRequest.from_dict(args)))

def delete_ssh_servers_access(args):
  return normalize(delete_ssh_servers_access_(json_body=kf_csscms_data_model_models_ssh_access_server_access_request.CSSCMSDataModelModelsSSHAccessServerAccessRequest.from_dict(args)))

def ssh_servers_access(args):
  return normalize(post_ssh_servers_access_(json_body=kf_csscms_data_model_models_ssh_access_server_access_request.CSSCMSDataModelModelsSSHAccessServerAccessRequest.from_dict(args)))

def put_ssh_servers(args):
  return normalize(put_ssh_servers_(json_body=kf_csscms_data_model_models_ssh_servers_server_update_request.CSSCMSDataModelModelsSSHServersServerUpdateRequest.from_dict(args)))

def ssh_servers(args):
  return normalize(post_ssh_servers_(json_body=kf_csscms_data_model_models_ssh_servers_server_creation_request.CSSCMSDataModelModelsSSHServersServerCreationRequest.from_dict(args)))

def templates_import(args):
  return normalize(post_templates_import_(json_body=kf_keyfactor_web_keyfactor_api_models_configuration_tenant_configuration_tenant_request.KeyfactorWebKeyfactorApiModelsConfigurationTenantConfigurationTenantRequest.from_dict(args)))

def put_templates(args):
  return normalize(put_templates_(json_body=kf_keyfactor_web_keyfactor_api_models_templates_template_update_request.KeyfactorWebKeyfactorApiModelsTemplatesTemplateUpdateRequest.from_dict(args)))

def put_templates_settings(args):
  return normalize(put_templates_settings_(json_body=kf_keyfactor_web_keyfactor_api_models_templates_global_global_template_settings_request.KeyfactorWebKeyfactorApiModelsTemplatesGlobalGlobalTemplateSettingsRequest.from_dict(args)))

def monitoring_resolve_ocsp(args):
  return normalize(post_monitoring_resolve_ocsp_(json_body=kf_keyfactor_web_keyfactor_api_models_monitoring_ocsp_parameters_request.KeyfactorWebKeyfactorApiModelsMonitoringOCSPParametersRequest.from_dict(args)))

def monitoring_revocation_test(args):
  return normalize(post_monitoring_revocation_test_(json_body=kf_keyfactor_web_keyfactor_api_models_monitoring_revocation_monitoring_alert_test_request.KeyfactorWebKeyfactorApiModelsMonitoringRevocationMonitoringAlertTestRequest.from_dict(args)))

def monitoring_revocation(args):
  return normalize(post_monitoring_revocation_(json_body=kf_keyfactor_web_keyfactor_api_models_monitoring_revocation_monitoring_creation_request.KeyfactorWebKeyfactorApiModelsMonitoringRevocationMonitoringCreationRequest.from_dict(args)))

def put_monitoring_revocation(args):
  return normalize(put_monitoring_revocation_(json_body=kf_keyfactor_web_keyfactor_api_models_monitoring_revocation_monitoring_update_request.KeyfactorWebKeyfactorApiModelsMonitoringRevocationMonitoringUpdateRequest.from_dict(args)))

def monitoring_revocation_test_all(args):
  return normalize(post_monitoring_revocation_test_all_(json_body=kf_keyfactor_web_keyfactor_api_models_monitoring_revocation_monitoring_alert_test_all_request.KeyfactorWebKeyfactorApiModelsMonitoringRevocationMonitoringAlertTestAllRequest.from_dict(args)))

def ssh_users(args):
  return normalize(post_ssh_users_(json_body=kf_csscms_data_model_models_ssh_users_ssh_user_creation_request.CSSCMSDataModelModelsSSHUsersSshUserCreationRequest.from_dict(args)))

def put_ssh_users(args):
  return normalize(put_ssh_users_(json_body=kf_csscms_data_model_models_ssh_users_ssh_user_update_request.CSSCMSDataModelModelsSSHUsersSshUserUpdateRequest.from_dict(args)))

def ssh_users_access(args):
  return normalize(post_ssh_users_access_(json_body=kf_csscms_data_model_models_ssh_users_ssh_user_update_request.CSSCMSDataModelModelsSSHUsersSshUserUpdateRequest.from_dict(args)))

def put_ssl_networks(args):
  return normalize(put_ssl_networks_(json_body=kf_keyfactor_web_keyfactor_api_models_ssl_update_network_request.KeyfactorWebKeyfactorApiModelsSslUpdateNetworkRequest.from_dict(args)))

def ssl_networks(args):
  return normalize(post_ssl_networks_(json_body=kf_keyfactor_web_keyfactor_api_models_ssl_create_network_request.KeyfactorWebKeyfactorApiModelsSslCreateNetworkRequest.from_dict(args)))

def ssl_networks_id_scan(args):
  return normalize(post_ssl_networks_id_scan_(json_body=kf_csscms_data_model_models_ssl_immediate_ssl_scan_request.CSSCMSDataModelModelsSSLImmediateSslScanRequest.from_dict(args)))

def ssl_network_ranges(args):
  return normalize(post_ssl_network_ranges_(json_body=kf_csscms_data_model_models_ssl_network_ranges_request.CSSCMSDataModelModelsSSLNetworkRangesRequest.from_dict(args)))

def put_ssl_network_ranges(args):
  return normalize(put_ssl_network_ranges_(json_body=kf_csscms_data_model_models_ssl_network_ranges_request.CSSCMSDataModelModelsSSLNetworkRangesRequest.from_dict(args)))

def certificates_import(args):
  return normalize(post_certificates_import_(json_body=kf_csscms_data_model_models_certificate_import_request_model.CSSCMSDataModelModelsCertificateImportRequestModel.from_dict(args)))

def certificates_recover(args):
  return normalize(post_certificates_recover_(json_body=kf_keyfactor_web_keyfactor_api_models_certificates_certificate_recovery_request.KeyfactorWebKeyfactorApiModelsCertificatesCertificateRecoveryRequest.from_dict(args)))

def put_certificates_metadata_all(args):
  return normalize(put_certificates_metadata_all_(json_body=kf_csscms_data_model_models_metadata_all_update_request.CSSCMSDataModelModelsMetadataAllUpdateRequest.from_dict(args)))

def certificates_revoke(args):
  return normalize(post_certificates_revoke_(json_body=kf_csscms_data_model_models_revoke_certificate_request.CSSCMSDataModelModelsRevokeCertificateRequest.from_dict(args)))

def certificates_analyze(args):
  return normalize(post_certificates_analyze_(json_body=kf_keyfactor_web_keyfactor_api_models_certificates_analyze_certificate_request.KeyfactorWebKeyfactorApiModelsCertificatesAnalyzeCertificateRequest.from_dict(args)))

def certificates_download(args):
  return normalize(post_certificates_download_(json_body=kf_keyfactor_web_keyfactor_api_models_certificates_certificate_download_request.KeyfactorWebKeyfactorApiModelsCertificatesCertificateDownloadRequest.from_dict(args)))

def put_certificates_metadata(args):
  return normalize(put_certificates_metadata_(json_body=kf_csscms_data_model_models_metadata_update_request.CSSCMSDataModelModelsMetadataUpdateRequest.from_dict(args)))

def workflow_certificates_deny(args):
  return normalize(post_workflow_certificates_deny_(json_body=kf_csscms_data_model_models_workflow_denial_request.CSSCMSDataModelModelsWorkflowDenialRequest.from_dict(args)))

def security_claims(args):
  return normalize(post_security_claims_(json_body=kf_keyfactor_web_keyfactor_api_models_security_role_claim_definitions_role_claim_definition_creation_request.KeyfactorWebKeyfactorApiModelsSecurityRoleClaimDefinitionsRoleClaimDefinitionCreationRequest.from_dict(args)))

def put_security_claims(args):
  return normalize(put_security_claims_(json_body=kf_keyfactor_web_keyfactor_api_models_security_role_claim_definitions_role_claim_definition_update_request.KeyfactorWebKeyfactorApiModelsSecurityRoleClaimDefinitionsRoleClaimDefinitionUpdateRequest.from_dict(args)))

def put_permission_sets(args):
  return normalize(put_permission_sets_(json_body=kf_keyfactor_web_keyfactor_api_models_permission_sets_permission_set_update_request.KeyfactorWebKeyfactorApiModelsPermissionSetsPermissionSetUpdateRequest.from_dict(args)))

def permission_sets(args):
  return normalize(post_permission_sets_(json_body=kf_keyfactor_web_keyfactor_api_models_permission_sets_permission_set_create_request.KeyfactorWebKeyfactorApiModelsPermissionSetsPermissionSetCreateRequest.from_dict(args)))

def orchestrator_jobs_custom(args):
  return normalize(post_orchestrator_jobs_custom_(json_body=kf_csscms_data_model_models_orchestrator_jobs_schedule_job_request.CSSCMSDataModelModelsOrchestratorJobsScheduleJobRequest.from_dict(args)))

def orchestrator_jobs_acknowledge(args):
  return normalize(post_orchestrator_jobs_acknowledge_(json_body=kf_keyfactor_web_keyfactor_api_models_orchestrator_jobs_acknowledge_job_request.KeyfactorWebKeyfactorApiModelsOrchestratorJobsAcknowledgeJobRequest.from_dict(args)))

def orchestrator_jobs_custom_bulk(args):
  return normalize(post_orchestrator_jobs_custom_bulk_(json_body=kf_csscms_data_model_models_orchestrator_jobs_schedule_bulk_job_request.CSSCMSDataModelModelsOrchestratorJobsScheduleBulkJobRequest.from_dict(args)))

def orchestrator_jobs_reschedule(args):
  return normalize(post_orchestrator_jobs_reschedule_(json_body=kf_keyfactor_web_keyfactor_api_models_orchestrator_jobs_reschedule_job_request.KeyfactorWebKeyfactorApiModelsOrchestratorJobsRescheduleJobRequest.from_dict(args)))

def orchestrator_jobs_unschedule(args):
  return normalize(post_orchestrator_jobs_unschedule_(json_body=kf_keyfactor_web_keyfactor_api_models_orchestrator_jobs_unschedule_job_request.KeyfactorWebKeyfactorApiModelsOrchestratorJobsUnscheduleJobRequest.from_dict(args)))

def ssh_logons_access(args):
  return normalize(post_ssh_logons_access_(json_body=kf_csscms_data_model_models_ssh_logons_logon_access_request.CSSCMSDataModelModelsSSHLogonsLogonAccessRequest.from_dict(args)))

def ssh_logons(args):
  return normalize(post_ssh_logons_(json_body=kf_csscms_data_model_models_ssh_logons_logon_creation_request.CSSCMSDataModelModelsSSHLogonsLogonCreationRequest.from_dict(args)))

def put_alerts_pending_schedule(args):
  return normalize(put_alerts_pending_schedule_(json_body=kf_keyfactor_web_keyfactor_api_models_alerts_alert_schedule_alert_schedule_request.KeyfactorWebKeyfactorApiModelsAlertsAlertScheduleAlertScheduleRequest.from_dict(args)))

def alerts_pending_test_all(args):
  return normalize(post_alerts_pending_test_all_(json_body=kf_keyfactor_web_keyfactor_api_models_alerts_pending_pending_alert_test_all_request.KeyfactorWebKeyfactorApiModelsAlertsPendingPendingAlertTestAllRequest.from_dict(args)))

def alerts_pending(args):
  return normalize(post_alerts_pending_(json_body=kf_keyfactor_web_keyfactor_api_models_alerts_pending_pending_alert_creation_request.KeyfactorWebKeyfactorApiModelsAlertsPendingPendingAlertCreationRequest.from_dict(args)))

def put_alerts_pending(args):
  return normalize(put_alerts_pending_(json_body=kf_keyfactor_web_keyfactor_api_models_alerts_pending_pending_alert_update_request.KeyfactorWebKeyfactorApiModelsAlertsPendingPendingAlertUpdateRequest.from_dict(args)))

def alerts_pending_test(args):
  return normalize(post_alerts_pending_test_(json_body=kf_keyfactor_web_keyfactor_api_models_alerts_pending_pending_alert_test_request.KeyfactorWebKeyfactorApiModelsAlertsPendingPendingAlertTestRequest.from_dict(args)))

def agent_pools(args):
  return normalize(post_agent_pools_(json_body=kf_keyfactor_web_keyfactor_api_models_orchestrator_pools_agent_pool_creation_request.KeyfactorWebKeyfactorApiModelsOrchestratorPoolsAgentPoolCreationRequest.from_dict(args)))

def put_agent_pools(args):
  return normalize(put_agent_pools_(json_body=kf_keyfactor_web_keyfactor_api_models_orchestrator_pools_agent_pool_update_request.KeyfactorWebKeyfactorApiModelsOrchestratorPoolsAgentPoolUpdateRequest.from_dict(args)))

def put_mac_enrollment(args):
  return normalize(put_mac_enrollment_(json_body=kf_keyfactor_web_keyfactor_api_models_mac_enrollment_mac_enrollment_api_model.KeyfactorWebKeyfactorApiModelsMacEnrollmentMacEnrollmentAPIModel.from_dict(args)))

def put_alerts_issued(args):
  return normalize(put_alerts_issued_(json_body=kf_keyfactor_web_keyfactor_api_models_alerts_issued_issued_alert_update_request.KeyfactorWebKeyfactorApiModelsAlertsIssuedIssuedAlertUpdateRequest.from_dict(args)))

def put_alerts_issued_schedule(args):
  return normalize(put_alerts_issued_schedule_(json_body=kf_keyfactor_web_keyfactor_api_models_alerts_alert_schedule_alert_schedule_request.KeyfactorWebKeyfactorApiModelsAlertsAlertScheduleAlertScheduleRequest.from_dict(args)))

def alerts_issued(args):
  return normalize(post_alerts_issued_(json_body=kf_keyfactor_web_keyfactor_api_models_alerts_issued_issued_alert_creation_request.KeyfactorWebKeyfactorApiModelsAlertsIssuedIssuedAlertCreationRequest.from_dict(args)))

def put_certificate_collections(args):
  return normalize(put_certificate_collections_(json_body=kf_keyfactor_web_keyfactor_api_models_certificate_collections_certificate_collection_update_request.KeyfactorWebKeyfactorApiModelsCertificateCollectionsCertificateCollectionUpdateRequest.from_dict(args)))

def put_certificate_collections_id_favorite(args):
  return normalize(put_certificate_collections_id_favorite_(json_body=kf_keyfactor_web_keyfactor_api_models_certificate_collections_certificate_collection_favorite_request.KeyfactorWebKeyfactorApiModelsCertificateCollectionsCertificateCollectionFavoriteRequest.from_dict(args)))

def certificate_collections(args):
  return normalize(post_certificate_collections_(json_body=kf_keyfactor_web_keyfactor_api_models_certificate_collections_certificate_collection_create_request.KeyfactorWebKeyfactorApiModelsCertificateCollectionsCertificateCollectionCreateRequest.from_dict(args)))

def certificate_collections_copy(args):
  return normalize(post_certificate_collections_copy_(json_body=kf_keyfactor_web_keyfactor_api_models_certificate_collections_certificate_collection_copy_request.KeyfactorWebKeyfactorApiModelsCertificateCollectionsCertificateCollectionCopyRequest.from_dict(args)))

def put_certificate_store_types(args):
  return normalize(put_certificate_store_types_(json_body=kf_keyfactor_web_keyfactor_api_models_certificate_stores_types_certificate_store_type_update_request.KeyfactorWebKeyfactorApiModelsCertificateStoresTypesCertificateStoreTypeUpdateRequest.from_dict(args)))

def certificate_store_types(args):
  return normalize(post_certificate_store_types_(json_body=kf_keyfactor_web_keyfactor_api_models_certificate_stores_types_certificate_store_type_creation_request.KeyfactorWebKeyfactorApiModelsCertificateStoresTypesCertificateStoreTypeCreationRequest.from_dict(args)))

def put_smtp(args):
  return normalize(put_smtp_(json_body=kf_keyfactor_web_keyfactor_api_models_smtpsmtp_request.KeyfactorWebKeyfactorApiModelsSMTPSMTPRequest.from_dict(args)))

def smtp_test(args):
  return normalize(post_smtp_test_(json_body=kf_keyfactor_web_keyfactor_api_models_smtpsmtp_test_request.KeyfactorWebKeyfactorApiModelsSMTPSMTPTestRequest.from_dict(args)))

def alerts_denied(args):
  return normalize(post_alerts_denied_(json_body=kf_keyfactor_web_keyfactor_api_models_alerts_denied_denied_alert_creation_request.KeyfactorWebKeyfactorApiModelsAlertsDeniedDeniedAlertCreationRequest.from_dict(args)))

def put_alerts_denied(args):
  return normalize(put_alerts_denied_(json_body=kf_keyfactor_web_keyfactor_api_models_alerts_denied_denied_alert_update_request.KeyfactorWebKeyfactorApiModelsAlertsDeniedDeniedAlertUpdateRequest.from_dict(args)))

def put_alerts_key_rotation_schedule(args):
  return normalize(put_alerts_key_rotation_schedule_(json_body=kf_keyfactor_web_keyfactor_api_models_alerts_alert_schedule_alert_schedule_request.KeyfactorWebKeyfactorApiModelsAlertsAlertScheduleAlertScheduleRequest.from_dict(args)))

def alerts_key_rotation_test_all(args):
  return normalize(post_alerts_key_rotation_test_all_(json_body=kf_keyfactor_web_keyfactor_api_models_alerts_key_rotation_key_rotation_alert_test_all_request.KeyfactorWebKeyfactorApiModelsAlertsKeyRotationKeyRotationAlertTestAllRequest.from_dict(args)))

def alerts_key_rotation_test(args):
  return normalize(post_alerts_key_rotation_test_(json_body=kf_keyfactor_web_keyfactor_api_models_alerts_key_rotation_key_rotation_alert_test_request.KeyfactorWebKeyfactorApiModelsAlertsKeyRotationKeyRotationAlertTestRequest.from_dict(args)))

def put_alerts_key_rotation(args):
  return normalize(put_alerts_key_rotation_(json_body=kf_keyfactor_web_keyfactor_api_models_alerts_key_rotation_key_rotation_alert_update_request.KeyfactorWebKeyfactorApiModelsAlertsKeyRotationKeyRotationAlertUpdateRequest.from_dict(args)))

def alerts_key_rotation(args):
  return normalize(post_alerts_key_rotation_(json_body=kf_keyfactor_web_keyfactor_api_models_alerts_key_rotation_key_rotation_alert_creation_request.KeyfactorWebKeyfactorApiModelsAlertsKeyRotationKeyRotationAlertCreationRequest.from_dict(args)))

def put_extensions_scripts(args):
  return normalize(put_extensions_scripts_(json_body=kf_keyfactor_web_keyfactor_api_models_scripts_scripts_update_request.KeyfactorWebKeyfactorApiModelsScriptsScriptsUpdateRequest.from_dict(args)))

def extensions_scripts(args):
  return normalize(post_extensions_scripts_(json_body=kf_keyfactor_web_keyfactor_api_models_scripts_script_create_request.KeyfactorWebKeyfactorApiModelsScriptsScriptCreateRequest.from_dict(args)))

def put_ssh_keys_my_key(args):
  return normalize(put_ssh_keys_my_key_(json_body=kf_csscms_data_model_models_ssh_keys_key_update_request.CSSCMSDataModelModelsSSHKeysKeyUpdateRequest.from_dict(args)))

def ssh_keys_my_key(args):
  return normalize(post_ssh_keys_my_key_(json_body=kf_csscms_data_model_models_ssh_keys_key_generation_request.CSSCMSDataModelModelsSSHKeysKeyGenerationRequest.from_dict(args)))

def put_alerts_expiration(args):
  return normalize(put_alerts_expiration_(json_body=kf_keyfactor_web_keyfactor_api_models_alerts_expiration_expiration_alert_update_request.KeyfactorWebKeyfactorApiModelsAlertsExpirationExpirationAlertUpdateRequest.from_dict(args)))

def alerts_expiration_test(args):
  return normalize(post_alerts_expiration_test_(json_body=kf_keyfactor_web_keyfactor_api_models_alerts_expiration_expiration_alert_test_request.KeyfactorWebKeyfactorApiModelsAlertsExpirationExpirationAlertTestRequest.from_dict(args)))

def alerts_expiration_test_all(args):
  return normalize(post_alerts_expiration_test_all_(json_body=kf_keyfactor_web_keyfactor_api_models_alerts_expiration_expiration_alert_test_all_request.KeyfactorWebKeyfactorApiModelsAlertsExpirationExpirationAlertTestAllRequest.from_dict(args)))

def put_alerts_expiration_schedule(args):
  return normalize(put_alerts_expiration_schedule_(json_body=kf_keyfactor_web_keyfactor_api_models_alerts_alert_schedule_alert_schedule_request.KeyfactorWebKeyfactorApiModelsAlertsAlertScheduleAlertScheduleRequest.from_dict(args)))

def alerts_expiration(args):
  return normalize(post_alerts_expiration_(json_body=kf_keyfactor_web_keyfactor_api_models_alerts_expiration_expiration_alert_creation_request.KeyfactorWebKeyfactorApiModelsAlertsExpirationExpirationAlertCreationRequest.from_dict(args)))

def put_security_roles(args):
  return normalize(put_security_roles_(json_body=kf_keyfactor_web_keyfactor_api_models_security_legacy_security_roles_security_role_update_request.KeyfactorWebKeyfactorApiModelsSecurityLegacySecurityRolesSecurityRoleUpdateRequest.from_dict(args)))

def security_roles(args):
  return normalize(post_security_roles_(json_body=kf_keyfactor_web_keyfactor_api_models_security_legacy_security_roles_security_role_creation_request.KeyfactorWebKeyfactorApiModelsSecurityLegacySecurityRolesSecurityRoleCreationRequest.from_dict(args)))

def security_roles_id_copy(args):
  return normalize(post_security_roles_id_copy_(json_body=kf_keyfactor_web_keyfactor_api_models_security_legacy_security_roles_security_role_copy_request.KeyfactorWebKeyfactorApiModelsSecurityLegacySecurityRolesSecurityRoleCopyRequest.from_dict(args)))

def put_security_roles_id_identities(args):
  return normalize(put_security_roles_id_identities_(json_body=kf_keyfactor_web_keyfactor_api_models_security_legacy_security_roles_role_identities_request.KeyfactorWebKeyfactorApiModelsSecurityLegacySecurityRolesRoleIdentitiesRequest.from_dict(args)))

def certificate_authority_alert_recipients_ca_threshold_recipients(args):
  return normalize(post_certificate_authority_alert_recipients_ca_threshold_recipients_(json_body=kf_keyfactor_web_keyfactor_api_models_certificate_authorities_ca_alert_recipient_create_request.KeyfactorWebKeyfactorApiModelsCertificateAuthoritiesCAAlertRecipientCreateRequest.from_dict(args)))

def certificate_authority(args):
  return normalize(post_certificate_authority_(json_body=kf_keyfactor_web_keyfactor_api_models_certificate_authorities_certificate_authority_request.KeyfactorWebKeyfactorApiModelsCertificateAuthoritiesCertificateAuthorityRequest.from_dict(args)))

def certificate_authority_test(args):
  return normalize(post_certificate_authority_test_(json_body=kf_csscms_data_model_models_certificate_authorities_certificate_authority_test_request.CSSCMSDataModelModelsCertificateAuthoritiesCertificateAuthorityTestRequest.from_dict(args)))

def put_certificate_authority_alert_recipients_ca_health_recipients_id(args):
  return normalize(put_certificate_authority_alert_recipients_ca_health_recipients_id_(json_body=kf_keyfactor_web_keyfactor_api_models_certificate_authorities_ca_alert_recipient_update_request.KeyfactorWebKeyfactorApiModelsCertificateAuthoritiesCAAlertRecipientUpdateRequest.from_dict(args)))

def certificate_authority_alert_recipients_ca_health_recipients(args):
  return normalize(post_certificate_authority_alert_recipients_ca_health_recipients_(json_body=kf_keyfactor_web_keyfactor_api_models_certificate_authorities_ca_alert_recipient_create_request.KeyfactorWebKeyfactorApiModelsCertificateAuthoritiesCAAlertRecipientCreateRequest.from_dict(args)))

def put_certificate_authority_alert_recipients_ca_threshold_recipients_id(args):
  return normalize(put_certificate_authority_alert_recipients_ca_threshold_recipients_id_(json_body=kf_keyfactor_web_keyfactor_api_models_certificate_authorities_ca_alert_recipient_update_request.KeyfactorWebKeyfactorApiModelsCertificateAuthoritiesCAAlertRecipientUpdateRequest.from_dict(args)))

def certificate_authority_publish_crl(args):
  return normalize(post_certificate_authority_publish_crl_(json_body=kf_csscms_data_model_models_crl_request_model.CSSCMSDataModelModelsCRLRequestModel.from_dict(args)))

def put_certificate_authority(args):
  return normalize(put_certificate_authority_(json_body=kf_keyfactor_web_keyfactor_api_models_certificate_authorities_certificate_authority_request.KeyfactorWebKeyfactorApiModelsCertificateAuthoritiesCertificateAuthorityRequest.from_dict(args)))

def security_identities(args):
  return normalize(post_security_identities_(json_body=kf_keyfactor_web_keyfactor_api_models_security_security_identities_security_identity_request.KeyfactorWebKeyfactorApiModelsSecuritySecurityIdentitiesSecurityIdentityRequest.from_dict(args)))

def certificate_stores_schedule(args):
  return normalize(post_certificate_stores_schedule_(json_body=kf_csscms_data_model_models_cert_stores_schedule.CSSCMSDataModelModelsCertStoresSchedule.from_dict(args)))

def put_certificate_stores(args):
  return normalize(put_certificate_stores_(json_body=kf_csscms_data_model_models_certificate_stores_certificate_store_update_request.CSSCMSDataModelModelsCertificateStoresCertificateStoreUpdateRequest.from_dict(args)))

def certificate_stores_certificates_remove(args):
  return normalize(post_certificate_stores_certificates_remove_(json_body=kf_keyfactor_web_keyfactor_api_models_certificate_stores_remove_certificate_request.KeyfactorWebKeyfactorApiModelsCertificateStoresRemoveCertificateRequest.from_dict(args)))

def certificate_stores_reenrollment(args):
  return normalize(post_certificate_stores_reenrollment_(json_body=kf_keyfactor_web_keyfactor_api_models_certificate_stores_reenrollment_request.KeyfactorWebKeyfactorApiModelsCertificateStoresReenrollmentRequest.from_dict(args)))

def certificate_stores_certificates_add(args):
  return normalize(post_certificate_stores_certificates_add_(json_body=kf_keyfactor_web_keyfactor_api_models_certificate_stores_add_certificate_request.KeyfactorWebKeyfactorApiModelsCertificateStoresAddCertificateRequest.from_dict(args)))

def put_certificate_stores_discovery_job(args):
  return normalize(put_certificate_stores_discovery_job_(json_body=kf_csscms_data_model_models_discovery_job_request.CSSCMSDataModelModelsDiscoveryJobRequest.from_dict(args)))

def put_certificate_stores_password(args):
  return normalize(put_certificate_stores_password_(json_body=kf_csscms_data_model_models_cert_store_new_password_request.CSSCMSDataModelModelsCertStoreNewPasswordRequest.from_dict(args)))

def put_certificate_stores_server(args):
  return normalize(put_certificate_stores_server_(json_body=kf_csscms_data_model_models_certificate_store_update_server_request.CSSCMSDataModelModelsCertificateStoreUpdateServerRequest.from_dict(args)))

def certificate_stores(args):
  return normalize(post_certificate_stores_(json_body=kf_csscms_data_model_models_certificate_stores_certificate_store_create_request.CSSCMSDataModelModelsCertificateStoresCertificateStoreCreateRequest.from_dict(args)))

def certificate_stores_server(args):
  return normalize(post_certificate_stores_server_(json_body=kf_csscms_data_model_models_certificate_store_create_server_request.CSSCMSDataModelModelsCertificateStoreCreateServerRequest.from_dict(args)))

def put_certificate_stores_assign_container(args):
  return normalize(put_certificate_stores_assign_container_(json_body=kf_csscms_data_model_models_container_assignment.CSSCMSDataModelModelsContainerAssignment.from_dict(args)))

def agents_set_auth_certificate_reenrollment(args):
  return normalize(post_agents_set_auth_certificate_reenrollment_(json_body=kf_keyfactor_web_keyfactor_api_models_orchestrators_update_orchestrator_auth_certificate_reenrollment_request.KeyfactorWebKeyfactorApiModelsOrchestratorsUpdateOrchestratorAuthCertificateReenrollmentRequest.from_dict(args)))

def csr_generation_generate(args):
  return normalize(post_csr_generation_generate_(json_body=kf_csscms_data_model_models_enrollment_csr_generation_request.CSSCMSDataModelModelsEnrollmentCSRGenerationRequest.from_dict(args)))

def workflow_instances_instance_id_signals(args):
  return normalize(post_workflow_instances_instance_id_signals_(json_body=kf_keyfactor_web_keyfactor_api_models_workflows_signal_request.KeyfactorWebKeyfactorApiModelsWorkflowsSignalRequest.from_dict(args)))

def pam_providers_types(args):
  return normalize(post_pam_providers_types_(json_body=kf_keyfactor_web_keyfactor_api_models_pam_provider_type_create_request.KeyfactorWebKeyfactorApiModelsPAMProviderTypeCreateRequest.from_dict(args)))

def put_pam_providers(args):
  return normalize(put_pam_providers_(json_body=kf_keyfactor_web_keyfactor_api_models_pam_provider_update_request_legacy.KeyfactorWebKeyfactorApiModelsPAMProviderUpdateRequestLegacy.from_dict(args)))

def pam_providers(args):
  return normalize(post_pam_providers_(json_body=kf_keyfactor_web_keyfactor_api_models_pam_provider_create_request.KeyfactorWebKeyfactorApiModelsPAMProviderCreateRequest.from_dict(args)))

def workflow_definitions(args):
  return normalize(post_workflow_definitions_(json_body=kf_keyfactor_web_keyfactor_api_models_workflows_definition_create_request.KeyfactorWebKeyfactorApiModelsWorkflowsDefinitionCreateRequest.from_dict(args)))

def put_workflow_definitions_definition_id(args):
  return normalize(put_workflow_definitions_definition_id_(json_body=kf_keyfactor_web_keyfactor_api_models_workflows_definition_update_request.KeyfactorWebKeyfactorApiModelsWorkflowsDefinitionUpdateRequest.from_dict(args)))

def put_metadata_fields(args):
  return normalize(put_metadata_fields_(json_body=kf_keyfactor_web_keyfactor_api_models_metadata_field_metadata_field_update_request.KeyfactorWebKeyfactorApiModelsMetadataFieldMetadataFieldUpdateRequest.from_dict(args)))

def metadata_fields(args):
  return normalize(post_metadata_fields_(json_body=kf_keyfactor_web_keyfactor_api_models_metadata_field_metadata_field_create_request.KeyfactorWebKeyfactorApiModelsMetadataFieldMetadataFieldCreateRequest.from_dict(args)))

def put_identity_providers_id(args):
  return normalize(put_identity_providers_id_(json_body=kf_keyfactor_web_keyfactor_api_models_identity_provider_identity_provider_update_request.KeyfactorWebKeyfactorApiModelsIdentityProviderIdentityProviderUpdateRequest.from_dict(args)))
